/*
 * Lexico.java
 *
 * Created on 27 de septiembre de 2007, 18:30
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package pSintactico;

import java.util.ArrayList;

/**
 *
 * @author globus
 */
public class Lexico {
    
    /** Creates a new instance of Lexico */
    String cadena_a_analizar;
    private String[] fragmentos;
    private int palabra_actual = 0;
    private int indice_actual = 0;
    private int max_indice;
    
    int posicion_cadena_no_reconocida = -1;
    
    String aux = null;
    public ComponenteLexico actual;
    
    public ArrayList errores;
    public Lexico(String cadena) {
        this.cadena_a_analizar = cadena;;
        fragmentos = cadena_a_analizar.split(" ");
        
        this.max_indice = cadena_a_analizar.length();
        this.indice_actual = 0;
        
        this.errores = new ArrayList();
        
    }
    
    public int getActualIndex() {
        return this.indice_actual;
    }
    
    
    public String avanzaHastaSiguiente() {
        
        this.indice_actual++;
        while (this.indice_actual < this.max_indice && this.cadena_a_analizar.charAt(this.indice_actual) == ' ') {
            this.indice_actual++;
        }
        
        this.aux =  this.cadena_a_analizar.substring(this.indice_actual);
        return this.aux;
    }
    
    public ComponenteLexico Siguiente()  {
        
        
        if (this.indice_actual == (this.max_indice)   )
            return null;
        
        if (aux == null)
            aux = this.cadena_a_analizar;
        
        
        
        if (aux.compareTo("") == 0) {
            errores.add(new String("Keyboard entry not recognized! "+this.posicion_cadena_no_reconocida));
            return new Nulo();
        }
        
        ComponenteLexico lex = null;
        
        while(true) {
            
            if (aux.compareTo("") == 0) {
                errores.add(new String("Keyboard entry not recognized! "+this.posicion_cadena_no_reconocida));
                this.actual =  new Nulo();
                return this.actual;
            }
            
            
            if (aux.startsWith("(") == true) {
                lex = new AbreParentesis();
                this.avanzaHastaSiguiente();
                
                break;
            }
            
            
            else if (aux.startsWith(")") == true) {
                lex = new CierraParentesis();
                this.avanzaHastaSiguiente();
                
                break;
            }
            
            
            else if (aux.matches("\"[^ ]*\"[^$]*") == true) {
                lex = new Cadena("");
                int i = 1;
                this.indice_actual++;
                while(aux.charAt(i) != '"' && i <= aux.length())
                {
                    this.indice_actual++;
                    i++;
                }
             
                
                if (aux.substring(i). startsWith("\"") == false) {
                    errores.add(new String("Quotes must be closed"));
                    

                    break;
                }
                break;
                
            } else if (aux.startsWith("HOSTNAME") == true||
                    aux.startsWith("ARCH") == true||
                    aux.startsWith("OS_NAME") == true||
                    aux.startsWith("OS_VERSION") == true||
                    aux.startsWith("CPU_MODEL") == true||
                    aux.startsWith("CPU_MHZ") == true||
                    aux.startsWith("CPU_FREE") == true||
                    aux.startsWith("CPU_SMP") == true||
                    aux.startsWith("NODECOUNT") == true||
                    aux.startsWith("SIZE_MEM_MB") == true||
                    aux.startsWith("FREE_MEM_MB") == true||
                    aux.startsWith("SIZE_DISK_MB") == true||
                    aux.startsWith("FREE_DISK_MB") == true||
                    aux.startsWith("LRMS_NAME") == true||
                    aux.startsWith("LRMS_TYPE") == true||
                    aux.startsWith("QUEUE_NAME") == true||
                    aux.startsWith("QUEUE_NODECOUNT") == true||
                    aux.startsWith("QUEUE_MAXTIME") == true||
                    aux.startsWith("QUEUE_MAXCPUTIME") == true||
                    aux.startsWith("QUEUE_MAXCOUNT") == true||
                    aux.startsWith("QUEUE_MAXRUNNINGJOBS") == true||
                    aux.startsWith("QUEUE_DISPATCHTYPE") == true||
                    aux.startsWith("QUEUE_PRIORITY") == true||
                    aux.startsWith("QUEUE_STATUS") == true) {
                
                
                lex = new Variable(aux);
                
                if (aux.startsWith("HOSTNAME") == true)
                    this.indice_actual += 8;
                else if (aux.startsWith("ARCH") == true)
                    this.indice_actual += 4;
                else if (aux.startsWith("OS_NAME") == true)
                    this.indice_actual += 7;
                else if (aux.startsWith("OS_VERSION") == true)
                    this.indice_actual += 10;
                else if (aux.startsWith("CPU_MODEL") == true)
                    this.indice_actual += 9;
                else if (aux.startsWith("CPU_MHZ") == true)
                    this.indice_actual += 7;
                else if (aux.startsWith("CPU_FREE")  == true)
                    this.indice_actual += 8;
                else if (aux.startsWith("CPU_SMP") == true)
                    this.indice_actual += 7;
                else if (aux.startsWith("NODECOUNT") == true)
                    this.indice_actual += 9;
                else if (aux.startsWith("SIZE_MEM_MB") == true)
                    this.indice_actual += 11;
                else if (aux.startsWith("FREE_MEM_MB") == true)
                    this.indice_actual += 11;
                else if (aux.startsWith("SIZE_DISK_MB") == true)
                    this.indice_actual += 12;
                else if (aux.startsWith("FREE_DISK_MB") == true)
                    this.indice_actual += 12;
                else if (aux.startsWith("LRMS_NAME") == true)
                    this.indice_actual += 9;
                else if (aux.startsWith("LRMS_TYPE") == true)
                    this.indice_actual += 9;
                else if (aux.startsWith("QUEUE_NAME") == true)
                    this.indice_actual += 10;
                else if (aux.startsWith("QUEUE_NODECOUNT") == true)
                    this.indice_actual += 15;
                else if (aux.startsWith("QUEUE_MAXTIME") == true)
                    this.indice_actual += 13;
                else if (aux.startsWith("QUEUE_MAXCPUTIME") == true)
                    this.indice_actual += 16;
                else if (aux.startsWith("QUEUE_MAXCOUNT") == true)
                    this.indice_actual += 14;
                else if (aux.startsWith("QUEUE_MAXRUNNINGJOBS") == true)
                    this.indice_actual += 20;
                else if (aux.startsWith("QUEUE_DISPATCHTYPE") == true)
                    this.indice_actual += 18;
                else if (aux.startsWith("QUEUE_PRIORITY") == true)
                    this.indice_actual += 14;
                else if (aux.startsWith("QUEUE_STATUS") == true)
                    this.indice_actual += 12;
                
                
                break;
                
            }
            
            else if (aux.startsWith("+") == true || aux.startsWith("-") == true) {
                lex = new Operador_aritmetico(aux.substring(0,1));
                this.avanzaHastaSiguiente();
                
                break;
            }
            
            else if (aux.startsWith("*") == true || aux.startsWith("/") == true) {
                lex = new Operador_aritmetico(aux.substring(0,1));
                this.avanzaHastaSiguiente();
                
                break;
            }
            
            else if (aux.startsWith("<") == true || aux.startsWith(">") == true || aux.startsWith("=") == true) {
                lex = new Condicion(aux.substring(0,1));
                this.avanzaHastaSiguiente();
                
                break;
            } else if (aux.startsWith("&") == true || aux.startsWith("|") == true || aux.startsWith("!") == true) {
                lex = new Operador_logico(aux.substring(0,1));
                this.avanzaHastaSiguiente();
                
                break;
            } else if (aux.startsWith(";") == true) {
                lex = new PuntoComa();
                this.avanzaHastaSiguiente();
                
                break;
            }
            
            else if (aux.matches("[0-9]+[^$]*") == true) {
                lex = new Entero(aux);
                this.indice_actual++;
                while (this.indice_actual < this.cadena_a_analizar.length() &&
                        (
                        this.cadena_a_analizar.charAt(this.indice_actual) == '0' ||
                        this.cadena_a_analizar.charAt(this.indice_actual) == '1' ||
                        this.cadena_a_analizar.charAt(this.indice_actual) == '2' ||
                        this.cadena_a_analizar.charAt(this.indice_actual) == '3' ||
                        this.cadena_a_analizar.charAt(this.indice_actual) == '4' ||
                        this.cadena_a_analizar.charAt(this.indice_actual) == '5' ||
                        this.cadena_a_analizar.charAt(this.indice_actual) == '6' ||
                        this.cadena_a_analizar.charAt(this.indice_actual) == '7' ||
                        this.cadena_a_analizar.charAt(this.indice_actual) == '8' ||
                        this.cadena_a_analizar.charAt(this.indice_actual) == '9'
                        ))
                    this.indice_actual++;
                
                
                if (this.cadena_a_analizar.length() < this.indice_actual &&
                        this.cadena_a_analizar.charAt(this.indice_actual) == ' ')
                    this.avanzaHastaSiguiente();
                
                break;
            }
            
            
            
            else {
                
                // int a = this.indice_actual++;
                if (this.posicion_cadena_no_reconocida == -1)
                    this.posicion_cadena_no_reconocida = this.indice_actual;
                
                
                
                
                this.avanzaHastaSiguiente();
                continue;
                
                
            }
        }
        
        this.actual = lex;
        
        aux = this.cadena_a_analizar.substring(this.indice_actual);
        
        this.posicion_cadena_no_reconocida = -1;
        return lex;
        
    }
    
}
