/*
 * AddInputFile.java
 *
 * Created on 27 de septiembre de 2007, 15:37
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import com.jscape.inet.sftp.SftpException;
import java.awt.Color;
import java.awt.Frame;
import java.io.File;
import java.net.MalformedURLException;
import java.net.URISyntaxException;
import java.util.Vector;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

/**
 *
 * @author  globus
 */
public class AddInputFile extends java.awt.Dialog {
    
    /** Creates new form AddInputFile */
    
    public boolean aceptar = false;
    public int seleccionado = 1;
    public static int ORIGEN = 1;
    public static int DESTINO = 2;
    
    boolean local  = false;
    
    SecureFTP conexion;
    
    Fichero fichero;
    
    Frame parent;
    
    boolean stream = false;
    
    public AddInputFile(java.awt.Frame parent, boolean modal,String origen, String destino,boolean stream,SecureFTP conexion,boolean local) {
        super(parent, modal);
        initComponents();
        this.parent = parent;
        this.listaVariables.removeAll();
        
        this.local = local;
        if (this.local == true)
        {
            this.label4.setText("Local File System");
            this.label4.setBackground(new Color(0,255,0));
        }
        else {
            this.label4.setText("GridWay Server File System");
            this.label4.setBackground(new Color(255,255,0));
        }
        
        this.conexion = conexion;
        
        this.stream = stream;
        this.listaVariables.add("${JOB_ID}");
        this.listaVariables.add("${ARRAY_ID}");
        this.listaVariables.add("${TASK_ID}");
        this.listaVariables.add("${TOTAL_TASKS}");
        this.listaVariables.add("${ARCH}");
        this.listaVariables.add("${PARAM}");
        
        if (stream == true) {
            this.ficheroOrigenTextField.setEnabled(true);
            this.ficheroDestinoTextField.setEnabled(false);
            this.ficheroDestinoTextField.setVisible(false);
            this.label2.setVisible(false);
        }
        
        else {
            this.ficheroOrigenTextField.setEnabled(true);
            this.ficheroDestinoTextField.setEnabled(true);
        }
        
        
        fichero = null;
        
        if (origen != null && origen.compareTo("") != 0)
            this.ficheroOrigenTextField.setText(origen);
        
        if (destino != null && destino.compareTo("") != 0)
            this.ficheroDestinoTextField.setText(destino);
        try {
            
            
            this.fichero = new Fichero(true,stream,origen,destino,local);
        } catch (URISyntaxException ex) {
            
        };
        
        
    }
    
    public Fichero getFichero() {
        int a = 2;
        try {
            fichero =  new Fichero(true,stream,this.ficheroOrigenTextField.getText(),this.ficheroDestinoTextField.getText(),local);
        } catch (URISyntaxException ex) {
            ex.printStackTrace();
            JOptionPane dialog = new JOptionPane();
            
            JOptionPane.showMessageDialog(this, "Invalid URL!", "Error", JOptionPane.ERROR_MESSAGE);
        }
        
        return fichero;
    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Código Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        label3 = new java.awt.Label();
        listaVariables = new java.awt.List();
        ficheroOrigenTextField = new javax.swing.JTextField();
        label1 = new java.awt.Label();
        label2 = new java.awt.Label();
        ficheroDestinoTextField = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        label4 = new java.awt.Label();

        setAlwaysOnTop(true);
        setResizable(false);
        setTitle("Add Input File");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        label3.setText("Sustitution variables:");

        listaVariables.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                listaVariablesMouseClicked(evt);
            }
        });

        ficheroOrigenTextField.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ficheroOrigenTextFieldMouseClicked(evt);
            }
        });

        label1.setText("Source File:");

        label2.setText("Name at destination:");

        ficheroDestinoTextField.setToolTipText("The destination file must be a clean filename, not absolute path or URL!.\n");
        ficheroDestinoTextField.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ficheroDestinoTextFieldMouseClicked(evt);
            }
        });

        jButton1.setText("Local");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton1jLocalMouseClicked(evt);
            }
        });

        jButton2.setText("Remote");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton2jRemotoMouseClicked(evt);
            }
        });

        jButton4.setText("Cancel");
        jButton4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton4jCancelarMouseClicked(evt);
            }
        });

        jButton3.setText("Accept");
        jButton3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton3jAceptarMouseClicked(evt);
            }
        });

        label4.setAlignment(java.awt.Label.CENTER);
        label4.setBackground(new java.awt.Color(0, 255, 0));
        label4.setEnabled(false);
        label4.setText("Local file system");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(26, 26, 26)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(ficheroOrigenTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 258, Short.MAX_VALUE))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                                .add(67, 67, 67)
                                .add(jButton3)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 120, Short.MAX_VALUE)
                                .add(jButton4))
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                .add(label4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 163, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(ficheroDestinoTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 206, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(15, 15, 15)
                        .add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(listaVariables, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 202, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(15, 15, 15)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jButton1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 82, Short.MAX_VALUE)
                    .add(jButton2))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jButton2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton1)
                        .add(35, 35, 35))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(30, 30, 30)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(listaVariables, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 103, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 28, Short.MAX_VALUE)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(ficheroOrigenTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(43, 43, 43)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(ficheroDestinoTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(label4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton4)
                    .add(jButton3))
                .addContainerGap())
        );
        add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void jButton3jAceptarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton3jAceptarMouseClicked
        
        int a = 2;
        try {
            
            fichero = new Fichero(true,stream,this.ficheroOrigenTextField.getText(),this.ficheroDestinoTextField.getText(),local);
            
            if (local == true &&
                    (fichero.toString().contains("${JOB_ID}") ||
                    fichero.toString().contains("${ARRAY_ID}") ||
                    fichero.toString().contains("${TASK_ID}")||
                    fichero.toString().contains("${TOTAL_TASKS}")||
                    fichero.toString().contains("${ARCH}")||
                    fichero.toString().contains("${PARAM}")
                    
                    )
                    
                    ) {
                JOptionPane.showMessageDialog(this, "If a local file is specified, you cannot include sustitution+" +
                        "variables in its definition", "Error", JOptionPane.ERROR_MESSAGE);
                
                return;
                
            }
            
        } catch (URISyntaxException ex) {
            //    ex.printStackTrace();
            
            JOptionPane dialog = new JOptionPane();
            
            JOptionPane.showMessageDialog(this, "Invalid URL!", "Error", JOptionPane.ERROR_MESSAGE);
            
            return;
        }
        
        this.aceptar = true;
        this.setVisible(false);
    }//GEN-LAST:event_jButton3jAceptarMouseClicked
    
    private void jButton4jCancelarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton4jCancelarMouseClicked
        this.aceptar = false;
        this.setVisible(false);
    }//GEN-LAST:event_jButton4jCancelarMouseClicked
    
    private void jButton2jRemotoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton2jRemotoMouseClicked
        try {
            
            AddRemoteFileDialog remotefiledialog;
            
            if (this.ficheroOrigenTextField.getText().compareTo("") != 0)
                remotefiledialog = new AddRemoteFileDialog(parent, true, stream, new Fichero(true, stream, this.ficheroOrigenTextField.getText(), this.ficheroDestinoTextField.getText(),true));
            else
                remotefiledialog = new AddRemoteFileDialog(parent, true, stream,null);
            remotefiledialog.setVisible(true);
            
            if (remotefiledialog.aceptar == true) {
                fichero = remotefiledialog.getFichero();
                this.ficheroOrigenTextField.setText(fichero.getSource());
                this.ficheroDestinoTextField.setText(fichero.getDest());
                
                this.local = false;
            }
            
        } catch (URISyntaxException ex) {
            ex.printStackTrace();
        }
        
        if (this.local == true)
        {
            this.label4.setText("Local File System");
            this.label4.setBackground(new Color(0,255,0));
        }
        else {
            this.label4.setText("GridWay Server File System");
            this.label4.setBackground(new Color(255,255,0));
        }
    }//GEN-LAST:event_jButton2jRemotoMouseClicked
    
    private void jButton1jLocalMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1jLocalMouseClicked
        
        
        this.local = false;
        RemotoOLocalDialog dialogo_decision = new RemotoOLocalDialog(parent,true);
        dialogo_decision.setVisible(true);
        
        if (dialogo_decision.local == true) { //Selección de ficheros locales
            JFileChooser dialogo_examinar = new JFileChooser();
            
            dialogo_examinar.setCurrentDirectory(new File(System.getProperty("user.dir")));
            
            dialogo_examinar.setDialogTitle("Add File");
            
            int returnVal = dialogo_examinar.showOpenDialog(this);
            
            
            
            dialogo_examinar.setFileSelectionMode(JFileChooser.FILES_ONLY); //Sólo archivos.
            dialogo_examinar.setMultiSelectionEnabled(false); //Posibilidad de seleccionar varios ficheros a la vez
            
            
            if(returnVal == JFileChooser.APPROVE_OPTION) {
                
                try {
                    
                    fichero = new Fichero(true, stream,dialogo_examinar.getSelectedFile().getAbsolutePath(),"",true);
                    this.local = true;
                }
                
                catch (URISyntaxException ex) {
                    ex.printStackTrace();
                    
                    JOptionPane dialog = new JOptionPane();
                    
                    JOptionPane.showMessageDialog(this, "Invalid URL!", "Error", JOptionPane.ERROR_MESSAGE);
                    
                    fichero = null;
                    return;
                }
                
                
                this.ficheroOrigenTextField.setText(fichero.getSource());
                this.ficheroDestinoTextField.setText(fichero.getDest());
            }
            
            
        }
        
        else {
            
            if (conexion == null || conexion.isConnected() == false) {
                this.local = false; //Los ficheros remotos se especifican de forma remota
                
                JOptionPane dialog = new JOptionPane();
                String string1 = "Sí";
                String string2 = "No";
                Object[] options = {string1, string2};
                int n = JOptionPane.showOptionDialog(null,
                        "You are disconnected.\n" +
                        "Would you like to connect now?",
                        "Caution",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,     //don't use a custom Icon
                        options,  //the titles of buttons
                        string2); //the title of the default button
                
                if (n == 1)
                    return;
                
                
                SSHConfigurationDialog dialogo_ssh = new SSHConfigurationDialog(parent,true);
                dialogo_ssh.setVisible(true);
                if (dialogo_ssh.aceptar == false)
                    return;
                
                ((GUI)this.parent).conexion = dialogo_ssh.getConexion(); //La conexión se asigna a la clase principal.
                
                this.conexion = dialogo_ssh.getConexion();
                
            }
            local = false;
            //Selección de ficheros remotos
            RemoteFileDialog dialogo_examinar = null;
            try {
                dialogo_examinar = new RemoteFileDialog((JFrame) parent, conexion,new Vector(),false,dialogo_examinar.FILES_AND_DIRECTORIES);
            } catch (SftpException ex) {
                ex.printStackTrace();
                return;
            }
            
            dialogo_examinar.setVisible(true);
            
            if (dialogo_examinar.aceptar == true) {
                try {
                    if (dialogo_examinar.copiar == true) {
                        
                        fichero = new Fichero(true,stream,"file://"+dialogo_examinar.getSelectedFile().getAbsolutePath(),"",false);
                    } else
                        fichero = new Fichero(true,stream,dialogo_examinar.getSelectedFile().getAbsolutePath(),"",false);
                    
                }
                
                catch(URISyntaxException ex) {
                    ex.printStackTrace();
                    
                    JOptionPane dialog = new JOptionPane();
                    
                    JOptionPane.showMessageDialog(this, "Invalid URL!", "Error", JOptionPane.ERROR_MESSAGE);
                    
                    fichero = null;
                    return;
                }
                
                
                
                this.ficheroOrigenTextField.setText((fichero.getSource()).replace(System.getProperty("user.dir"),"")); //Lo deja relativo
                this.ficheroDestinoTextField.setText(fichero.getDest());
            }
        }
        
        if (this.local == true)
        {
            this.label4.setText("Local File System");
            this.label4.setBackground(new Color(0,255,0));
        }
        else {
            this.label4.setText("GridWay Server File System");
            this.label4.setBackground(new Color(255,255,0));
        }
        
        
    }//GEN-LAST:event_jButton1jLocalMouseClicked
    
    private void ficheroDestinoTextFieldMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ficheroDestinoTextFieldMouseClicked
        this.seleccionado = this.DESTINO;
    }//GEN-LAST:event_ficheroDestinoTextFieldMouseClicked
    
    private void ficheroOrigenTextFieldMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ficheroOrigenTextFieldMouseClicked
        this.seleccionado = this.ORIGEN;
    }//GEN-LAST:event_ficheroOrigenTextFieldMouseClicked
    
    private void listaVariablesMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_listaVariablesMouseClicked
        
        if (this.listaVariables.getSelectedIndex() != -1) {
            if (seleccionado == ORIGEN) {
                this.ficheroOrigenTextField.setText(this.ficheroOrigenTextField.getText()+this.listaVariables.getSelectedItem());
                
            } else if (seleccionado == DESTINO)
                this.ficheroDestinoTextField.setText(this.ficheroDestinoTextField.getText()+this.listaVariables.getSelectedItem());
        }
    }//GEN-LAST:event_listaVariablesMouseClicked
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    
    
    
    // Declaración de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JTextField ficheroDestinoTextField;
    private javax.swing.JTextField ficheroOrigenTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JPanel jPanel1;
    private java.awt.Label label1;
    private java.awt.Label label2;
    private java.awt.Label label3;
    private java.awt.Label label4;
    private java.awt.List listaVariables;
    // Fin de declaración de variables//GEN-END:variables
    
}
