/*
 * AddOutPutFile.java
 *
 * Created on 27 de septiembre de 2007, 12:20
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import com.jscape.inet.sftp.SftpException;
import java.awt.Frame;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.Vector;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

/**
 *
 * @author  globus
 */
public class AddOutPutFile extends java.awt.Dialog {
    
    /** Creates new form AddOutPutFile */
    boolean local = true;
    public boolean aceptar = false;
    public int seleccionado = 1;
    public static int ORIGEN = 1;
    public static int DESTINO = 2;
    Frame parent;
    
    private Fichero fichero;
    SecureFTP conexion = null;
    
    boolean stream = false;
    public AddOutPutFile(java.awt.Frame parent, boolean modal, String origen, String destino,boolean stream,SecureFTP conexion,boolean local) {
        super(parent, modal);
        initComponents();
        
        this.conexion = conexion;
        this.stream = stream;
        
        
        
        if (stream == true) {
            this.ficheroOrigenTextField.setEnabled(false);
            this.ficheroOrigenTextField.setVisible(false);
            this.label1.setVisible(false);
            this.seleccionado = 2;
        }
        
        this.listaVariables.removeAll();
        
        this.listaVariables.add("${JOB_ID}");
        this.listaVariables.add("${ARRAY_ID}");
        this.listaVariables.add("${TASK_ID}");
        this.listaVariables.add("${TOTAL_TASKS}");
        this.listaVariables.add("${ARCH}");
        this.listaVariables.add("${PARAM}");
        
        this.parent = parent;
        
        if (origen != null)
            this.ficheroOrigenTextField.setText(origen);
        
        if (destino != null)
            this.ficheroDestinoTextField.setText(destino);
        try {
            
            
            this.fichero = new Fichero(false,stream, origen,destino,local);
        } catch (URISyntaxException ex) {
            
        };
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Código Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        label1 = new java.awt.Label();
        label2 = new java.awt.Label();
        ficheroOrigenTextField = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        ficheroDestinoTextField = new javax.swing.JTextField();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        listaVariables = new java.awt.List();
        label3 = new java.awt.Label();

        setAlwaysOnTop(true);
        setResizable(false);
        setTitle("OutPutfile");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        label1.setText("Source File:");

        label2.setText("New location:");
        label2.getAccessibleContext().setAccessibleName("New ");

        ficheroOrigenTextField.setToolTipText("The source file must be a clean filename, not allowed paths or URLs!");
        ficheroOrigenTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                ficheroOrigenTextFieldKeyPressed(evt);
            }
        });
        ficheroOrigenTextField.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ficheroOrigenTextFieldMouseClicked(evt);
            }
        });

        jButton1.setText("...");
        jButton1.setEnabled(false);
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLocalMouseClicked(evt);
            }
        });

        jButton2.setText("Remote");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jRemotoMouseClicked(evt);
            }
        });

        ficheroDestinoTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                ficheroDestinoTextFieldKeyTyped(evt);
            }
        });
        ficheroDestinoTextField.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ficheroDestinoTextFieldMouseClicked(evt);
            }
        });

        jButton3.setText("Accept");
        jButton3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jAceptarMouseClicked(evt);
            }
        });

        jButton4.setText("Cancel");
        jButton4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jCancelarMouseClicked(evt);
            }
        });

        listaVariables.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                listaVariablesMouseClicked(evt);
            }
        });

        label3.setText("Sustitution variables:");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, ficheroOrigenTextField)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, ficheroDestinoTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 229, Short.MAX_VALUE))
                                .add(16, 16, 16)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jButton1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 81, Short.MAX_VALUE)
                                    .add(jButton2)))
                            .add(jPanel1Layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(listaVariables, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 189, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(86, 86, 86)
                        .add(jButton3)
                        .add(110, 110, 110)
                        .add(jButton4)))
                .addContainerGap(39, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(32, 32, 32)
                        .add(listaVariables, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(39, 39, 39)
                        .add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(12, 12, 12)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(ficheroOrigenTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(jButton1)))
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(50, 50, 50)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(ficheroDestinoTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 35, Short.MAX_VALUE)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jButton3)
                            .add(jButton4))
                        .addContainerGap())
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                        .add(jButton2)
                        .add(66, 66, 66))))
        );
        add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void ficheroDestinoTextFieldKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_ficheroDestinoTextFieldKeyTyped

    }//GEN-LAST:event_ficheroDestinoTextFieldKeyTyped

    private void ficheroOrigenTextFieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_ficheroOrigenTextFieldKeyPressed

        String aux = this.ficheroOrigenTextField.getText();
        aux = aux.replace("/","").replace(":","");
        this.ficheroOrigenTextField.setText(aux);
    }//GEN-LAST:event_ficheroOrigenTextFieldKeyPressed
    
    private void ficheroDestinoTextFieldMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ficheroDestinoTextFieldMouseClicked
        
        this.seleccionado = this.DESTINO;
    }//GEN-LAST:event_ficheroDestinoTextFieldMouseClicked
    
    private void ficheroOrigenTextFieldMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ficheroOrigenTextFieldMouseClicked
        
        this.seleccionado = this.ORIGEN;
    }//GEN-LAST:event_ficheroOrigenTextFieldMouseClicked
    
    private void listaVariablesMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_listaVariablesMouseClicked
        
        if (this.listaVariables.getSelectedIndex() != -1) {
            if (seleccionado == ORIGEN) {
                this.ficheroOrigenTextField.setText(this.ficheroOrigenTextField.getText()+this.listaVariables.getSelectedItem());
                
            } else if (seleccionado == DESTINO)
                this.ficheroDestinoTextField.setText(this.ficheroDestinoTextField.getText()+this.listaVariables.getSelectedItem());
        }
    }//GEN-LAST:event_listaVariablesMouseClicked
    
    private void jCancelarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCancelarMouseClicked
        
        this.aceptar = false;
        this.setVisible(false);
    }//GEN-LAST:event_jCancelarMouseClicked
    
    private void jAceptarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jAceptarMouseClicked
        try {
            
            Fichero fichero = new Fichero(false,stream,this.ficheroOrigenTextField.getText(),this.ficheroDestinoTextField.getText(),local);
        } catch (URISyntaxException ex) {
            
            ex.printStackTrace();
            
            JOptionPane dialog = new JOptionPane();
            
            JOptionPane.showMessageDialog(this, "Invalid URL", "Error", JOptionPane.ERROR_MESSAGE);
            
            fichero = null;
            return;
        }
        this.aceptar = true;
        
        this.setVisible(false);
    }//GEN-LAST:event_jAceptarMouseClicked
    
    private void jRemotoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jRemotoMouseClicked
        
        
        
        AddOutPutRemoteFileDialog remotefiledialog;
        
        remotefiledialog = new AddOutPutRemoteFileDialog(parent, true, stream,null);
        remotefiledialog.setVisible(true);
        
        if (remotefiledialog.aceptar == true) {
            fichero = remotefiledialog.getFichero();
            this.ficheroOrigenTextField.setText(fichero.getSource());
            this.ficheroDestinoTextField.setText(fichero.getDest());
            this.local = false;
        }
        
        
        
    }//GEN-LAST:event_jRemotoMouseClicked
    
    /*Los ficheros de salida que son definidos de forma local siempre serán definidos
     relativamente a la máquina que contiene el demonio de gridway y sobre la que se lanzarán los trabajos.
     OJO, está máquina no será en la que estos se ejecuten,*/
    private void jLocalMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLocalMouseClicked
        
        if (this.jButton1.isEnabled() == false)
            return;
        
        RemoteFileDialog  dialogo_examinar = null;
        
        if (conexion == null || conexion.isConnected() == false) //Si está conectado se muestran los ficheros remotos
        {
            this.local = false; //Los ficheros remotos se especifican de forma remota
            
            JOptionPane dialog = new JOptionPane();
            String string1 = "Sí";
            String string2 = "No";
            Object[] options = {string1, string2};
            int n = JOptionPane.showOptionDialog(null,
                    "You are disconnected from server."+
                     "The output files specification must be down within the file system of a Gridway Server."+
                    "You must connect to continue, Would you like to connect now?",
                    "Caution",
                    JOptionPane.YES_NO_OPTION,
                    JOptionPane.QUESTION_MESSAGE,
                    null,     //don't use a custom Icon
                    options,  //the titles of buttons
                    string2); //the title of the default button
            
            if (n == 1)
                return;
            
            
            SSHConfigurationDialog dialogo_ssh = new SSHConfigurationDialog(parent,true);
            dialogo_ssh.setVisible(true);
            if (dialogo_ssh.aceptar == false)
                return;
            
            ((GUI)this.parent).conexion = dialogo_ssh.getConexion(); //La conexión se asigna a la clase principal.
            
            this.conexion = dialogo_ssh.getConexion();
            
            
            
            
            
        }
        try {
            
            dialogo_examinar = new RemoteFileDialog((JFrame) parent, conexion,new Vector(),false,dialogo_examinar.FILES_AND_DIRECTORIES);
        } catch (SftpException ex) {
            ex.printStackTrace();
            return;
        }
        
        dialogo_examinar.setVisible(true);
        
        if (dialogo_examinar.aceptar == true) {
            String[] parts = dialogo_examinar.getSelectedFile().getPath().split("/");
            
            
            try {
                if (dialogo_examinar.copiar == true)
                    
                    fichero = new Fichero(false,stream,parts[parts.length-1],"file://"+dialogo_examinar.getSelectedFile().getAbsolutePath(),false);
                
                else
                    fichero = new Fichero(false,stream,parts[parts.length-1],dialogo_examinar.getSelectedFile().getAbsolutePath(),false);
                
            }
            
            catch(URISyntaxException ex) {
                ex.printStackTrace();
                
                
                
                JOptionPane.showMessageDialog(this, "Invalid URL", "Error", JOptionPane.ERROR_MESSAGE);
                
                fichero = null;
                return;
            }
            
            this.ficheroOrigenTextField.setText(fichero.getSource());
            this.ficheroDestinoTextField.setText(fichero.getDest());
        }
    }//GEN-LAST:event_jLocalMouseClicked
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    
    
    public Fichero getFichero() {
        
        try {
            fichero =  new Fichero(false,stream, this.ficheroOrigenTextField.getText(),this.ficheroDestinoTextField.getText(),local);
        } catch (URISyntaxException ex) {
            ex.printStackTrace();
            JOptionPane dialog = new JOptionPane();
            
            JOptionPane.showMessageDialog(this, "Invalid URL", "Error", JOptionPane.ERROR_MESSAGE);
        }
        
        return fichero;
    }
    
    // Declaración de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JTextField ficheroDestinoTextField;
    private javax.swing.JTextField ficheroOrigenTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JPanel jPanel1;
    private java.awt.Label label1;
    private java.awt.Label label2;
    private java.awt.Label label3;
    private java.awt.List listaVariables;
    // Fin de declaración de variables//GEN-END:variables
    
}
