/*
 * AddOutPutRemoteFileDialog.java
 *
 * Created on 4 de octubre de 2007, 16:37
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import java.net.MalformedURLException;
import java.net.URI;
import java.net.URISyntaxException;
import javax.swing.JOptionPane;

/**
 *
 * @author  globus
 */
public class AddOutPutRemoteFileDialog extends java.awt.Dialog {
    
    /** Creates new form AddOutPutRemoteFileDialog */
    
    boolean aceptar = false;
    
    private Fichero fichero;
    boolean stream = false;
    
    public AddOutPutRemoteFileDialog(java.awt.Frame parent, boolean modal, boolean stream, Fichero fichero) {
        super(parent, modal);
        initComponents();
        
        this.stream = stream;
        if (stream == true) {
            this.nombreFicheroTextField.setEnabled(false);
            this.nombreFicheroTextField.setVisible(false);
            this.label3.setVisible(false);
            
        }
        
        if (fichero != null) {
            if (stream == false)
            {
            this.nombreFicheroTextField.setText(fichero.getDestFilename());
            this.ficheroTextField.setText(fichero.getSourceFilename());
            }
            else
            {
                this.nombreFicheroTextField.setText(fichero.getSourceFilename());
                this.ficheroTextField.setText(fichero.getDestFilename());
            }
            
            this.remotehostTextField.setText(fichero.getHost());
            
            
          if (this.ficheroTextField.getText().startsWith("/") == false && this.ficheroTextField.getText().compareTo("") != 0)
            this.ficheroTextField.setText("/"+this.ficheroTextField.getText());
        
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Código Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        label1 = new java.awt.Label();
        remotehostTextField = new javax.swing.JTextField();
        label2 = new java.awt.Label();
        ficheroTextField = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        label3 = new java.awt.Label();
        nombreFicheroTextField = new javax.swing.JTextField();

        setAlwaysOnTop(true);
        setTitle("Remote location");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        label1.setText("Remote host:");

        remotehostTextField.setToolTipText("Enter the address of remote host. Example: globusdev.dyndns.info\n");

        label2.setText("File Path:");

        ficheroTextField.setToolTipText("Enter the file path within remote host. Example: \n/tmp/X1123432f");
        ficheroTextField.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                ficheroTextFieldPropertyChange(evt);
            }
        });
        ficheroTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                ficheroTextFieldKeyTyped(evt);
            }
        });

        jButton1.setText("Accept");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton1jAceptarMouseClicked(evt);
            }
        });

        jButton2.setText("Cancel");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton2jCancelarMouseClicked(evt);
            }
        });

        label3.setText("New name:");

        nombreFicheroTextField.setToolTipText("This name will be the name of the output file in the remote host. ");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                        .add(63, 63, 63)
                        .add(jButton1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 100, Short.MAX_VALUE)
                        .add(jButton2)
                        .add(10, 10, 10))
                    .add(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, nombreFicheroTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 223, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, ficheroTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 223, Short.MAX_VALUE)
                            .add(remotehostTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 223, Short.MAX_VALUE))))
                .add(68, 68, 68))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(37, 37, 37)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(ficheroTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(19, 19, 19)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(remotehostTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(19, 19, 19)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(nombreFicheroTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 17, Short.MAX_VALUE)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton1)
                    .add(jButton2))
                .addContainerGap())
        );
        add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void ficheroTextFieldKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_ficheroTextFieldKeyTyped
        String[] partes = this.ficheroTextField.getText().split("/");
        
        String aux = this.ficheroTextField.getText();
        if (aux.compareTo("") != 0 && aux.startsWith("/") == false)
            this.ficheroTextField.setText("/"+aux);
        
        if (partes.length > 0)
            this.nombreFicheroTextField.setText(partes[partes.length-1]);
        
    }//GEN-LAST:event_ficheroTextFieldKeyTyped
    
    private void jButton2jCancelarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton2jCancelarMouseClicked
        this.aceptar = false;
        this.setVisible(false);
    }//GEN-LAST:event_jButton2jCancelarMouseClicked
    
    private void jButton1jAceptarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1jAceptarMouseClicked
        try {
            
            if (this.remotehostTextField.getText().matches("gsiftp://") == false)
                fichero = new Fichero(false,stream, this.nombreFicheroTextField.getText(),"gsiftp://"+this.remotehostTextField.getText()+this.ficheroTextField.getText(),false);
            
            else
                fichero = new Fichero(false,stream,this.nombreFicheroTextField.getText(), this.remotehostTextField.getText()+this.ficheroTextField.getText(),false);
            
            
        } catch (URISyntaxException ex) {
            
            JOptionPane dialog = new JOptionPane();
            
            JOptionPane.showMessageDialog(this, "Invalid URL", "Error", JOptionPane.ERROR_MESSAGE);
            
            return;
        }
        
        
        this.aceptar = true;
        this.setVisible(false);
    }//GEN-LAST:event_jButton1jAceptarMouseClicked
    
    private void ficheroTextFieldPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_ficheroTextFieldPropertyChange
        this.nombreFicheroTextField.setText(this.ficheroTextField.getText());
    }//GEN-LAST:event_ficheroTextFieldPropertyChange
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    
    
    Fichero getFichero() {
        return this.fichero;
    }
    
    
    // Declaración de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JTextField ficheroTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JPanel jPanel1;
    private java.awt.Label label1;
    private java.awt.Label label2;
    private java.awt.Label label3;
    private javax.swing.JTextField nombreFicheroTextField;
    private javax.swing.JTextField remotehostTextField;
    // Fin de declaración de variables//GEN-END:variables
    
}
