/*
 * AddOutputFilesDialog.java
 *
 * Created on 27 de septiembre de 2007, 12:03
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import java.awt.Frame;
import java.awt.List;
import java.util.ArrayList;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 *
 * @author  globus
 */
public class AddOutputFilesDialog extends java.awt.Dialog {
    
    /** Creates new form AddOutputFilesDialog */
    
    public TaskEditorDialog interfaz;
    public boolean aceptar = false;
    ArrayList ficheros;
    
    Frame parent;
    
    SecureFTP conexion = null;
    
    public boolean contiene(Fichero fichero) {
        for (int i = 0;i<ficheros.size();i++) {
            Fichero aux = (Fichero) ficheros.get(i);
            
            if (aux.iguales(fichero) == true)
                return true;
        }
        
        return false;
    }
    
    
    public AddOutputFilesDialog(java.awt.Frame parent, boolean modal, ArrayList lista, TaskEditorDialog interfaz,SecureFTP conexion) {
        super(parent, modal);
        initComponents();
        this.conexion = conexion;
        this.parent = parent;
        this.interfaz = interfaz;
        this.list1.removeAll();
        
        ficheros = new ArrayList();
        
        for (int i = 0;i<lista.size();i++) {
            Fichero aux = (Fichero) lista.get(i);
            ficheros.add(aux); //Se añaden los ficheros al arraylist del cuadro de dialogo
            list1.add(aux.toString());
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Código Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        label1 = new java.awt.Label();
        list1 = new java.awt.List();
        jButton1 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();

        setAlwaysOnTop(true);
        setResizable(false);
        setTitle("Add output files");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        label1.setText("Added Files:");

        jButton1.setText("Add File");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton1jAnadirFicheroMouseClicked(evt);
            }
        });

        jButton6.setText("Cancel");
        jButton6.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton6jCancelarMouseClicked(evt);
            }
        });

        jButton5.setText("Remove");
        jButton5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton5jEliminarMouseClicked(evt);
            }
        });

        jButton4.setText("Edit");
        jButton4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton4jEditarMouseClicked(evt);
            }
        });

        jButton3.setText("Accept");
        jButton3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton3jAceptarMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(30, 30, 30)
                .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(328, Short.MAX_VALUE))
            .add(jPanel1Layout.createSequentialGroup()
                .add(80, 80, 80)
                .add(jButton3)
                .add(88, 88, 88)
                .add(jButton6)
                .addContainerGap(116, Short.MAX_VALUE))
            .add(jPanel1Layout.createSequentialGroup()
                .add(48, 48, 48)
                .add(list1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 263, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jButton5)
                    .add(jButton4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 83, Short.MAX_VALUE))
                .add(63, 63, 63))
            .add(jPanel1Layout.createSequentialGroup()
                .add(148, 148, 148)
                .add(jButton1)
                .addContainerGap(201, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(24, 24, 24)
                        .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(list1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 113, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(65, 65, 65)
                        .add(jButton4)
                        .add(20, 20, 20)
                        .add(jButton5)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton1)
                .add(29, 29, 29)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton3)
                    .add(jButton6))
                .addContainerGap())
        );
        add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    
    public Fichero obtenerFichero(String path) {
        for (int i = 0;i<ficheros.size();i++) {
            Fichero aux = (Fichero) ficheros.get(i);
            
            if (aux.toString().compareTo(path) == 0)
                return aux;
            
        }
        
        return null;
    }
    private void jButton4jEditarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton4jEditarMouseClicked
        
        if (list1.getSelectedIndex() != -1) {
            String aux = this.list1.getSelectedItem();
            ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            
            /*En este punto se va a comprobar si alguna tarea depende de los ficheros de salida para
             esta tarea y así avisar para la edición y modificación en cascada.*/
            
            
            
            WorkFlow workflow = this.interfaz.interfaz.workflow_actual;
            Fichero ficheroseleccionado = this.obtenerFichero(list1.getSelectedItem());
            
            AddOutPutFile dialogoedicionfichero = new AddOutPutFile(parent,true,ficheroseleccionado.getSource(),ficheroseleccionado.getDest(),false,conexion,ficheroseleccionado.fichero_local);
            
            
            dialogoedicionfichero.setVisible(true);
            
            if (dialogoedicionfichero.aceptar == true) {
                Fichero editado = dialogoedicionfichero.getFichero();
                /*Se elimina del arraylist de ficheros*/
                
                Fichero eliminado = this.eliminaFicheroFromList(ficheroseleccionado);
                
                
                if (this.contiene(editado) == false) {
                    
                    if (workflow.existeDependenciaAlFichero(this.interfaz.tarea, ficheroseleccionado) == true) {
                        
                        JOptionPane dialog = new JOptionPane();
                        String string1 = "Sí";
                        String string2 = "No";
                        Object[] options = {string1, string2};
                        int n = JOptionPane.showOptionDialog(null,
                                "The selected File has dependencies in another tasks, so these dependencies will be removed."+
                                "Would you like to continue?",
                                "Caution",
                                JOptionPane.YES_NO_OPTION,
                                JOptionPane.QUESTION_MESSAGE,
                                null,     //don't use a custom Icon
                                options,  //the titles of buttons
                                string2); //the title of the default button
                        
                        
                        if (n == 1) {
                            this.ficheros.add(eliminado);
                            return;
                        }
                        
                        this.interfaz.interfaz.workflow_actual.actualizarFicheroDependiente(this.interfaz.tarea,
                                eliminado,editado);
                        
                        this.interfaz.tarea.actualizaFicheroSalida(eliminado,editado);
                    }
                    
                    int i = this.list1.getSelectedIndex();
                    list1.remove(this.list1.getSelectedIndex()); //Se elimina de la lista.
                    this.ficheros.add(editado); //Se añade a la lista
                    
                    list1.add(editado.toString(),i);
                }
                
                else {
                    
                    
                    JOptionPane dialog = new JOptionPane();
                    
                    JOptionPane.showMessageDialog(this, "The file already exists on the list", "Error", JOptionPane.ERROR_MESSAGE);
                    //Ahora hay que deshacer todo lo anterior.
                    
                    this.ficheros.add(eliminado);
                    
                    return;
                }
                
                
                
                
                /*Ahora hay que editar las dependencias a este fichero*/
                //////////////////////////////////////////////////////////////
                /*Hay que crear un método para actualizar las dependencias con la nueva informacion*/
                
                
                
                
                
            }
        }
        
        
        
    }//GEN-LAST:event_jButton4jEditarMouseClicked
    
    
    
    public Fichero eliminaFicheroFromList(Fichero fichero) {
        for (int i = 0;i<this.ficheros.size();i++) {
            Fichero aux = (Fichero) this.ficheros.get(i);
            if (fichero.iguales(aux) == true) {
                this.ficheros.remove(aux);
                return aux;
            }
        }
        
        return null;
    }
    
    
    
    private void jButton5jEliminarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton5jEliminarMouseClicked
        
        if (list1.getSelectedIndex() != -1) {
            String aux = this.list1.getSelectedItem();
            ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            
            /*En este punto se va a comprobar si alguna tarea depende de los ficheros de salida para
             esta tarea y así avisar para la edición y modificación en cascada.*/
            
            
            
            WorkFlow workflow = this.interfaz.interfaz.workflow_actual;
            Fichero ficheroseleccionado = this.obtenerFichero(list1.getSelectedItem());
            if (workflow.existeDependenciaAlFichero(this.interfaz.tarea, ficheroseleccionado) == true) {
                
                JOptionPane dialog = new JOptionPane();
                String string1 = "Sí";
                String string2 = "No";
                Object[] options = {string1, string2};
                int n = JOptionPane.showOptionDialog(null,
                        "El fichero seleccionado tiene dependencias en otras tareas, ¿desea continuar?",
                        "Advertencia",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,     //don't use a custom Icon
                        options,  //the titles of buttons
                        string2); //the title of the default button
                
                
                if (n == 1)
                    return;
                
                Fichero eliminado = this.eliminaFicheroFromList(ficheroseleccionado);
                this.interfaz.tarea.eliminaFicheroSalida(eliminado);
                this.interfaz.interfaz.workflow_actual.eliminarFicheroDependiente(this.interfaz.tarea,eliminado);
            }
            
            Fichero eliminado = this.eliminaFicheroFromList(ficheroseleccionado);
            
            
            
            
            this.list1.remove(this.list1.getSelectedIndex());
            
        }
        
        
        
    }//GEN-LAST:event_jButton5jEliminarMouseClicked
    
    private void jButton6jCancelarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton6jCancelarMouseClicked
        this.aceptar = false;
        this.setVisible(false);
    }//GEN-LAST:event_jButton6jCancelarMouseClicked
    
    private void jButton3jAceptarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton3jAceptarMouseClicked
        this.aceptar = true;
        this.setVisible(false);
    }//GEN-LAST:event_jButton3jAceptarMouseClicked
    
    
    public boolean existeFicheroEnLista(String file) {
        for (int i = 0;i<list1.getItemCount();i++) {
            String aux = list1.getItem(i);
            
            
            if (aux.split(" ").length > 0) {
                String[] sub = aux.split(" ");
                if (sub[sub.length-1].compareTo(file) == 0)
                    return true;
            }
            
            else if (aux.split("/").length > 0) {
                String [] sub = aux.split(" ");
                if (sub[sub.length-1].compareTo(file) == 0)
                    return true;
            }
        }
        
        return false;
    }
    
    
    private void jButton1jAnadirFicheroMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1jAnadirFicheroMouseClicked
        
        AddOutPutFile dialog = new AddOutPutFile(parent,true,null,null,false,conexion,true);
        
        dialog.setVisible(true);
        
        if (dialog.aceptar == true) {
            if (this.contiene(dialog.getFichero()) == false) {
                Fichero aux = dialog.getFichero();
                
                ficheros.add(aux);
                
                this.list1.add(aux.toString());
                
            }
            
            else {
                
                JOptionPane dialogo = new JOptionPane();
                
                JOptionPane.showMessageDialog(this, "El fichero ya ha sido añadido", "Error", JOptionPane.ERROR_MESSAGE);
                
            }
        }
        
        
    }//GEN-LAST:event_jButton1jAnadirFicheroMouseClicked
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    public ArrayList getFiles() {
        return this.ficheros;
    }
    
    
    
    // Declaración de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JPanel jPanel1;
    private java.awt.Label label1;
    private java.awt.List list1;
    // Fin de declaración de variables//GEN-END:variables
    
}
