/*
 * Dependencia.java
 *
 * Created on 3 de octubre de 2007, 13:20
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import java.net.URISyntaxException;
import java.util.ArrayList;

/**
 *
 * @author globus
 */
public class Dependencia {
    
    private ArrayList ficheros;
    Tarea tarea1;
    Tarea tarea2;
    String nombre;
    public Dependencia(String nombre, Tarea tarea1, Tarea tarea2) throws URISyntaxException {
        ficheros = new ArrayList();
        this.tarea1 = tarea1;
        this.tarea2 = tarea2;
        this.nombre = nombre;
        
        if (tarea1 == null || tarea2 == null || this.nombre == null || this.nombre.compareTo("") == 0)
            throw new URISyntaxException("Error","Error while defining dependency");
    }
    
    
    public void actualizaFicheroDependiente(Fichero fichero, Fichero ficheronuevo)
    {
        for (int i = 0;i<ficheros.size();i++)
        {
            Fichero aux = (Fichero) ficheros.get(i);
            
            if (aux.iguales(fichero) == true)
            {
                ficheros.remove(i);
                ficheros.add(ficheronuevo);
                break; 
            }
        }
    }
    
    public void anadeFichero(Fichero fichero)
    {
        ficheros.add(fichero);
    }
    
    public boolean contieneFichero(Fichero fichero)
    {
        for (int i = 0;i< ficheros.size();i++)
        {
            Fichero aux = (Fichero)ficheros.get(i);
            if (aux.iguales(fichero) == true)
                return true;
            
        }
        
        return false;
    }
    
    
    public void eliminaFicheroDependencia(Fichero fichero)
    {
        for (int i = 0;i< ficheros.size();i++)
        {
            Fichero aux = (Fichero)ficheros.get(i);
            if (aux.iguales(fichero) == true)
            {
                ficheros.remove(i);
                break;
            }
        }
    }
    
    public boolean hayFicherosDependientes()
    {
        return (this.ficheros.size() > 0);
    }
    
    public ArrayList obtieneFicheros()
    {
        return ficheros;
    }
    
    public void eliminaTodos()
    {
        ficheros.clear();
    }
    
    
    public String toString()
    {
        return this.nombre;
    }
    
}
