/*
 * DynamicTree.java
 *
 * Created on 13 de septiembre de 2007, 10:28
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Hernández Fernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;
import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import javax.swing.tree.*;
import javax.swing.JTree;





public class DynamicTree extends JPanel {
    private DefaultMutableTreeNode rootNode;
    private DefaultTreeModel treeModel;
    private JTree tree;
    private Toolkit toolkit;
    
    
    
    public GUI interfaz;
    
    
    
    
    
    public void addMouseListener(MouseListener l) {
        tree.addMouseListener(l);
    }
    
    
    
    public DynamicTree(GUI i) {
        
        this.interfaz = i;
        toolkit = Toolkit.getDefaultToolkit();
        
        
        ActionListener eliminar = new ActionListener() {
            public void actionPerformed( ActionEvent evt ) {
                
                DefaultMutableTreeNode aux = getSelection() ;
                
                if (interfaz.workflow_actual.ObtenerTipo(aux) == interfaz.workflow_actual.TAREA) {
                    interfaz.borrarTarea();
                }
                
                else if (interfaz.workflow_actual.ObtenerTipo(aux) == interfaz.workflow_actual.DEPENDENCIA) {
                    interfaz.borrarDependencia();
                }
                
            }
        };
        
        
        ActionListener cerrar = new ActionListener() {
            public void actionPerformed( ActionEvent evt ) {
                
                DefaultMutableTreeNode aux = getSelection() ;
                
                if (interfaz.workflow_actual.ObtenerTipo(aux) == interfaz.workflow_actual.WORKFLOW)
                    interfaz.cerrarWorkFlow();
                
            }
        };
        
        
        
        
        
        
        
        
        rootNode = new DefaultMutableTreeNode("WorkFlows");
        treeModel = new DefaultTreeModel(rootNode);
        
        tree = new JTree(treeModel);
        tree.setEditable(false);
        tree.getSelectionModel().setSelectionMode
                (TreeSelectionModel.SINGLE_TREE_SELECTION);
        
        
        
        tree.setShowsRootHandles(true);
        tree.setExpandsSelectedPaths(true);
        tree.setLargeModel(true);
        
        
        JScrollPane scrollPane = new JScrollPane(tree);
        setLayout(new GridLayout(1,0));
        add(scrollPane);
        
        //tree.setCellRenderer(new TreeRenderer());
        
        
        
        
    }
    
    //////////////////////////////////////////////////////////////////////////////////
    
    
///////////////////////////////////////////////////////////////////////////
    
    
    
    /** Remove all nodes except the root node. */
    public void clear() {
        rootNode.removeAllChildren();
        treeModel.reload();
    }
    
    /** Remove the currently selected node. */
    
    
    
    
    public DefaultMutableTreeNode getSelection() {
        TreePath aux = tree.getSelectionPath();
        if (aux != null) {
            DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)aux.getLastPathComponent();
            return currentNode;
        }
        return null;
    }
    
    
    public void removeNode(DefaultMutableTreeNode node) {
        
        MutableTreeNode parent = (MutableTreeNode)(node.getParent());
        
        if (parent != null)
            treeModel.removeNodeFromParent(node);
        
        
    }
    
    public void removeNode(String workflowname, String nodename,boolean tarea) //Si no es tarea es dependencia
    {
        DefaultMutableTreeNode aux = this.rootNode;
        
        DefaultMutableTreeNode aux2;
        
        
        for (int i = 0;i<this.rootNode.getChildCount();i++) {
            aux = (DefaultMutableTreeNode) this.rootNode.getChildAt(i);
            
            if (aux.toString().compareTo(workflowname) == 0) {
                if (tarea == true) // es tarea
                    aux = (DefaultMutableTreeNode)aux.getChildAt(0);
                else
                    aux = (DefaultMutableTreeNode) aux.getChildAt(1); //Es dependencia
                
                for (int j = 0;j<aux.getChildCount();j++) {
                    aux2 = (DefaultMutableTreeNode)aux.getChildAt(j);
                    if (aux2.toString().compareTo(nodename) == 0) {
                        this.removeNode(aux2);
                        return;
                    }
                }
            }
        }
        
    }
    
    
    
    public void removeCurrentNode() {
        TreePath currentSelection = tree.getSelectionPath();
        if (currentSelection != null) {
            DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)
            (currentSelection.getLastPathComponent());
            MutableTreeNode parent = (MutableTreeNode)(currentNode.getParent());
            if (parent != null) {
                treeModel.removeNodeFromParent(currentNode);
                
                
                return;
            }
        }
        
        // Either there was no selection, or the root was selected.
        toolkit.beep();
    }
    
    
    
    public DefaultMutableTreeNode obtenerTreeNode(WorkFlow workflow) {
        DefaultMutableTreeNode aux = null;
        if (workflow != null) {
            for (int i = 0;i<this.interfaz.treeworkflows.size();i++) {
                aux = (DefaultMutableTreeNode) this.interfaz.treeworkflows.get(i);
                
                if (aux.toString().compareTo(workflow.toString()) == 0)
                    return aux;
            }
        }
        
        return null;
    }
    
    /** Add child to the currently selected node. */
    public DefaultMutableTreeNode addObject(Object child) {
        DefaultMutableTreeNode parentNode = null;
        TreePath parentPath = tree.getSelectionPath();
        
        if (parentPath == null) {
            parentNode = rootNode;
        } else {
            parentNode = (DefaultMutableTreeNode)
            (parentPath.getLastPathComponent());
        }
        
        return addObject(parentNode, child, true);
    }
    
    public DefaultMutableTreeNode addObject(DefaultMutableTreeNode parent,
            Object child) {
        return addObject(parent, child, false);
    }
    
    public DefaultMutableTreeNode addObject(DefaultMutableTreeNode parent,
            Object child,
            boolean shouldBeVisible) {
        DefaultMutableTreeNode childNode =
                new DefaultMutableTreeNode(child);
        
        if (parent == null) {
            parent = rootNode;
        }
        
        treeModel.insertNodeInto(childNode, parent,
                parent.getChildCount());
        
        // Make sure the user can see the lovely new node.
        if (shouldBeVisible) {
            tree.expandPath(new TreePath(parent.getPath()));
            tree.scrollPathToVisible(new TreePath(childNode.getPath()));
        }
        return childNode;
    }
}