/*
 * EditorDependenciaDialog.java
 *
 * Created on 11 de octubre de 2007, 16:11
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import java.net.URISyntaxException;
import java.util.ArrayList;
import javax.swing.JOptionPane;

/**
 *
 * @author  globus
 */
public class EditorDependenciaDialog extends java.awt.Dialog {
    
    /** Creates new form EditorDependenciaDialog */
    
    
    
    GUI interfaz;
    ArrayList ficherosTarea;
    ArrayList ficherosSeleccionados;
    boolean aceptar = false;
    
    boolean cambio = false;
    
    public ArrayList getSelectedFiles() {
        
        /*Hay que convertir los ficheros de salida en entrada*/
        
        
        
        return this.ficherosSeleccionados;
    }
    
    
    /*Los ficheros contenidos en la lista ficherosOUT son los ficheros de salida de la tarea 1 y los ficheros contenidos
     en la lista ficherosIN son los ficheros que actualmente han sido seleccionados para formar parte de la dependencia y
     si se eliminan de aquí, también se eliminarán de la tarea 2*/
    public EditorDependenciaDialog(java.awt.Frame parent, boolean modal, ArrayList ficherosOUT, ArrayList ficherosIN) {
        super(parent, modal);
        GUI  interfaz = (GUI) parent;
        initComponents();
        ficherosTarea = ficherosOUT;
        ficherosSeleccionados = new ArrayList();
        
        for (int i = 0;i<ficherosTarea.size();i++) {
            Fichero aux = (Fichero) ficherosTarea.get(i);
            this.list1.add(aux.toString());
        }
        
        for (int i = 0;i<ficherosIN.size();i++) {
            Fichero aux = (Fichero)ficherosIN.get(i);
            this.list2.add(aux.toString());
            ficherosSeleccionados.add(aux);
        }
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Código Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        list1 = new java.awt.List();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        list2 = new java.awt.List();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jLabel3 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();

        setTitle("Dependency editor");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        list1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                list1MouseClicked(evt);
            }
        });

        jLabel1.setText("Task 1 output files:");

        jLabel2.setText("Selected Files:");

        list2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                list2MouseClicked(evt);
            }
        });

        jScrollPane1.setBorder(null);
        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setRows(2);
        jTextArea1.setText("Select which task 1 output files will be needed as task 2 input files.\n");
        jScrollPane1.setViewportView(jTextArea1);

        jLabel3.setText("(Right click to remove from list)");

        jButton1.setText("Accept");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jAceptarMouseClicked(evt);
            }
        });

        jButton2.setText("Cancel");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jCancelarMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(26, 26, 26)
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 391, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(jLabel2)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jLabel3))
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(46, 46, 46)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(list2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 311, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(list1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 311, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(84, 84, 84)
                        .add(jButton1)
                        .add(88, 88, 88)
                        .add(jButton2))
                    .add(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jLabel1)))
                .addContainerGap(26, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 38, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel1)
                .add(20, 20, 20)
                .add(list1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 182, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(28, 28, 28)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(jLabel3))
                .add(19, 19, 19)
                .add(list2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 191, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 35, Short.MAX_VALUE)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton1)
                    .add(jButton2))
                .addContainerGap())
        );
        add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void jCancelarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCancelarMouseClicked
        
        this.aceptar = false;
        this.setVisible(false);
    }//GEN-LAST:event_jCancelarMouseClicked
    
    private void jAceptarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jAceptarMouseClicked
        
        JOptionPane dialog = new JOptionPane();
        String string1 = "Sí";
        String string2 = "No";
        Object[] options = {string1, string2};
        
        if (cambio == false)
            this.setVisible(false);
       
         int n = JOptionPane.showOptionDialog(null,
                    "The changes will be saved immediately." +
                    "Would you like to continue?",
                    "Caution",
                    JOptionPane.YES_NO_OPTION,
                    JOptionPane.QUESTION_MESSAGE,
                    null,     //don't use a custom Icon
                    options,  //the titles of buttons
                    string2); //the title of the default button

            
            if (n == 1)
            {
                       
             this.setVisible(false);
                return;
            }
         
         
            this.aceptar = true;
            this.setVisible(false);
            
  
            
    }//GEN-LAST:event_jAceptarMouseClicked
        
        private void eliminarFichero(String name) {
            for (int i = 0;i<this.ficherosSeleccionados.size();i++) {
                Fichero aux = (Fichero) this.ficherosSeleccionados.get(i);
                
                if (aux.iguales(name) == true) {
                    this.ficherosSeleccionados.remove(i);
                    break;
                }
            }
        }
        
        
    private void list2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_list2MouseClicked
        if (evt.getButton() == evt.BUTTON3 && evt.getClickCount() == 1) {
            if (list2.getSelectedIndex() != -1) {
                {
                    this.eliminarFichero(list2.getSelectedItem());
                    list2.remove(list2.getSelectedIndex());
                    cambio = true;
                    
                }
            }
        }
    }//GEN-LAST:event_list2MouseClicked
    
    private void list1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_list1MouseClicked
        if (list1.getSelectedIndex() != -1) {
            String fichero_seleccionado = list1.getSelectedItem();
            
            String partes[] = fichero_seleccionado.split(" ");
            
            Fichero aux = null;
            
            try {
                if (partes.length > 1)
                    aux = new Fichero(false,false,partes[0],partes[1],false); //Todos los ficheros dependientes son remotos //puesto que en nuestra máquina local no se ejecuta gridway
                else
                    aux = new Fichero(false,false,partes[0],"",false);
                if (list2Contiene(fichero_seleccionado) == false) {
                    this.ficherosSeleccionados.add(aux); //Se añade sin  convertir
                    this.list2.add(aux.toString());
                    
                    cambio = true;
                }
            } catch (URISyntaxException ex) {
                ex.printStackTrace();
                return;
            }
            
            
            
            
            
        }
    }//GEN-LAST:event_list1MouseClicked
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    public boolean list2Contiene(String fichero) {
        String[] items = this.list2.getItems();
        
        for (int i = 0;i<items.length;i++) {
            if (items[i].compareTo(fichero) == 0)
                return true;
        }
        
        return false;
    }
    
    // Declaración de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    private java.awt.List list1;
    private java.awt.List list2;
    // Fin de declaración de variables//GEN-END:variables
    
    }
