/*
 * EnvironmentEditor.java
 *
 * Created on 25 de septiembre de 2007, 17:21
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import java.awt.Frame;
import javax.swing.JOptionPane;

/**
 *
 * @author  globus
 */
public class EnvironmentEditor extends java.awt.Dialog {
    
    /** Creates new form EnvironmentEditor */
    
    boolean aceptar = false;
    Frame parent;
    public EnvironmentEditor(java.awt.Frame parent, boolean modal,String variables) {
        super(parent, modal);
        initComponents();
        
        this.parent = parent;
        
        this.setLocation(Utiles.findScreenCenter(this));
        String aux[] = variables.split(",");
        
        
        if (variables.length() > 0)
        for (int i = 0;i<aux.length;i++)
            this.list1.add(aux[i]);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Código Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        label1 = new java.awt.Label();
        list1 = new java.awt.List();
        jButton2 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        label2 = new java.awt.Label();
        label3 = new java.awt.Label();
        jButton1 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        variableTextField = new javax.swing.JTextField();
        valorTextField = new javax.swing.JTextField();

        setAlwaysOnTop(true);
        setTitle("Environment variables editor");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        label1.setText("Environment variables created:");

        list1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                list1MouseClicked(evt);
            }
        });

        jButton2.setText("Remove variable:");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton2jBorrarVariableMouseClicked(evt);
            }
        });

        jButton5.setText("Edit");
        jButton5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton5jEditarVariableMouseClicked(evt);
            }
        });

        label2.setText("Variable:");

        label3.setText("Value:");

        jButton1.setText("Create new variable");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton1jCrearVaribleEntornoMouseClicked(evt);
            }
        });

        jButton4.setText("Cancel");
        jButton4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jCancelarMouseClicked(evt);
            }
        });

        jButton3.setText("Accept");
        jButton3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jAceptarMouseClicked(evt);
            }
        });

        valorTextField.setToolTipText("Las variables definidas en ENVIRONMENT son inicializadas en el bash shell. Estas pueden tomar ventaja de las capacidades de sustituci\u00f3n del bash y de las funciones integeradas.\nPor ejemplo:\n\nVAR = ' expr ${JOB_ID} + 3' ");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(24, 24, 24)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(jButton3)
                                    .add(variableTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE)
                                    .add(valorTextField))
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jPanel1Layout.createSequentialGroup()
                                        .add(20, 20, 20)
                                        .add(jButton1))
                                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 108, Short.MAX_VALUE)
                                        .add(jButton4)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))))
                            .add(list1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 260, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(jButton5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(jButton2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap(19, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(74, 74, 74)
                        .add(jButton2)
                        .add(20, 20, 20)
                        .add(jButton5))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(23, 23, 23)
                        .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(list1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 129, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(50, 50, 50)
                                .add(jButton1))
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(40, 40, 40)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(jPanel1Layout.createSequentialGroup()
                                        .add(variableTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(valorTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                    .add(jPanel1Layout.createSequentialGroup()
                                        .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))))
                .add(36, 36, 36)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton3)
                    .add(jButton4))
                .addContainerGap(21, Short.MAX_VALUE))
        );
        add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jCancelarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCancelarMouseClicked

        this.aceptar = false;
        this.setVisible(false);
    }//GEN-LAST:event_jCancelarMouseClicked

    private void jAceptarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jAceptarMouseClicked

        this.aceptar = true;
        this.setVisible(false);
    }//GEN-LAST:event_jAceptarMouseClicked
    
    
    private boolean list1Contiene(String variable_name) {
        for (int i = 0;i<this.list1.getItemCount();i++) {
            String aux = this.list1.getItem(i);
            String[] split = aux.split("=");
            if (split[0].compareTo(variable_name) == 0)
                return true;
        }
        
        return false;
    }
    
    private void jButton1jCrearVaribleEntornoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1jCrearVaribleEntornoMouseClicked
        if (this.variableTextField.getText().compareTo("") == 0) {
            JOptionPane dialog = new JOptionPane();
            
            JOptionPane.showMessageDialog(this, "Variable name missing!", "Error", JOptionPane.ERROR_MESSAGE);
        }
        
        else if (this.list1Contiene(this.variableTextField.getText()) == true) {
            
            JOptionPane dialog = new JOptionPane();
            
            JOptionPane.showMessageDialog(this, "The variable "+this.variableTextField.getText()+" already exists!", "Error", JOptionPane.ERROR_MESSAGE);
        }
        
        else if (this.valorTextField.getText().compareTo("") == 0) {
            JOptionPane dialog = new JOptionPane();
            
            JOptionPane.showMessageDialog(this, "Value missing!", "Error", JOptionPane.ERROR_MESSAGE);
        }
        
        else {
            
            this.list1.add(this.variableTextField.getText()+"="+this.valorTextField.getText());
        }
        
        this.variableTextField.setText("");
        this.valorTextField.setText("");
    }//GEN-LAST:event_jButton1jCrearVaribleEntornoMouseClicked
    
    private void jButton5jEditarVariableMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton5jEditarVariableMouseClicked

        if (this.list1.getSelectedIndex() != -1) {
            String aux = this.list1.getSelectedItem();
            String[] aux2 = aux.split("=");
            
            EditorVariable dialog = new EditorVariable(parent,true,aux2[0],aux2[1]);
            
            dialog.setVisible(true);
            
            if (dialog.aceptar == true)
            {
                this.list1.remove(this.list1.getSelectedIndex());
                this.list1.add(dialog.variable+"="+dialog.valor);
            }
            
            
        }
    }//GEN-LAST:event_jButton5jEditarVariableMouseClicked
    
    private void jButton2jBorrarVariableMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton2jBorrarVariableMouseClicked
        if (this.list1.getSelectedIndex() != -1) {
            this.list1.remove(this.list1.getSelectedIndex());
        }
        
        this.jButton2.setEnabled(false);//Deshabilita borrar y editar variable
        this.jButton5.setEnabled(false);
    }//GEN-LAST:event_jButton2jBorrarVariableMouseClicked
    
    private void list1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_list1MouseClicked
        if (this.list1.getSelectedIndex() != -1) {
            this.jButton2.setEnabled(true); //Habilita el botón de eliminar variable de entorno
            this.jButton5.setEnabled(true); //Habilita el botón de editar variable de entorno
        }
    }//GEN-LAST:event_list1MouseClicked
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        
        dispose();
    }//GEN-LAST:event_closeDialog
    
 
    public String getVariables()
    {
        String lista_variables = "";
        
        for (int i = 0;i < this.list1.getItemCount();i++)
        {
            lista_variables += this.list1.getItem(i)+" , ";
        }
        
        return lista_variables;
    }
    
    
    // Declaración de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JPanel jPanel1;
    private java.awt.Label label1;
    private java.awt.Label label2;
    private java.awt.Label label3;
    private java.awt.List list1;
    private javax.swing.JTextField valorTextField;
    private javax.swing.JTextField variableTextField;
    // Fin de declaración de variables//GEN-END:variables
    
}
