/*
 * Fichero.java
 *
 * Created on 3 de octubre de 2007, 21:01
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */    
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import java.net.MalformedURLException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.ArrayList;

/**
 *
 * @author globus
 */
public class Fichero implements Cloneable{
    
    /** Creates a new instance of Fichero */
    boolean fichero_local;
    
    boolean entrada;
    boolean remoto;
    boolean copiaraDestino;
    boolean stream;
    String origen;
    String destino;
    String host;
    
    
    
    
    
    public Fichero() {
        entrada = false;
        remoto = false;
        copiaraDestino = false;
        stream = false;
        origen = "";
        destino = "";
        host = "";
        
    }
    
    public static Fichero constructorFicheroRestart(String fichero,boolean fichero_local) throws URISyntaxException {
        if (fichero.contains("/") == true || fichero.contains(" ") == true)
            throw new URISyntaxException("Error","A checkpoint file cannot be specified as URL nor absolute path!");
        else
            return new Fichero(false,true,"",fichero,fichero_local);
        
    }
    public static Fichero constructorFichero(boolean entrada, boolean stream, String fichero,boolean fichero_local) throws URISyntaxException {
        
        
        if (fichero == null || fichero.compareTo("") == 0)
            throw new URISyntaxException("","The file cannot be null nor empty string!");
        
        
        String partes[] = fichero.split(" ");
        
        if (partes.length > 1) {
            return new Fichero(entrada,stream,partes[0],partes[1],fichero_local); //Llama al otro constructor con dos argumentos
        }
        
        else if (partes.length == 1 && entrada == true)
            return new Fichero(entrada,stream,partes[0],"",fichero_local);
        
        else if (partes.length == 1 && entrada == false)
            return new Fichero(entrada,stream,"",partes[0],fichero_local);
        
        else throw new URISyntaxException("","Bad file specification!");
        
        
    }
    
    
    
    public Fichero convertirDeSalidaAEntrada() {
        Fichero aux = null;
        if (this.entrada == true)
            return null;
        
        
        
        else {
            try {
                if (this.origen.compareTo("") == 0)
                    aux =  new Fichero(true,stream,this.destino,this.destino,this.fichero_local);
                
                
                else
                    aux = new Fichero(true,stream,this.destino,this.origen,this.fichero_local);
                
            } catch (URISyntaxException ex) {
                ex.printStackTrace();
                
            }
        }
        
        return aux;
    }
    /*
    public Fichero(boolean entrada, boolean stream, String fichero,boolean fichero_local) throws URISyntaxException {
     
        this.entrada = entrada;
        this.stream = stream;
     
        this.origen = this.destino = "";
     
        this.host = "";
     
        URI urlficheroentrada =null, urlficherosalida = null;
     
        this.fichero_local = fichero_local;
     
     
    }
     */
    public Fichero(boolean entrada, boolean stream,String ficheroentrada, String ficherosalida,boolean fichero_local)  throws URISyntaxException  {
        
        this.entrada = entrada;
        this.stream = stream;
        
        this.fichero_local = fichero_local;
        
        this.origen = this.destino = "";
        
        this.host = "";
        
        URI urlficheroentrada =null, urlficherosalida = null;
        
        if (ficheroentrada != null)
            ficheroentrada = ficheroentrada.replace(" ","");
        if (ficherosalida != null)
            ficherosalida = ficherosalida.replace(" ","");
        
        /*El fichero de entrada es obligatorio siempre*/
        
        String ficheroentradaaux = "", ficherosalidaaux = "";
        if (stream == true)
            //Si es fichero está declarando un input, output o err stream.
        {
            
            
            if (ficheroentrada != null && ficheroentrada.compareTo("") != 0 && this.entrada == true) {
                
                
                ficheroentradaaux = ficheroentrada.replace(new String("${JOB_ID}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${ARRAY_ID}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${TASK_ID}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${TOTAL_TASKS}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${ARCH}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${PARAM}"),"a");
                
                ficheroentradaaux = ficheroentradaaux.replace(System.getProperty("user.dir")+"/","");
                if (ficheroentrada != null)
                    ficheroentrada = ficheroentrada.replace(" ","");
 
                
                if (ficheroentrada.matches("gsiftp://[^ ]+") == true && this.entrada == true) {
                    this.remoto = true;
                    this.copiaraDestino = true;
                    
                    
                    urlficheroentrada = new URI(ficheroentradaaux.substring(9));
                    
                    String parts[] = urlficheroentrada.toString().split("/");
                    this.host = parts[0];
                    
                    parts = ficheroentrada.substring(9).split("/");
                    
                    this.origen = "/";
                    for (int i = 1;i< parts.length;i++)
                        this.origen += parts[i];
                    
                    this.destino = "";
                }
                
                else if (ficheroentrada.matches("file://[^ ]+") == true && this.entrada == true) {
                    this.remoto = false;
                    this.copiaraDestino = true;
                    urlficheroentrada = new URI(ficheroentradaaux);
                    
                    this.origen = ficheroentrada.substring(7);
                    
                    this.destino = "";
                }
                
                else if (ficheroentrada.startsWith("/") == false)
                {
                    
                    
                    this.remoto = false;
                    this.copiaraDestino = false;
                    urlficheroentrada = new URI(ficheroentradaaux); //Puede que salte una excepción que se tratará más arriba
                    
                    this.origen = ficheroentrada;
                    this.destino = "";
                }
                else //Relativo
                {
                    this.remoto = false;
                    this.copiaraDestino = true;
                    urlficheroentrada = new URI(ficheroentradaaux);
                    this.origen = ficheroentradaaux;
                    this.destino = "";
                }
                
            }
            
            else if (ficherosalida != null && ficherosalida.compareTo("") != 0 && this.entrada == false) {
                
                
                //Se instancias las variables por valores triviales.
                ficherosalidaaux = ficherosalida.replace(new String("${JOB_ID}"),"0");
                ficherosalidaaux = ficherosalidaaux.replace(new String("${ARRAY_ID}"),"0");
                ficherosalidaaux = ficherosalidaaux.replace(new String("${TASK_ID}"),"0");
                ficherosalidaaux = ficherosalidaaux.replace(new String("${TOTAL_TASKS}"),"0");
                ficherosalidaaux = ficherosalidaaux.replace(new String("${ARCH}"),"0");
                ficherosalidaaux = ficherosalidaaux.replace(new String("${PARAM}"),"0");
                
                
                if (ficherosalida != null)
                    ficherosalida = ficherosalida.replace(" ","");
                
                if (ficherosalida.matches("gsiftp://[^ ]+") == true && this.entrada == false) {
                    this.remoto = true;
                    this.copiaraDestino = true;
                    
                    urlficherosalida = new URI(ficherosalidaaux.substring(9));
                    
                    String parts[] = urlficherosalida.toString().split("/");
                    this.host = parts[0];
                    parts = ficherosalida.substring(9).split("/");
                    
                    this.destino = "/";
                    for (int i = 1;i< parts.length;i++)
                        this.destino += parts[i];
                    
                    
                    this.origen = "";
                }
                
                else if (ficherosalida.matches("file://[^ ]+") == true && this.entrada == false) {
                    this.remoto = false;
                    this.copiaraDestino = true;
                    urlficherosalida = new URI(ficherosalidaaux.substring(7));
                    
                    this.destino = ficherosalida.substring(7);
                    
                    this.origen = "";
                }
                
                else {
                    
                    
                    this.remoto = false;
                    this.copiaraDestino = false;
                    urlficherosalida = new URI(ficherosalidaaux); //Puede que salte una excepción que se tratará más arriba
                    
                    this.destino = ficherosalida;
                    this.origen = "";
                }
                
            }
            
            
            else throw new URISyntaxException("Error","Error specifing the file!, find out by yourself what went wrong");
            
            
            
            
            
        }
        
        else //Si se está definiendo un fichero normal
        {
            if (ficheroentrada != null && ficheroentrada.compareTo("") != 0 && this.entrada == true) {
                
                
                ficheroentradaaux = ficheroentrada.replace(new String("${JOB_ID}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${ARRAY_ID}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${TASK_ID}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${TOTAL_TASKS}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${ARCH}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${PARAM}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${ARCH}"),"a");
                //Se instancias las variables por valores triviales.
                
                if (ficherosalida != null) {
                    ficherosalidaaux = ficherosalida.replace(new String("${JOB_ID}"),"0");
                    ficherosalidaaux = ficherosalidaaux.replace(new String("${ARRAY_ID}"),"0");
                    ficherosalidaaux = ficherosalidaaux.replace(new String("${TASK_ID}"),"0");
                    ficherosalidaaux = ficherosalidaaux.replace(new String("${TOTAL_TASKS}"),"0");
                    ficherosalidaaux = ficherosalidaaux.replace(new String("${ARCH}"),"0");
                    ficherosalidaaux = ficherosalidaaux.replace(new String("${PARAM}"),"0");
                }
                
                ficheroentradaaux = ficheroentradaaux.replace(System.getProperty("user.dir")+"/","");
                if (ficheroentrada != null)
                    ficheroentrada = ficheroentrada.replace(" ","");
                
                if (ficherosalida != null)
                    ficherosalida = ficherosalida.replace(" ","");
                
                if (ficheroentrada.matches("gsiftp://[^ ]+") == true && this.entrada == true) {
                    this.remoto = true;
                    this.copiaraDestino = true;
                    
                    urlficheroentrada = new URI(ficheroentradaaux.substring(9));
                    String parts[] = urlficheroentrada.toString().split("/");
                    this.host = parts[0];
                    
                    parts = ficheroentrada.substring(9).split("/");
                    
                    this.origen = "/";
                    for (int i = 1;i< parts.length;i++)
                        this.origen += parts[i];
                    
                    
                    
                }
                
                else if (ficheroentrada.matches("file://[^ ]+") == true && this.entrada == true) {
                    this.remoto = false;
                    this.copiaraDestino = true;
                    urlficheroentrada = new URI(ficheroentradaaux);
                    
                    this.origen = ficheroentrada.substring(7);
                    
                    
                }
                
                else if (this.fichero_local == false){
                    
                    
                    this.remoto = false;
                    this.copiaraDestino = false;
                    urlficheroentrada = new URI(ficheroentradaaux); //Puede que salte una excepción que se tratará más arriba
                    
                    
                    this.origen = ficheroentrada;
                    
                }
                else
                {
                    this.remoto = false;
                    this.copiaraDestino = true;
                    urlficheroentrada = new URI(ficheroentradaaux);
                    this.origen = ficheroentradaaux;
                }
                
                if (ficherosalida != null && ficherosalida.contains("/") == true)
                    throw new URISyntaxException("Error","El fichero de destino en definiendo un input file no debe" +
                            "ser url");
                
                urlficherosalida = new URI(ficherosalidaaux);
                
                if (ficherosalida == null)
                    this.destino = "";
                else
                    this.destino = ficherosalida;
                
            }
            
            else if (ficheroentrada != null && ficheroentrada.compareTo("") != 0 &&
                    this.entrada == false) {
                
                if (ficherosalida == null)
                    ficherosalida = "";
                
                ficheroentradaaux = ficheroentrada.replace(new String("${JOB_ID}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${ARRAY_ID}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${TASK_ID}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${TOTAL_TASKS}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${ARCH}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${PARAM}"),"a");
                ficheroentradaaux = ficheroentradaaux.replace(new String("${ARCH}"),"a");
                //Se instancias las variables por valores triviales.
                ficherosalidaaux = ficherosalida.replace(new String("${JOB_ID}"),"0");
                ficherosalidaaux = ficherosalidaaux.replace(new String("${ARRAY_ID}"),"0");
                ficherosalidaaux = ficherosalidaaux.replace(new String("${TASK_ID}"),"0");
                ficherosalidaaux = ficherosalidaaux.replace(new String("${TOTAL_TASKS}"),"0");
                ficherosalidaaux = ficherosalidaaux.replace(new String("${ARCH}"),"0");
                ficherosalidaaux = ficherosalidaaux.replace(new String("${PARAM}"),"0");
                
                
                
                if (ficherosalida != null)
                    ficherosalida = ficherosalida.replace(" ","");
                
                
                if (ficheroentrada != null)
                    ficheroentrada = ficheroentrada.replace(" ","");
                
                if (ficherosalida.matches("gsiftp://[^ ]+") == true && this.entrada == true) {
                    this.remoto = true;
                    this.copiaraDestino = true;
                    
                    urlficherosalida = new URI(ficherosalidaaux.substring(9));
                    String parts[] = urlficherosalida.toString().split("/");
                    this.host = parts[0];
                    
                    parts = ficherosalida.substring(9).split("/");
                    
                    this.destino = "/";
                    for (int i = 1;i< parts.length;i++)
                        this.destino += parts[i];
                    
                    
                    
                }
                
                else if (ficherosalida.matches("file://[^ ]+") == true && this.entrada == true) {
                    this.remoto = false;
                    this.copiaraDestino = true;
                    urlficherosalida = new URI(ficherosalidaaux);
                    
                    this.destino = ficherosalida.substring(7);
                    
                    
                }
                
                else {
                    
                    
                    this.remoto = false;
                    this.copiaraDestino = false;
                    urlficherosalida = new URI(ficherosalidaaux); //Puede que salte una excepción que se tratará más arriba
                    
                    this.destino = ficherosalida;
                    
                }
                
                if (ficheroentrada != null && ficheroentrada.contains("/") == true)
                    throw new URISyntaxException("Error","The origin path of an output file must be defined as a relative path!");
                
                urlficheroentrada = new URI(ficheroentradaaux);
                this.origen = ficheroentrada;
                
            }
            
            else
                throw new  URISyntaxException("Error","A origin path of a file must be defined!");
            
            
            
            
            
            if (destino.compareTo("") == 0) {
                String parts[] = this.origen.split("/");
                if (parts.length > 1)
                    this.destino = parts[parts.length-1];
                else
                    this.destino = this.origen;
            }
            
        }
        
        
        
        
        
        
        
        
        
        
        
    }
    
    public String getHost() {
        if (this.remoto == true)
            return this.host;
        
        
        return "";
        
    }
    
    
    public String getSourceFilename() {
        return this.origen;
    }
    
    public String getDestFilename() {
        return this.destino;
    }
    
    public String getSource() {
        String cadena = "";
        
        if (this.stream == true && this.entrada == false)
            return "";
        
        if (this.entrada == true) { //INPUT FILE
            
            if (this.remoto == true) {
                cadena ="gsiftp://"+this.host;
            } else if (this.copiaraDestino == true && this.fichero_local == false) {
                cadena = "file://";
            }
            else
                cadena = "";
            
            cadena += this.origen;
            
        }
        
        else    //OUTPUT FILE
        {
            cadena += this.origen;
            
        }
        
        return cadena;
    }
    
    public String getDest() {
        String cadena = "";
        
        if (this.stream == true && this.entrada == true)
            return "";
        
        if (this.entrada == true) { //INPUT FILE
            
            cadena += this.destino;
        }
        
        else    //OUTPUT FILE
        {
            
            if (this.remoto == true)
                cadena = "gsiftp://"+this.host;
            else if (this.copiaraDestino == true)
                cadena = "file://";
            
            cadena += this.destino;
            
        }
        
        return cadena;
    }
    
    
    public String codigo() {
        String cadena = "";
        
        if (this.fichero_local == true && this.entrada == true && this.remoto == false) {
            if (this.copiaraDestino == false)
                return toString();
            
            String partes[] = this.origen.split("/");
            if (partes.length > 1)
                cadena = partes[partes.length-1];
            
            else
                cadena = partes[0];
            
            return cadena;
        } else
            return toString();
    }
    
    
    public String toString() {
        
        /*Los ficheros que son de la máquina local y serán copiados a la máquina
         en la que se encuentra el metaplanificador deben ser relativos al path facilitado
         a la hora de enviar los ficheros a la máquina remota. A la hora de generar las plantillas
         de trabajo se eliminará de los ficheros toda su ruta, para dejarlos de forma relativa, si es que estuvieran
         de forma absoluta.*/
        String cadena = "";
        
        if (this.origen.compareTo("") == 0 && this.destino.compareTo("") == 0)
            return "";
        
        if (this.entrada == true) { //INPUT FILE
            
            if (this.remoto == true) {
                cadena ="gsiftp://";
            }
            
            else if (this.copiaraDestino == true && this.fichero_local == false) {
                cadena = "file://";
            }
            
            else
                cadena = "";
            
            
            cadena += this.origen;
            
            if (stream == false && this.copiaraDestino == true)
                cadena += " "+this.destino;
        }
        
        else    //OUTPUT FILE
        {
            if (stream == false)
                cadena += this.origen+" ";
            
            
            if (this.remoto == true)
                cadena = "gsiftp://";
            else if (this.copiaraDestino == true)
                cadena = "file://";
            
            cadena += this.destino;
            
        }
        
        
        return cadena;
    }
    
    
    public boolean iguales(Fichero fichero) {
        
        if (fichero.stream == false && this.stream == false) {
            
            if (this.entrada ==  true) {
                if (fichero.entrada == true && this.destino.compareTo(fichero.destino) == 0)
                    return true;
                else if (fichero.entrada == false && this.destino.compareTo(fichero.origen) == 0)
                    return true;
                else return false;
            }
            
            else  {
                
                
                if (fichero.entrada == true && this.origen.compareTo(fichero.destino) == 0)
                    return true;
                else if (fichero.entrada == false && this.origen.compareTo(fichero.origen) == 0)
                    return true;
                else return false;
                
            }
            
            
        }
        
        else if (fichero.stream == false && this.stream == true) {
            if (this.entrada == true) //Stream stdin
            {
                String[] parts = this.origen.split("/");
                
                if (fichero.entrada == true && parts[parts.length-1].compareTo(fichero.destino) == 0)
                    return true;
                
                else if (fichero.entrada == false && parts[parts.length-1].compareTo(fichero.origen) == 0)
                    return true;
                else return false;
                
                
            }
            
            else {
                String[] parts = this.destino.split("/");
                
                if (fichero.entrada == true && parts[parts.length-1].compareTo(fichero.destino) == 0)
                    return true;
                else if (fichero.entrada == false && parts[parts.length-1].compareTo(fichero.origen) == 0)
                    return true;
                else return false;
            }
            
            
        }
        
        else if (fichero.stream == true && this.stream == false) {
            String[] parts = null;
            
            if (fichero.entrada == true) //stdin
                parts = fichero.origen.split("/");
            
            
            else //stdout o stderr
                parts = fichero.destino.split("/");
            
            if (this.entrada == true && this.destino.compareTo(parts[parts.length-1]) == 0)
                return true;
            else if (this.entrada == false && this.origen.compareTo(parts[parts.length-1]) == 0)
                return true;
            
            else return false;
            
            
        }
        
        else if (fichero.stream == true && this.stream == true) {
            String parts1[],parts2[];
            
            if (fichero.entrada == true)
                parts2 = fichero.origen.split("/");
            else
                parts2 = fichero.destino.split("/");
            
            if (this.entrada == true)
                parts1 = this.origen.split("/");
            else
                parts1 = this.destino.split("/");
            
            if (parts1[parts1.length-1].compareTo(parts2[parts2.length-1]) == 0)
                return true;
            else return false;
            
        }
        
        return false;
    }
    
    public boolean iguales(String pathfichero) {
        
        
        
        String filename = pathfichero;
        
        String[] parts = filename.split("/");
        
        if (parts.length > 0)
            filename = parts[parts.length-1];
        else
            filename = pathfichero;
        
        if (this.entrada == true) {
            if (this.toString().compareTo(filename) == 0)
                return true;
            
        } else {
            if (this.toString().compareTo(pathfichero) == 0)
                return true;
        }
        
        return false;
    }
    
    
    
    public Object clone() throws CloneNotSupportedException {
        super.clone();
        
        Fichero clon = new Fichero();
        
        clon.copiaraDestino = this.copiaraDestino;
        clon.destino = new String(this.destino);
        
        clon.entrada = this.entrada;
        
        clon.fichero_local = this.fichero_local;
        
        clon.host = new String(this.host);
        
        clon.origen = new String(this.origen);
        
        clon.remoto = this.remoto;
        
        clon.stream = this.stream;
        
        return clon;
        
    }
    
}
