/*
 * GUI.java
 *
 * Created on 4 de septiembre de 2007, 10:58
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Hernández Fernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import com.jscape.inet.sftp.SftpException;
import java.awt.Color;
import java.awt.Component;
import java.awt.GridBagLayout;
import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JFileChooser;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.tree.*;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;


import org.jgraph.JGraph;
import org.jgraph.event.GraphModelEvent;
import org.jgraph.event.GraphModelListener;
import org.jgraph.graph.DefaultEdge;
import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.DefaultGraphModel;
import org.jgraph.graph.GraphConstants;
import org.jgraph.graph.GraphModel;
import paqInterfaz.MouseDemo;

/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
public class GUI extends javax.swing.JFrame  implements GraphModelListener {
    
    /** Creates new form GUI */
    
    DisplayEstadoConexion hilo_estado = null;
    boolean conectado = false;
    
    SecureFTP conexion = null;
    
    WorkFlow workflow_actual;
    
    DefaultMutableTreeNode tree_workflow_actual;
    
    int contador_workflows;
    boolean creando_dependencia;
    ArrayList workflows;
    ArrayList treeworkflows;
    
    //Tarea paraCopiar = null;
    
    /*
     public TGPanel tgpan = new TGPanel();
  TGLensSet tglen = new TGLensSet();
     
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
     *
     */
    
    
//protected TGUIManager tgUIManager = new TGUIManager();
    
    
    
    DynamicTree treePanel;
    
    
    public int getHeightPanel() {
        return this.jScrollPane1.getHeight();
    }
    
    public int getWidthPanel() {
        return this.jScrollPane1.getWidth();
    }
    
    public int getAnchoPanelPrincipal() {
        return this.jScrollPane1.getWidth();
    }
    
    public void habilitarMenuGenerarScripts(boolean decision) {
        this.generarScriptsItem.setEnabled(decision);
    }
    
    public void habilitarBorrarDep(boolean decision) {
        this.jButton4.setEnabled(decision);
    }
    
    
    public void habilitarCrearTarea(boolean decision) {
        this.jButton1.setEnabled(decision);
        this.habilitarCrearArrayTareas(decision);
    }
    
    
    public void habilitarCrearDep(boolean decision) {
        
        if (this.workflow_actual != null && this.workflow_actual.noderealcounter > 1)
            this.jButton3.setEnabled(decision);
        
        else
            this.jButton3.setEnabled(false);
        
    }
    
    public void habilitarBorrarTask(boolean decision) {
        this.jButton2.setEnabled(decision);
    }
    
    
    
    public void imprimirMensajeLog(String mensaje) {
        
        this.jLogPane.setText(this.jLogPane.getText()+"\n"+mensaje);
    }
    
    
    public void habilitarCrearArrayTareas(boolean habilitar)
    {
        this.jButton5.setEnabled(habilitar);
    }
    
    public GUI() {
        
        initComponents();
        
        
        
        
        
        this.hilo_estado = new DisplayEstadoConexion(this);
        hilo_estado.start();
        this.workflow_actual = null;
        this.tree_workflow_actual = null;
        this.jButton4.setEnabled(false);
        this.jButton2.setEnabled(false);
        
        this.contador_workflows = 0;
        
        workflows = new ArrayList(); //Arraylist de objetos workflows
        this.treeworkflows = new ArrayList();
        
        this.setDefaultCloseOperation(this.EXIT_ON_CLOSE);
        
        //this.jScrollPane1.getViewport().add(this.workflow_actual.getGraph(),null);
        
        
     /*
    tglen.addLens(tgpan.getAdjustOriginLens());
    tgpan.setLensSet(tglen);
      
   GLEditUI edui = new GLEditUI(tgpan);
    tgUIManager = new TGUIManager();
    tgUIManager.addUI(edui,"Edit");
    tgUIManager.activate("Edit");
    tgUIManager.addUI(edui,"Edit");
    tgUIManager.activate("Edit");
    this.tgpan.setLayout(this.gridBagLayout2);
    this.tgpan.addNode(new com.touchgraph.graphlayout.Node("1",3,new Color(110,90,216),"hola"));
      
      
      **/
        
        /*Deshabilitamos los botones hasta que se cree un nuevo workflow*/
        
        //treePanel.removeAll();
        this.jScrollPane1.setEnabled(false);
        this.habilitarBorrarDep(false);
        this.habilitarBorrarTask(false);
        this.habilitarCrearTarea(false);
        this.habilitarCrearDep(false);
        this.habilitarCerrarWorkFlow(false);
        this.habilitarCrearArrayTareas(false);
        //this.habilitarMenuGenerarScripts(false);
        
        this.treePanel.addMouseListener(new TreeMouseListener(this));
        
        this.habilitarConectarMenu(true);
        
        this.habilitarDesconectarMenu(false);
        
    }
    
    
    
    public void habilitarConectarMenu(boolean decision) {
        this.conectarItem.setEnabled(decision);
    }
    
    public void habilitarDesconectarMenu(boolean decision) {
        this.desconectarItem.setEnabled(decision);
    }
    
    public void imprimirMensajeBarra(String mensaje, boolean visible, Color color) {
        
        this.label1.setVisible(visible);
        
        if (visible != false && color == null)
            return;
        
        this.label1.setText(mensaje);
        
        
        this.label1.setBackground(color);
        
    }
    
    public void imprimirMensajeEstadoConexion(String mensaje, boolean visible, Color color) {
        
        this.label2.setVisible(visible);
        
        if (visible != false && color == null)
            return;
        
        this.label2.setText(mensaje);
        
        
        
        this.label2.setBackground(color);
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Código Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jMenuBar2 = new javax.swing.JMenuBar();
        jMenu2 = new javax.swing.JMenu();
        jSplitPane1 = new javax.swing.JSplitPane();
        jSplitPane2 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        jLogPane = new javax.swing.JEditorPane();
        jPanel2 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        label1 = new java.awt.Label();
        jButton4 = new javax.swing.JButton();
        label2 = new java.awt.Label();
        jButton5 = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        nuevoWorkflowItem = new javax.swing.JMenuItem();
        abrirWorkflowItem = new javax.swing.JMenuItem();
        cerrarWorkflowItem = new javax.swing.JMenuItem();
        generarScriptsItem = new javax.swing.JMenuItem();
        guardarComoItem = new javax.swing.JMenuItem();
        guardarItem = new javax.swing.JMenuItem();
        conectarItem = new javax.swing.JMenuItem();
        desconectarItem = new javax.swing.JMenuItem();
        enviarTrabajoItem = new javax.swing.JMenuItem();
        enviarYEjecutarItem = new javax.swing.JMenuItem();
        salirItem = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        reordenarGrafoMenuItem = new javax.swing.JMenuItem();
        jMenu4 = new javax.swing.JMenu();
	treePanel = new DynamicTree(this);
        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        jMenu2.setText("Menu");
        jMenuBar2.add(jMenu2);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("GWGUI beta 0.2 - WorkFlow designer Tool for GridWay metascheduler");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jSplitPane1.setDividerLocation(150);
        jSplitPane2.setDividerLocation(400);
        jSplitPane2.setDividerSize(5);
        jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane2.setResizeWeight(1.0);
        jSplitPane2.setOneTouchExpandable(true);
        jSplitPane2.setPreferredSize(new java.awt.Dimension(34, 111));
        jSplitPane2.setTopComponent(jScrollPane1);

        jLogPane.setAlignmentX(0.4F);
        jScrollPane2.setViewportView(jLogPane);

        jSplitPane2.setBottomComponent(jScrollPane2);

        jSplitPane1.setRightComponent(jSplitPane2);
	jSplitPane1.setLeftComponent(treePanel);
        jButton1.setText("Create Task");
        jButton1.setActionCommand("Crear tarea");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                crearNodoClick(evt);
            }
        });

        jButton2.setText("Remove Task");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jBorrarTareaClicked(evt);
            }
        });

        jButton3.setText("Create Dependency");
        jButton3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jCrearDependenciaClicked(evt);
            }
        });

        label1.setBackground(new java.awt.Color(51, 255, 51));
        label1.setEnabled(false);
        label1.setText("Welcome");

        jButton4.setText("Remove Dependency");
        jButton4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jBorrardepClicked(evt);
            }
        });

        label2.setBackground(new java.awt.Color(255, 102, 0));
        label2.setEnabled(false);
        label2.setText("Disconnected");

        jButton5.setText("Create Job Array");
        jButton5.setActionCommand("Create Job Array");
        jButton5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jNuevoArrayTareasMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel2Layout.createSequentialGroup()
                        .add(jButton1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton3)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton4))
                    .add(jButton5))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 238, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 238, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jButton1)
                            .add(jButton3)
                            .add(jButton2)
                            .add(jButton4))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(jButton5))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                        .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 30, Short.MAX_VALUE)
                        .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        jMenu1.setText("File");
        nuevoWorkflowItem.setText("New WorkFlow");
        nuevoWorkflowItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuINuevoWorkFlowActionPerformed(evt);
            }
        });

        jMenu1.add(nuevoWorkflowItem);

        abrirWorkflowItem.setText("Open WorkFlow");
        abrirWorkflowItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                abrirWorkflowItemActionPerformed(evt);
            }
        });

        jMenu1.add(abrirWorkflowItem);

        cerrarWorkflowItem.setText("Close WorkFlow");
        cerrarWorkflowItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemCerrarWorkFlowActionPerformed(evt);
            }
        });

        jMenu1.add(cerrarWorkflowItem);

        generarScriptsItem.setText("Generate scripts");
        generarScriptsItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jGenerarScriptsActionPerformed(evt);
            }
        });

        jMenu1.add(generarScriptsItem);

        guardarComoItem.setText("Save as...");
        guardarComoItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jGuardarComoActionPerformed(evt);
            }
        });

        jMenu1.add(guardarComoItem);

        guardarItem.setText("Save");
        guardarItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jGuardarActionPerformed(evt);
            }
        });

        jMenu1.add(guardarItem);

        conectarItem.setText("Connect to remote host");
        conectarItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jConectarActionPerformed(evt);
            }
        });

        jMenu1.add(conectarItem);

        desconectarItem.setText("Disconnect");
        desconectarItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jEnviarTrabajoActionPerformed(evt);
            }
        });

        jMenu1.add(desconectarItem);

        enviarTrabajoItem.setText("Upload job");
        enviarTrabajoItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jEnviarActionPerformed(evt);
            }
        });

        jMenu1.add(enviarTrabajoItem);

        enviarYEjecutarItem.setText("Upload and execute job");
        enviarYEjecutarItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jEnviarYEjecutarActionPerformed(evt);
            }
        });

        jMenu1.add(enviarYEjecutarItem);

        salirItem.setText("Exit program");
        salirItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jSalirActionPerformed(evt);
            }
        });

        jMenu1.add(salirItem);

        jMenuBar1.add(jMenu1);

        jMenu3.setText("Graph");
        reordenarGrafoMenuItem.setText("Reorder Nodes");
        reordenarGrafoMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reordenarGrafoMenuItemActionPerformed(evt);
            }
        });

        jMenu3.add(reordenarGrafoMenuItem);

        jMenuBar1.add(jMenu3);

        jMenu4.setText("About me");
        jMenu4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jAcercadeMenuMouseClicked(evt);
            }
        });

        jMenuBar1.add(jMenu4);

        setJMenuBar(jMenuBar1);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 820, Short.MAX_VALUE)
            .add(layout.createSequentialGroup()
                .add(jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(12, 12, 12))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 520, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jAcercadeMenuMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jAcercadeMenuMouseClicked
        AcercadeDialog dialogo = new AcercadeDialog(this,true);
        dialogo.setVisible(true);
        
    }//GEN-LAST:event_jAcercadeMenuMouseClicked

    private void jNuevoArrayTareasMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jNuevoArrayTareasMouseClicked

          if (this.jButton5.isEnabled() == false)
            return;
        
        this.workflow_actual.seleccionado = null;
        
        
        //this.jScrollPane1.add(new Node(this,20+nodecounter*10,20+nodecounter*10,"Node"+(nodecounter++)));
        
        String nodo = this.workflow_actual.crearBulkJob();
         
        
        this.imprimirMensajeLog("Job Array created "+nodo);
        
        
        
        this.treePanel.addObject((DefaultMutableTreeNode) this.tree_workflow_actual.getChildAt(0), "Task "+this.workflow_actual.nodecounter,true);
        
        this.actualizarWorkFlow();
        
        if (this.workflow_actual.noderealcounter > 1)
            this.habilitarCrearDep(true);
        
        else
            this.habilitarCrearDep(false);
    }//GEN-LAST:event_jNuevoArrayTareasMouseClicked
    
    private void reordenarGrafoMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reordenarGrafoMenuItemActionPerformed
        
        if (this.workflow_actual != null)
            this.workflow_actual.reordenarGrafo(); //Reorganiza el grafo en la pantalla
    }//GEN-LAST:event_reordenarGrafoMenuItemActionPerformed
    
    private void abrirWorkflowItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_abrirWorkflowItemActionPerformed
        
        JFileChooser dialogo_examinar = new JFileChooser();
        
        dialogo_examinar.setDialogTitle("Select File");
        
        dialogo_examinar.setDialogType(JFileChooser.SAVE_DIALOG);
        
        dialogo_examinar.setFileSelectionMode(JFileChooser.FILES_ONLY); //Sólo archivos.
        dialogo_examinar.setMultiSelectionEnabled(false); //Posibilidad de seleccionar varios ficheros a la vez
        dialogo_examinar.setCurrentDirectory(new File(System.getProperty("user.dir")));
        int returnVal = dialogo_examinar.showOpenDialog(this);
        
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            this.imprimirMensajeLog("Opening "+dialogo_examinar.getSelectedFile());
            WorkFlow nuevo = WorkFlow.Cargar(this,dialogo_examinar.getSelectedFile().getPath());
            
            if (nuevo == null)
                return;
            
            if (this.listaWorkflowsContiene(nuevo) == true) {
                
                String string1 = "Yes";
                String string2 = "No";
                Object[] options = {string1, string2};
                int n = JOptionPane.showOptionDialog(null,
                        "You have already open a WorkFlow with this name: "+nuevo.name +
                        ". Would you like to open it with a new one?",
                        "Caution",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,     //don't use a custom Icon
                        options,  //the titles of buttons
                        string2); //the title of the default button
                
                if (n == 1)
                    return;
                
                NombreEditorDialog dialogo = new NombreEditorDialog(this,true);
                dialogo.setVisible(true);
                if (dialogo.aceptar == true) {
                    nuevo.name = dialogo.getName();
                }
                
                else return; //Se cancela la apertura
            }
            
            
            
            /*Se habilitan los botones de crear tarea y dependencia*/
            this.habilitarCrearTarea(true);
            //this.habilitarCrearDep(true);
            
            /*Se habilita el panel principal*/
            this.jScrollPane1.setEnabled(true);
            
            //this.jScrollPane1.getViewport().removeAll(); //Elimina el componente jgraph del panel principal
            
            /*Creamos un nuevo nodo en el arbol dinamico representando el nuevo workflow*/
            
            this.workflow_actual = nuevo;
            
            this.addWorkFlowtoWorkFlowList(this.workflow_actual);
            
            
            
            this.habilitarBorrarDep(false);
            this.habilitarBorrarTask(false);
            this.habilitarCrearDep(false);
            this.habilitarCrearTarea(true);
            this.habilitarCerrarWorkFlow(true);
            
            
            this.tree_workflow_actual = this.treePanel.addObject(null,this.workflow_actual,true);
            
            this.addWorkFlowTreetoWorkFlowTreeList(this.tree_workflow_actual);
            
            
            this.treePanel.addObject(this.tree_workflow_actual,"Tasks",true);
            
            
            for (int i = 0;i<this.workflow_actual.listaTareas.size();i++) {
                this.treePanel.addObject((DefaultMutableTreeNode) this.tree_workflow_actual.getChildAt(0),
                        ((Tarea)this.workflow_actual.listaTareas.get(i)).nombre,true);
            }
            
            this.treePanel.addObject(tree_workflow_actual,"Dependencies",true);
            
            for (int i = 0;i<this.workflow_actual.listaDeps.size();i++) {
                this.treePanel.addObject((DefaultMutableTreeNode) this.tree_workflow_actual.getChildAt(1),
                        ((Dependencia)this.workflow_actual.listaDeps.get(i)).nombre,true);
            }
            
            
            this.treePanel.repaint();
            
            this.anadirComponentes(this.workflow_actual.getGraph());
        }
    }//GEN-LAST:event_abrirWorkflowItemActionPerformed
    
    
    
    
    public boolean listaWorkflowsContiene(WorkFlow wf) {
        if (wf != null) {
            for (int i = 0;i<this.workflows.size();i++) {
                WorkFlow aux = (WorkFlow) this.workflows.get(i);
                if (aux.name.compareTo(wf.name) == 0)
                    return true;
            }
        }
        
        return false;
    }
    private void jSalirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jSalirActionPerformed
        
        JOptionPane dialog = new JOptionPane();
        String string1 = "Yes";
        String string2 = "No";
        Object[] options = {string1, string2};
        int n = JOptionPane.showOptionDialog(null,
                "Are you really trying to exit?",
                "Caution",
                JOptionPane.YES_NO_OPTION,
                JOptionPane.QUESTION_MESSAGE,
                null,     //don't use a custom Icon
                options,  //the titles of buttons
                string2); //the title of the default button
        
        if (n == 1)
            return;
        
        
        
        for (int i = 0;i<this.workflows.size();i++) {
            WorkFlow aux = (WorkFlow)this.workflows.get(i);
            if (aux.modificado == true) {
                dialog = new JOptionPane();
                string1 = "Yes";
                string2 = "No";
                n = JOptionPane.showOptionDialog(null,
                        "The WorkFlow: "+aux.toString()+" has been modified. \n Would you like to save the changes before closing?",
                        "Caution",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,     //don't use a custom Icon
                        options,  //the titles of buttons
                        string2); //the title of the default button
                
                
                aux.cerrarWorkFlow( !(n == 1) );
                
                
            } else
                this.workflow_actual.cerrarWorkFlow(false);
        }
        
        if (this.conexion != null && this.conexion.isConnected() == true)
            this.conexion.disconnect();
        
        this.hilo_estado.salir();
        System.exit(0);
        
        
    }//GEN-LAST:event_jSalirActionPerformed
    
    private void jEnviarYEjecutarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jEnviarYEjecutarActionPerformed
        
        if (this.workflow_actual != null) {
            if (this.workflow_actual.enviarTrabajo())
                try {
                    this.workflow_actual.ejecutar();
                } catch (SftpException ex) {
                    this.imprimirMensajeLog(ex.toString());
                    
                    
                    JOptionPane.showMessageDialog(this, "An unexpected error appeared: "+ex.toString(),
                            "Error", JOptionPane.ERROR_MESSAGE);
                }
            
            
        }
    }//GEN-LAST:event_jEnviarYEjecutarActionPerformed
    
    private void jEnviarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jEnviarActionPerformed
        if (this.workflow_actual != null)
            this.workflow_actual.enviarTrabajo();
    }//GEN-LAST:event_jEnviarActionPerformed
    
    private void jEnviarTrabajoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jEnviarTrabajoActionPerformed
        if (conexion != null && conexion.isConnected() == true) {
            JOptionPane dialog = new JOptionPane();
            String string1 = "Yes";
            String string2 = "No";
            Object[] options = {string1, string2};
            int n = JOptionPane.showOptionDialog(null,
                    "Are you sure you want to disconnect?",
                    "Caution",
                    JOptionPane.YES_NO_OPTION,
                    JOptionPane.QUESTION_MESSAGE,
                    null,     //don't use a custom Icon
                    options,  //the titles of buttons
                    string2); //the title of the default button
            
            if (n == 1)
                return;
        }
        
        conexion.disconnect();
        conexion = null;
        
    }//GEN-LAST:event_jEnviarTrabajoActionPerformed
    
    private void jConectarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jConectarActionPerformed
        
        
        if (conexion != null && conexion.isConnected() == true)
            return;
        
        SSHConfigurationDialog configurarconexion = new SSHConfigurationDialog(this,true);
        
        configurarconexion.setVisible(true);
        
        if (configurarconexion.aceptar == true) {
            conexion = configurarconexion.getConexion();
        }
    }//GEN-LAST:event_jConectarActionPerformed
    
    private void jGuardarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jGuardarActionPerformed
        
        if (this.workflow_actual != null)
            this.workflow_actual.guardarWorkFlow();
    }//GEN-LAST:event_jGuardarActionPerformed
    
    private void jGuardarComoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jGuardarComoActionPerformed
        if (this.workflow_actual != null) {
            
            this.workflow_actual.guardarComoWorkFlow();
        }
    }//GEN-LAST:event_jGuardarComoActionPerformed
    
    private void jGenerarScriptsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jGenerarScriptsActionPerformed
        if (this.workflow_actual != null) {
            JFileChooser dialogo_examinar = new JFileChooser();
            
            dialogo_examinar.setDialogTitle("Select location");
            
            dialogo_examinar.setDialogType(JFileChooser.SAVE_DIALOG);
            dialogo_examinar.setCurrentDirectory(new File(System.getProperty("user.dir")));
            dialogo_examinar.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY); //Sólo archivos.
            dialogo_examinar.setMultiSelectionEnabled(false); //Posibilidad de seleccionar varios ficheros a la vez
            
            int returnVal = dialogo_examinar.showOpenDialog(this);
            
            
            
            
            
            
            if(returnVal == JFileChooser.APPROVE_OPTION) {
                
                File directorio = dialogo_examinar.getSelectedFile();
                try {
                    
                    this.workflow_actual.generarScripts(directorio.getPath(),this.workflow_actual.name);
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            }
        }
    }//GEN-LAST:event_jGenerarScriptsActionPerformed
    
    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        
        for (int i = 0;i<this.workflows.size();i++) {
            WorkFlow aux = (WorkFlow)this.workflows.get(i);
            if (aux.modificado == true) {
                JOptionPane dialog = new JOptionPane();
                String string1 = "Yes";
                String string2 = "No";
                Object[] options = {string1, string2};
                int n = JOptionPane.showOptionDialog(null,
                        "The WorkFlow: "+aux.toString()+" has been modified.\n Would you like to save the changes before closing?",
                        "Caution",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,     //don't use a custom Icon
                        options,  //the titles of buttons
                        string2); //the title of the default button
                
                
                aux.cerrarWorkFlow( !(n == 1) );
                
                
            } else
                this.workflow_actual.cerrarWorkFlow(false);
        }
        
        
        /*Se cierra la conexion, si es que la hubiera, con el servidor sftp.*/
        if (this.conexion != null && this.conexion.isConnected() == true)
            this.conexion.disconnect();
        
        
        this.hilo_estado.salir();
    }//GEN-LAST:event_formWindowClosing
    
    
    
    private String intro(String aux) {
        aux += "\n";
        return aux;
    }
    
    public void cerrarWorkFlow() {
        
        
        if (this.workflow_actual != null) {
            if (this.workflow_actual.modificado == true) {
                JOptionPane dialog = new JOptionPane();
                String string1 = "Yes";
                String string2 = "No";
                Object[] options = {string1, string2};
                int n = JOptionPane.showOptionDialog(null,
                        "The WorkFlow: "+this.workflow_actual.toString()+" hass been modified. \n Would you like to save changes before closing?",
                        "Caution",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,     //don't use a custom Icon
                        options,  //the titles of buttons
                        string2); //the title of the default button
                
                
                this.workflow_actual.cerrarWorkFlow( !(n == 1) );
                
                
            } else
                
                this.workflow_actual.cerrarWorkFlow(false);
            
        }
        
    }
    
    private void jMenuItemCerrarWorkFlowActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemCerrarWorkFlowActionPerformed
        
        this.cerrarWorkFlow();
        
    }//GEN-LAST:event_jMenuItemCerrarWorkFlowActionPerformed
    
    private void jMenuINuevoWorkFlowActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuINuevoWorkFlowActionPerformed
        
        /*Se habilitan los botones de crear tarea y dependencia*/
        this.habilitarCrearTarea(true);
        //this.habilitarCrearDep(true);
        
        /*Se habilita el panel principal*/
        this.jScrollPane1.setEnabled(true);
        
        //this.jScrollPane1.getViewport().removeAll(); //Elimina el componente jgraph del panel principal
        
        /*Creamos un nuevo nodo en el arbol dinamico representando el nuevo workflow*/
        
        this.workflow_actual = this.crearWorkFlow();
        
        this.addWorkFlowtoWorkFlowList(this.workflow_actual);
        
        
        
        this.habilitarBorrarDep(false);
        this.habilitarBorrarTask(false);
        this.habilitarCrearDep(false);
        this.habilitarCrearTarea(true);
        this.habilitarCerrarWorkFlow(true);
        
        
        this.tree_workflow_actual = this.treePanel.addObject(null,this.workflow_actual,true);
        
        this.addWorkFlowTreetoWorkFlowTreeList(this.tree_workflow_actual);
        
        this.treePanel.addObject(this.tree_workflow_actual,"Tasks",true);
        this.treePanel.addObject(tree_workflow_actual,"Dependencies",true);
        
        this.jScrollPane1.getViewport().add(this.workflow_actual.getGraph()); //Añade el objeto grafo a la visualización
        
        
        
        this.treePanel.repaint();
        
        
    }//GEN-LAST:event_jMenuINuevoWorkFlowActionPerformed
    
    public void addWorkFlowTreetoWorkFlowTreeList(DefaultMutableTreeNode tree) {
        this.treeworkflows.add(tree);
    }
    
    public void addWorkFlowtoWorkFlowList(WorkFlow workflow) {
        this.workflows.add(this.workflow_actual);
        
    }
    
    public boolean deleteWorkFlowFromWorkFlowList(WorkFlow workflow) {
        
        if (workflow != null) {
            
            return    this.workflows.remove(workflow);
            
        }
        
        return false;
        
    }
    
    private void jBorrarTareaClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jBorrarTareaClicked
        
        if (this.jButton2.isEnabled() == false)
            return;
        
        if (this.workflow_actual.seleccionado != null) {
            this.workflow_actual.deleteTask(this.workflow_actual.seleccionado,true);
            
            
            
            this.imprimirMensajeLog("Removing Task "+this.workflow_actual.seleccionado);
            
            
            /*Aquí viene el código que elimine la tarea del grafo de tareas*/
            
            this.workflow_actual.seleccionado = null;
            
            this.habilitarBorrarTask(false);
            
            
            if (this.workflow_actual.noderealcounter > 1)
                this.habilitarCrearDep(true);
            else
                this.habilitarCrearDep(false);
            
        }
        
    }//GEN-LAST:event_jBorrarTareaClicked
    
    public void borrarTarea() {
        
        if (this.workflow_actual.seleccionado != null) {
            this.workflow_actual.deleteTask(this.workflow_actual.seleccionado,true);
            
            
            
            this.imprimirMensajeLog("Removing Task: "+this.workflow_actual.seleccionado);
            
            
            /*Aquí viene el código que elimine la tarea del grafo de tareas*/
            
            this.workflow_actual.seleccionado = null;
            
            this.habilitarBorrarTask(false);
            
            if (this.workflow_actual.noderealcounter > 1)
                this.habilitarCrearDep(true);
            else
                this.habilitarCrearDep(false);
            
        }
        
        
    }
    
    public void borrarDependencia() {
        if (this.workflow_actual.dependencia != null) {
            this.workflow_actual.deleteDep(this.workflow_actual.dependencia,false);
            
            
            
            
            
            
            /*Aquí viene el código que elimine la dependencia del grafo de tareas*/
        }
    }
    
    
    private void jBorrardepClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jBorrardepClicked
        
        if (this.jButton4.isEnabled() == false)
            return;
        
        if (this.workflow_actual.dependencia != null) {
            this.workflow_actual.deleteDep(this.workflow_actual.dependencia,false);
            
            
            
            
            
            
            /*Aquí viene el código que elimine la dependencia del grafo de tareas*/
            
        }
        
        
        
    }//GEN-LAST:event_jBorrardepClicked
    
    private void jCrearDependenciaClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCrearDependenciaClicked
        
        
        if (this.jButton3.isEnabled() == false)
            return;
        
        
        this.creando_dependencia = true;
        this.imprimirMensajeBarra("Select source Task",true,new Color(255,255,0));
        this.habilitarBorrarDep(false);
        this.habilitarBorrarTask(false);
        this.habilitarCrearDep(false);
        this.habilitarCrearTarea(false);
        this.habilitarCerrarWorkFlow(false);
        this.habilitarCrearNuevoWorkFlow(false);
        this.repaint();
        this.habilitarBorrarDep(false);
        
        
    }//GEN-LAST:event_jCrearDependenciaClicked
    
    public void habilitarCrearNuevoWorkFlow(boolean condicion) {
        this.nuevoWorkflowItem.setEnabled(condicion);
    }
    
    public void habilitarCerrarWorkFlow(boolean condicion) {
        this.cerrarWorkflowItem.setEnabled(condicion);
    }
    
    
    
    
    private void crearNodoClick(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_crearNodoClick
        
        if (this.jButton1.isEnabled() == false)
            return;
        
        this.workflow_actual.seleccionado = null;
        
        
        //this.jScrollPane1.add(new Node(this,20+nodecounter*10,20+nodecounter*10,"Node"+(nodecounter++)));
        
        String nodo = this.workflow_actual.crearTarea();
        
        
        
        
        this.imprimirMensajeLog(nodo+" created");
        
        
        
        this.treePanel.addObject((DefaultMutableTreeNode) this.tree_workflow_actual.getChildAt(0), "Task "+this.workflow_actual.nodecounter,true);
        
        this.actualizarWorkFlow();
        
        if (this.workflow_actual.noderealcounter > 1)
            this.habilitarCrearDep(true);
        
        else
            this.habilitarCrearDep(false);
        
        
    }//GEN-LAST:event_crearNodoClick
    
    
    
    /**
     * @param args the command line arguments
     */
    
    
    
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                
                new GUI().setVisible(true);
                
            }
        });
    }
    
    public void actualizarWorkFlow() {
        
        this.jScrollPane1.repaint();
        
    }
    
    
    
    public Component[] obtenerComponentes() {
        return this.jScrollPane1.getComponents();
        
    }
    
    public boolean contieneWorkFlow(String nombre)
    {
        for (int i = 0;i<this.workflows.size();i++)
        {
            WorkFlow aux = (WorkFlow) this.workflows.get(i);
            
            if (aux.name.compareTo(nombre) == 0)
                return true;
        }
        
        return false;
    }
    public WorkFlow crearWorkFlow() {
        
   
        int i = 0;
        while (this.contieneWorkFlow("WorkFlow "+(++this.contador_workflows)));
      
        
        
        return new WorkFlow(this,"WorkFlow "+this.contador_workflows);
    }
    
    
    
    public void anadirComponentes(Component comp) {
        this.jScrollPane1.getViewport().add(comp);
        
    }
    
    public void borrarComponente(int indice) {
        this.jScrollPane1.remove(indice);
    }
    
    public void borrarTodos(JGraph grafo) {
        
        this.jScrollPane1.getViewport().remove(grafo);
        
        this.jScrollPane1.repaint();
    }
    
    public void graphChanged(GraphModelEvent graphModelEvent) {
        System.out.println("Event");
    }
    
    
    // Declaración de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JMenuItem abrirWorkflowItem;
    private javax.swing.JMenuItem cerrarWorkflowItem;
    private javax.swing.JMenuItem conectarItem;
    private javax.swing.JMenuItem desconectarItem;
    private javax.swing.JMenuItem enviarTrabajoItem;
    private javax.swing.JMenuItem enviarYEjecutarItem;
    private javax.swing.JMenuItem generarScriptsItem;
    private javax.swing.JMenuItem guardarComoItem;
    private javax.swing.JMenuItem guardarItem;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JEditorPane jLogPane;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenu jMenu4;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuBar jMenuBar2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private java.awt.Label label1;
    private java.awt.Label label2;
    private javax.swing.JMenuItem nuevoWorkflowItem;
    private javax.swing.JMenuItem reordenarGrafoMenuItem;
    private javax.swing.JMenuItem salirItem;
    // Fin de declaración de variables//GEN-END:variables
    
}
