/*
 * ---------------------------------------------------------
 * Antelmann.com Java Framework by Holger Antelmann
 * Copyright (c) 2005 Holger Antelmann <info@antelmann.com>
 * For details, see also http://www.antelmann.com/developer
 * ---------------------------------------------------------
 */
package paqInterfaz;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;
import javax.swing.*;
import java.util.Date;
import javax.swing.text.DateFormatter;
import javax.swing.text.DefaultFormatterFactory;


/**
 * A simple specialized <code>JSpinner</code> using <code>java.util.Date</code>
 * for a value.
 *
 * @author Holger Antelmann
 */
public class JTimeChooser extends JSpinner
        implements MouseListener {
    /** DOCUMENT ME! */
    static final long serialVersionUID = -5524090997350592980L;
    
    /**
     * Creates a new JTimeChooser object.
     */
    public JTimeChooser() {
        super(new SpinnerDateModel());
        
        Calendar calendar = new GregorianCalendar();
        SpinnerDateModel dateModel = new SpinnerDateModel(
                calendar.getTime(), null, null, Calendar.HOUR_OF_DAY);
        
    
        
        this.setModel(dateModel);
        
        // Get the date formatter
    JFormattedTextField tf =
        ((JSpinner.DefaultEditor)this.getEditor()).getTextField();
    DefaultFormatterFactory factory =
        (DefaultFormatterFactory)tf.getFormatterFactory();
    DateFormatter formatter = (DateFormatter)factory.getDefaultFormatter();
    

    
    // Or use 24 hour mode
    formatter.setFormat(new SimpleDateFormat("HH:MM a"));
        /*
        
         JSpinner.DateEditor editor = new JSpinner.DateEditor(this);
        setEditor(editor);
         **/
    
    
    }
    
    /**
     * Creates a new JTimeChooser object.
     *
     * @param time DOCUMENT ME!
     */
    public JTimeChooser(Date time) {
        this();
        setTime(time);
        
        
    }
    
    /**
     * DOCUMENT ME!
     *
     * @param date DOCUMENT ME!
     */
    public void setTime(Date date) {
        this.setValue(date);
    }
    
    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    /*
    public Date getTime() {
        return (Date) getValue();
    }
     **/
    
    public Date getTime()
    {
        return (Date)this.getValue();
    }

    public void mouseClicked(MouseEvent e) {
        int a = 2;
    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }
}
