/*
 * MouseDemo.java
 *
 * Created on 11 de septiembre de 2007, 12:31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;
import java.awt.Color;
import java.awt.Frame;
import java.awt.event.*;
import java.awt.geom.Point2D;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Map;
import java.util.Set;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.MenuElement;
import javax.swing.tree.DefaultMutableTreeNode;
import org.jgraph.JGraph;
import org.jgraph.graph.DefaultEdge;
import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.GraphConstants;


public class MouseDemo implements MouseListener {
    
    int x = 0;
    int y = 0;
    WorkFlow interfaz;
    
    JPopupMenu popupTarea;
    JPopupMenu popupDependencia;
    JPopupMenu popupGrafo;
    
    
    
    
    JMenuItem menuItem;
    /** Creates a new instance of MouseDemo */
    public MouseDemo(WorkFlow workflow) {
        this.interfaz = workflow;
        
        popupGrafo = new JPopupMenu();
        
        menuItem = new JMenuItem("Reorder");
        
        menuItem.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                
                if (interfaz.interfaz.workflow_actual != null)
                    interfaz.interfaz.workflow_actual.reordenarGrafo();
                
            }
        }
        
        
        
        );
        
        popupGrafo.add(menuItem);
        
        menuItem = new JMenuItem("Paste");
        
        
        menuItem.addMouseListener(new MouseAdapter() {
            
            public void mousePressed(MouseEvent e) {
                if (interfaz.interfaz.workflow_actual != null) {
                    if (interfaz.copia != null) {
                        Tarea pegada = (Tarea)interfaz.getCopy(interfaz.copia);
                        
                        pegada.x_pos = x;
                        pegada.y_pos = y;
                        
                        interfaz.crearTarea(pegada,pegada.x_pos,pegada.y_pos);
                        //Se añade al árbol la tarea
                        interfaz.interfaz.treePanel.addObject((DefaultMutableTreeNode) interfaz.interfaz.tree_workflow_actual.getChildAt(0),
                                pegada.nombre,true);
                    }
                }
            }
        }
        );
        
        popupGrafo.add(menuItem);
        
        popupTarea = new JPopupMenu();
        menuItem = new JMenuItem("Edit");
        
        menuItem.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                
                interfaz.interfaz.habilitarBorrarTask(true);
                interfaz.interfaz.habilitarBorrarDep(false);
                interfaz.deSeleccionarTodos();
                
                Tarea tarea = interfaz.getTarea(interfaz.seleccionado.toString());
                String nameaux = tarea.nombre;
                
                TaskEditorDialog dialogoedicion = new TaskEditorDialog((Frame) interfaz.interfaz, true,interfaz.interfaz,tarea,interfaz.interfaz.conexion);
                
                dialogoedicion.setVisible(true);
                
                while(true) {
                    if (dialogoedicion.aceptar == true) {
                        
                        if (interfaz.setName(dialogoedicion.getName(),nameaux,interfaz.seleccionado) == true) {
                            dialogoedicion.setTaskParametersFromDialog(tarea);
                            break;
                        } else {
                            dialogoedicion.aceptar = false;
                            dialogoedicion.setVisible(true);
                            
                        }
                        
                    }
                    
                    else {
                        interfaz.seleccionado = null;
                        interfaz.interfaz.habilitarBorrarTask(false);
                        interfaz.deSeleccionarTodos();
                        break;
                    }
                    
                }
                
                
                
                
                
            }
        }
        
        
        );
        
        popupTarea.add(menuItem);
        
        
        
        popupTarea.add(menuItem);
        
        menuItem = new JMenuItem("Copy");
        
        menuItem.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                if (interfaz.seleccionado != null) {
                    Tarea copia = interfaz.getTarea(interfaz.seleccionado.toString());
                    
                    copia = (Tarea)copia.clone(); //Se hace un clon y se almacena
                    
                    if (copia != null) {
                        interfaz.copia = copia;
                    }
                    
                }
                
            }
        }
        
        );
        
        popupTarea.add(menuItem);
        
        
        
        menuItem = new JMenuItem("Remove");
        
        menuItem.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                
                interfaz.deleteTask(interfaz.seleccionado,true);
                
            }
            
        }
        
        
        );
        
        popupTarea.add(menuItem);
        
        /////////////////////////////////////////////////////////////////////////////////////////
        
        popupDependencia = new JPopupMenu();
        menuItem = new JMenuItem("Remove");
        
        menuItem.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                interfaz.deleteDep(interfaz.dependencia,false);
                
            }
            
        }
        
        
        );
        
        popupDependencia.add(menuItem);
        
        
        menuItem = new JMenuItem("Edit");
        menuItem.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                
                Dependencia aux = interfaz.getDependencyObject(interfaz.getDependencia().toString());
                
                Tarea tarea1 = aux.tarea1;
                Tarea tarea2 = aux.tarea2;
                
                ArrayList ficheros_dependientes = new ArrayList();
                
                for (int i = 0;i<tarea1.ficherosSalida.size();i++) {
                    Fichero fichero = (Fichero)tarea1.ficherosSalida.get(i);
                    if (tarea2.contieneFicheroEntrada(fichero) == true)
                        ficheros_dependientes.add(fichero);
                }
                EditorDependenciaDialog dialog = new EditorDependenciaDialog(interfaz.interfaz,true,tarea1.ficherosSalida,ficheros_dependientes);
                
                
                ficheros_dependientes = new ArrayList();
                dialog.setVisible(true);
                
                if (dialog.aceptar == true) {
                    ficheros_dependientes = dialog.getSelectedFiles();
                    
                    
                    
                    
                    ArrayList ficheros_antiguos = aux.obtieneFicheros();
                    
                    for (int i = 0;i< ficheros_antiguos.size();i++) {
                        tarea2.eliminaFicheroEntrada((Fichero)ficheros_antiguos.get(i)); //Elimina los ficheros dependientes de la tarea 2
                    }
                    
                    aux.eliminaTodos(); //Elimina los ficheros de la dependencia
                    
                    for (int i = 0;i<ficheros_dependientes.size();i++) {
                        
              /*Añade los nuevos ficheros a la tarea dependiente y a la dependencia.
               Para añadir los ficheros a la tarea dependientes previamente ha de transformar los ficheros de salida a entrada*/
                        aux.anadeFichero((Fichero)ficheros_dependientes.get(i));
                        tarea2.anadeFicheroEntrada(((Fichero)ficheros_dependientes.get(i)).convertirDeSalidaAEntrada());
                    }
                }
            }
            
        }
        
        );
        
        popupDependencia.add(menuItem);
        
        
        //////////////////////////////////////////////////////////////////////////////////////////
        
        
        
        
    }
    
    
    public void mouseClicked(MouseEvent e) {
        
        x = e.getX();
        y = e.getY();
        
        
        
        DefaultGraphCell cell = (DefaultGraphCell)interfaz.graph.getSelectionCellAt(new Point2D.Double(x, y));
        String name = new String();
        
        if (cell == null) {
            this.interfaz.interfaz.habilitarBorrarDep(false);
            if (this.interfaz.nodo1 != null) {
                
                this.interfaz.deSeleccionar(this.interfaz.nodo1,null);
                
                
                
            }
            
            if (e.getButton() == e.BUTTON3)
                popupGrafo.show(e.getComponent(), e.getX(), e.getY());
            
            this.interfaz.interfaz.imprimirMensajeBarra("",false,null);
            
            this.interfaz.interfaz.habilitarBorrarDep(cell != null && cell instanceof DefaultEdge);
            this.interfaz.interfaz.habilitarBorrarTask(false);
            this.interfaz.interfaz.habilitarCerrarWorkFlow(true);
            this.interfaz.interfaz.habilitarCrearDep(true);
            this.interfaz.interfaz.habilitarCrearNuevoWorkFlow(true);
            this.interfaz.interfaz.habilitarCrearTarea(true);
            this.interfaz.interfaz.creando_dependencia = false;
            this.interfaz.nodo1 = this.interfaz.nodo2 = null;
            this.interfaz.nodo1seleccionado = false;
            return;
            
        }
        
        if (e.getButton() == e.BUTTON3 && cell != null && !(cell instanceof DefaultEdge)) {
            this.interfaz.seleccionado = cell;
            this.interfaz.interfaz.habilitarBorrarTask(true);
            this.interfaz.interfaz.habilitarBorrarDep(false);
            this.interfaz.deSeleccionarTodos();
            
            this.interfaz.interfaz.creando_dependencia = false;
            this.interfaz.nodo1 = this.interfaz.nodo2 = null;
            this.interfaz.nodo1seleccionado = false;
            this.interfaz.interfaz.imprimirMensajeBarra("",false,null);
            
  
            popupTarea.show(e.getComponent(), e.getX(), e.getY());
            
            return;
            
        }
        
        if (e.getButton() == e.BUTTON3 && cell != null && (cell instanceof DefaultEdge)) {
            this.interfaz.dependencia = (DefaultEdge) cell;
            this.interfaz.interfaz.habilitarBorrarTask(false);
            this.interfaz.interfaz.habilitarBorrarDep(true);
            this.interfaz.deSeleccionarTodos();
            
            this.interfaz.interfaz.creando_dependencia = false;
            this.interfaz.nodo1 = this.interfaz.nodo2 = null;
            this.interfaz.nodo1seleccionado = false;
            this.interfaz.interfaz.imprimirMensajeBarra("",false,null);
            
            popupDependencia.show(e.getComponent(), e.getX(), e.getY());
            
            return;
            
            
        }
        
        else if (e.getButton() == e.BUTTON1 &&
                (e.getClickCount() == 1) && cell != null && !(cell instanceof DefaultEdge)) {
            this.interfaz.seleccionado = cell;
            this.interfaz.interfaz.habilitarBorrarTask(true);
            this.interfaz.interfaz.habilitarBorrarDep(false);
            this.interfaz.deSeleccionarTodos();
        }
        
        else if (e.getButton() == e.BUTTON1 && e.getClickCount() == 2 && cell != null && !(cell instanceof DefaultEdge)) {
            this.interfaz.seleccionado = cell;
            this.interfaz.interfaz.habilitarBorrarTask(true);
            this.interfaz.interfaz.habilitarBorrarDep(false);
            this.interfaz.deSeleccionarTodos();
            
            Tarea tarea = this.interfaz.getTarea(cell.toString());
            String nameaux = tarea.nombre;
            
            TaskEditorDialog dialogoedicion = new TaskEditorDialog((Frame) this.interfaz.interfaz, true,interfaz.interfaz,tarea,interfaz.interfaz.conexion);
            
            dialogoedicion.setVisible(true);
            
            while(true) {
                if (dialogoedicion.aceptar == true) {
                    
                    if (this.interfaz.setName(dialogoedicion.getName(),nameaux,cell) == true) {
                        dialogoedicion.setTaskParametersFromDialog(tarea);
                        break;
                    } else {
                        dialogoedicion.aceptar = false;
                        dialogoedicion.setVisible(true);
                        
                    }
                    
                }
                
                else {
                    this.interfaz.seleccionado = null;
                    this.interfaz.interfaz.habilitarBorrarTask(false);
                    this.interfaz.deSeleccionarTodos();
                    break;
                }
                
            }
            
            
            
        }
        
        
        /*Se hace doble click sobre una dependencia en el grafo*/
        
        else if (e.getButton() == e.BUTTON1 && e.getClickCount() == 2 && cell != null && (cell instanceof DefaultEdge)) {
            
            
            this.interfaz.seleccionado = null;
            this.interfaz.dependencia = (DefaultEdge) cell;
            this.interfaz.interfaz.habilitarBorrarTask(false);
            this.interfaz.interfaz.habilitarBorrarDep(true);
            this.interfaz.deSeleccionarTodos();
            
            Dependencia aux = interfaz.getDependencyObject(interfaz.getDependencia().toString());
            
            Tarea tarea1 = aux.tarea1;
            Tarea tarea2 = aux.tarea2;
            
            ArrayList ficheros_dependientes = new ArrayList();
            
            for (int i = 0;i<tarea1.ficherosSalida.size();i++) {
                Fichero fichero = (Fichero)tarea1.ficherosSalida.get(i);
                if (tarea2.contieneFicheroEntrada(fichero) == true)
                    ficheros_dependientes.add(fichero);
            }
            
            EditorDependenciaDialog dialog = new EditorDependenciaDialog(interfaz.interfaz,true,tarea1.ficherosSalida,ficheros_dependientes);
            
            
            ficheros_dependientes = new ArrayList();
            dialog.setVisible(true);
            
            if (dialog.aceptar == true) {
                ficheros_dependientes = dialog.getSelectedFiles();
                
                
                
                
                ArrayList ficheros_antiguos = aux.obtieneFicheros();
                
                for (int i = 0;i< ficheros_antiguos.size();i++) {
                    tarea2.eliminaFicheroEntrada((Fichero)ficheros_antiguos.get(i)); //Elimina los ficheros dependientes de la tarea 2
                }
                
                aux.eliminaTodos(); //Elimina los ficheros de la dependencia
                
                for (int i = 0;i<ficheros_dependientes.size();i++) {
                    
              /*Añade los nuevos ficheros a la tarea dependiente y a la dependencia.
               Para añadir los ficheros a la tarea dependientes previamente ha de transformar los ficheros de salida a entrada*/
                    aux.anadeFichero((Fichero)ficheros_dependientes.get(i));
                    tarea2.anadeFicheroEntrada(((Fichero)ficheros_dependientes.get(i)).convertirDeSalidaAEntrada());
                }
                
            }
            
        }
        
        if ( (e.getClickCount() == 1 || e.getClickCount() == 2) && cell != null && cell instanceof DefaultEdge) {
            this.interfaz.dependencia = (DefaultEdge)cell;
            this.interfaz.interfaz.habilitarBorrarDep(true);
            
            return;
        }
        
        
        
        if (e.getButton() == e.BUTTON1 &&
                e.getClickCount() == 1 && this.interfaz.interfaz.creando_dependencia) {
            
            
            if (this.interfaz.nodo1seleccionado == true) {
                if (cell != null && !(cell instanceof DefaultEdge)) {
                    this.interfaz.nodo2 = cell;
                    
                    
                    if (this.interfaz.nodo1 == this.interfaz.nodo2 ||
                            this.interfaz.existeConexion(this.interfaz.nodo1,this.interfaz.nodo2) ||
                            this.interfaz.existeConexion(this.interfaz.nodo2,this.interfaz.nodo1)
                            ) {
                        this.interfaz.nodo1seleccionado = false;
                        
                        this.interfaz.deSeleccionar(this.interfaz.nodo1,null);
                        
                        
                        this.interfaz.nodo1 = this.interfaz.nodo2 = null;
                        this.interfaz.interfaz.creando_dependencia = false;this.interfaz.interfaz.imprimirMensajeBarra("",false,null);
                        
                        return;
                    }
                    
                    
                    this.interfaz.interfaz.imprimirMensajeBarra("Select destination task",true,new Color(0,255,0));
                    
                    this.interfaz.seleccionar(cell);
                    
                    this.interfaz.interfaz.imprimirMensajeLog(cell.toString()+ " selected");
                    
                    
                    
                    try {
                        
                        
                        Thread.sleep(500);
                        
                        
                    } catch (InterruptedException ex) {
                        ex.printStackTrace();
                    }
                    
                    this.interfaz.interfaz.imprimirMensajeBarra("Dependency created",true,new Color(0,255,0));
                    this.interfaz.interfaz.imprimirMensajeLog("Dependency between: "+this.interfaz.nodo1.toString()+" and "+this.interfaz.nodo2.toString()+" has been created");
                    try {
                        
                        
                        Thread.sleep(500);
                        
                        
                    } catch (InterruptedException ex) {
                        ex.printStackTrace();
                    }
                    
                    this.interfaz.deSeleccionar(this.interfaz.nodo1,this.interfaz.nodo2);
                    
                    Tarea tarea1 = this.interfaz.getTarea(this.interfaz.nodo1.toString());
                    
                    
                    ArrayList ficheros_dependientes = new ArrayList();
                    
                    if (tarea1.ficherosSalida.size() > 0) {
                        SelectorFicheros dialog = new SelectorFicheros(this.interfaz.interfaz,true,tarea1.ficherosSalida);
                        
                        dialog.setVisible(true);
                        
                        ficheros_dependientes = dialog.getSelectedFiles();
                        
                        
                        
                        
                        
                        
                    }
                    
                    
                    
                    
                    
                    
                    this.interfaz.crearDependencia(this.interfaz.nodo1.toString(),this.interfaz.nodo2.toString(),ficheros_dependientes);
                    
                    
                    this.interfaz.nodo1 = this.interfaz.nodo2 = null;
                    this.interfaz.nodo1seleccionado = false;
                    this.interfaz.interfaz.creando_dependencia = false;
                    
                    this.interfaz.interfaz.treePanel.addObject((DefaultMutableTreeNode) this.interfaz.interfaz.tree_workflow_actual.getChildAt(1), "Dep"+this.interfaz.depcounter);
                    this.interfaz.interfaz.treePanel.repaint();
                    
                    this.interfaz.interfaz.imprimirMensajeBarra("",false,new Color(0,0,0));
                    
                    this.interfaz.interfaz.habilitarBorrarDep(cell != null && cell instanceof DefaultEdge);
                    this.interfaz.interfaz.habilitarBorrarTask(false);
                    this.interfaz.interfaz.habilitarCerrarWorkFlow(true);
                    this.interfaz.interfaz.habilitarCrearDep(true);
                    this.interfaz.interfaz.habilitarCrearNuevoWorkFlow(true);
                    this.interfaz.interfaz.habilitarCrearTarea(true);
                    
                }
                
                else {
                    /*Si la selección de tareas para la creación de dependencias se interrumpe seleccionando otro objeto
                     que no sea una tarea o bien pinchando fuera hay que restaurar todo lo hecho anteriormente, es decir
                     habilitar los menus y botones necesarios.*/
                    
                    this.interfaz.interfaz.habilitarBorrarDep(cell != null && cell instanceof DefaultEdge);
                    this.interfaz.interfaz.habilitarBorrarTask(false);
                    this.interfaz.interfaz.habilitarCerrarWorkFlow(true);
                    this.interfaz.interfaz.habilitarCrearDep(true);
                    this.interfaz.interfaz.habilitarCrearNuevoWorkFlow(true);
                    this.interfaz.interfaz.habilitarCrearTarea(true);
                }
            }
            
            
            else {
                
                
                if (cell != null && !(cell instanceof DefaultEdge)) {
                    this.interfaz.nodo1 = cell;
                    
                    this.interfaz.nodo1seleccionado = true;
                    
                    this.interfaz.seleccionar(cell);
                    
                    this.interfaz.interfaz.imprimirMensajeBarra("Select Destination task",true,new Color(255,0,0));
                    this.interfaz.interfaz.imprimirMensajeLog(cell.toString()+" selected");
                    
                    
                } else {
                    this.interfaz.nodo1 = this.interfaz.nodo2 = null;
                    this.interfaz.nodo1seleccionado = false;
                    this.interfaz.interfaz.creando_dependencia = false;
                    
                    
                    this.interfaz.interfaz.imprimirMensajeBarra("",false,new Color(255,0,0));
                }
                
            }
            
        }
        
        
        
        this.interfaz.dependencia = null;
        
        
    }
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
}
