/*
 * RemoteFileDialog.java
 *
 * Created on 20 de octubre de 2007, 18:44
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import com.jscape.inet.sftp.SftpException;
import java.awt.Dimension;
import java.awt.Frame;

import java.awt.HeadlessException;
import java.awt.Toolkit;
import javax.swing.*;
import java.io.File;
import java.awt.Color;
import java.util.Vector;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Cursor;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import java.awt.GridLayout;
/**
 *
 * @author  rayban
 */
public class RemoteFileDialog extends javax.swing.JDialog {
    
    public boolean aceptar = false;
    public static int DIRECTORIES_ONLY = 0;
    public static int FILES_AND_DIRECTORIES = 1;
    public static boolean MULTIPLE_SELECTION = false;
    public int showing = 1;
    public boolean ctrlPressed = false;
    public File current = null;
    public File selectedFile;
    public Vector selectedFiles = new Vector();
    public Vector directories = new Vector();
    public Vector files = new Vector();
    final Frame parent;
    final EsperaDialog dialogo_espera;
    
    boolean copiar = false;
    
    String currentFilter = "*";
    int accessoryInstalled = 0;
    SecureFTP conexion = null;
    public final static String SELECTED_FILE_CHANGED_PROPERTY = "file changed";
    
    boolean entrada;
    
    public RemoteFileDialog(Frame parent,SecureFTP conexion,Vector filters, boolean multiple,int showing) throws SftpException {
        super(parent,true);
        this.initComponents();
        if (conexion == null)
            throw new SftpException("Connection invalid!");
        
        this.conexion = conexion;
        
        
        
        this.conexion.setHomePath();
        
        File directory = this.conexion.getActualDir();
        this.current = directory;
        
        this.showing = showing;
        this.MULTIPLE_SELECTION = multiple;
        this.parent = parent;
        setResizable(false);
        
        
        
        this.jPathTextField.setText(directory.getPath());
        
        
        
        this.jPanel1.setBackground(Color.white);
        
        
        this.jPanel1.setLayout(new BoxLayout(this.jPanel1, BoxLayout.Y_AXIS));
        this.jPanel1.setBackground(Color.white);
        //scroller = new JScrollPane(jScrollPane1, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        //getContentPane().add(scroller);        //setModal(true);
        /*
        GridLayout layout = new GridLayout(2,2,0,0);
        pathPanel.setLayout(layout);
        pathPanel.add(new JLabel("Path:"));
        pathPanel.add(jPathTextField);
         */
        
        
        
        
        
        
        setLocation(findScreenCenter());
        
        //pathPanel.setMinimumSize(new java.awt.Dimension(280, 60));
        //pathPanel.setPreferredSize(new java.awt.Dimension(280, 60));
        jPathTextField.setMinimumSize(new java.awt.Dimension(245, 25));
        jPathTextField.setPreferredSize(new java.awt.Dimension(245, 25));
        jPathTextField.setMaximumSize(new java.awt.Dimension(245, 25));
        
        
        //getContentPane().setBackground(Color.white);
        
        dialogo_espera = new EsperaDialog(parent, true);
        
        
        Runnable hilo = new Runnable() {
            
            public  void run() {
                try {
                    dialogo_espera.imprimirMensaje("Loading...");
                    setupFiles("*");
                    
                    dialogo_espera.setVisible(false);
                    
                } catch (SftpException ex) {
                    ex.printStackTrace();
                    
                    
                    dialogo_espera.setVisible(false);
                    salir();
                    
                }
            }
        };
        
        
        
        Thread init_hilo = new Thread(hilo);
        init_hilo.start();
        
        dialogo_espera.setVisible(true);
        
        if (showing == this.DIRECTORIES_ONLY) {
            selectedFile = this.conexion.getActualDir();
            
            this.jButtonAceptar.setEnabled(true);
        }
        //setupFiles("*");
        
        
        
        //filter.setSelectedIndex(1);
        //show();
    }
    
    public RemoteFileDialog(JFrame parent,String ftpHostname, String ftpUserName,
            String ftpPasswd, Vector filters, boolean multiple, int showing) throws SftpException {
        
        super(parent, true);
        
        
        this.initComponents();
        
        
        
        if (ftpHostname != null && ftpUserName != null && ftpPasswd != null) {
            
            this.conexion = new SecureFTP(parent,ftpHostname,ftpUserName,ftpPasswd);
            
        }
        
        File directory = this.conexion.getActualDir();
        this.current = directory;
        
        this.showing = showing;
        this.MULTIPLE_SELECTION = multiple;
        this.parent = parent;
        setResizable(false);
        
        
        
        this.jPathTextField.setText(directory.getPath());
        
        
        
        this.jPanel1.setBackground(Color.white);
        
        
        this.jPanel1.setLayout(new BoxLayout(this.jPanel1, BoxLayout.Y_AXIS));
        this.jPanel1.setBackground(Color.white);
        //scroller = new JScrollPane(jScrollPane1, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        //getContentPane().add(scroller);        //setModal(true);
        /*
        GridLayout layout = new GridLayout(2,2,0,0);
        pathPanel.setLayout(layout);
        pathPanel.add(new JLabel("Path:"));
        pathPanel.add(jPathTextField);
         */
        
        
        
        
        
        
        setLocation(findScreenCenter());
        
        //pathPanel.setMinimumSize(new java.awt.Dimension(280, 60));
        //pathPanel.setPreferredSize(new java.awt.Dimension(280, 60));
        jPathTextField.setMinimumSize(new java.awt.Dimension(245, 25));
        jPathTextField.setPreferredSize(new java.awt.Dimension(245, 25));
        jPathTextField.setMaximumSize(new java.awt.Dimension(245, 25));
        
        
        //getContentPane().setBackground(Color.white);
        
        dialogo_espera = new EsperaDialog(parent, true);
        
        
        Runnable hilo = new Runnable() {
            
            public  void run() {
                try {
                    dialogo_espera.imprimirMensaje("Loading...");
                    setupFiles("*");
                    
                    dialogo_espera.setVisible(false);
                    
                } catch (SftpException ex) {
                    ex.printStackTrace();
                    
                    dialogo_espera.setVisible(false);
                    
                    salir();
                }
            }
        };
        
        
        
        Thread init_hilo = new Thread(hilo);
        init_hilo.start();
        
        dialogo_espera.setVisible(true);
        
        
        
        //setupFiles("*");
        
        
        
        //filter.setSelectedIndex(1);
        //show();
        
    }
    
    
    public File getCurrentDirectory() {
        return current;
    }
    
    /**
     * Return the selected file
     */
    public File getSelectedFile() {
        return selectedFile;
    }
    
    /**
     * Return an array of selected files.
     *
     * @return File[] selectedFiles File the user has selected
     */
    public File[] getSelectedFiles() {
        File[] orderedFiles = new File[selectedFiles.size()];
        for (int x=0; x<selectedFiles.toArray().length; x++) {
            orderedFiles[x] = (File)selectedFiles.elementAt(x);
        }
        return orderedFiles;
    }
    /**
     * Enables multiple selections.
     */
    public void setMultipleSelection(boolean enabled) {
        this.MULTIPLE_SELECTION = true;
    }
    /**
     * Locate the center of the frame we're attached to.
     */
    private java.awt.Point findScreenCenter() {
        java.awt.Point fin = new java.awt.Point(0, 0);
        if (parent != null) {
            
            Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
            Dimension window = this.getSize();
            
            //setLocation((screen.width - window.width) / 2, (screen.height - window.height) / 2);
            
            fin.x = (screen.width - window.width) / 2;
            fin.y = (screen.height - window.height) / 2;
            
        }
        
        return fin;
    }
    
    /**
     * Load the files in the directory we chose.
     */
    public void setupFiles(String filters) throws SftpException {
        //File[] listing = current.listFiles();
        
        File[] listing = this.conexion.getListing();
        directories.removeAllElements();
        files.removeAllElements();
        try {
            sortNames(listing);
        } catch (NullPointerException e) {
            this.current = this.conexion.getActualDir();
            this.jPathTextField.setText(current.getAbsolutePath());
            File[] fixedListing = current.listFiles();
            listing = fixedListing;
            sortNames(fixedListing);
        }
        ImageIcon labelImage = null;
        int numDir = 0;
        int numFile = 0;
        for (int x=0; x<listing.length;x++) {
            if (this.conexion.isaDirectory(listing[x])) {
                numDir++;
                //System.out.println("Labeling directory... " + numDir);
                directories.add(numDir - 1, listing[x]);
                
                
            } else if (this.conexion.isaDirectory(listing[x]) == false) {
                if (!currentFilter.equals("*")) {
                    if (listing[x].getName().toLowerCase().endsWith(currentFilter)) {
                        numFile++;
                        //System.out.println("Labeling file...");
                        files.add(numFile - 1 , listing[x]);
                    }
                } else {
                    numFile++;
                    //System.out.println("Labeling file...");
                    files.add(numFile - 1 , listing[x]);
                }
            }
            
            this.dialogo_espera.imprimirMensaje(listing[x].toString());
        }
        
        paintGraphics();
    }
    
    
    public void salir() {
        this.setVisible(false);
    }
    public void paintGraphics() {
        sortNames(directories);
        directories.add(0, new File(".."));
        //southPanel.removeAll();
        
        this.jPanel1.removeAll();
        sortNames(files);
        
        for (int x=0; x<directories.size(); x++) {
            ImageIcon labelImage = new ImageIcon(getClass().getResource("images/folder_closed.png"));
            JLabel label = new JLabel(((File)directories.elementAt(x)).getName(), labelImage, SwingConstants.LEFT);
            final JLabel flabel = label;
            label.addMouseListener(new MouseAdapter() {
                public void mouseEntered(MouseEvent e) {
                    flabel.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
                    System.out.println("Inside folder");
                    flabel.repaint();
                }
                public void mouseExited(MouseEvent e) {
                    flabel.setCursor(Cursor.getDefaultCursor());
                    System.out.println("Outside folder");
                }
                public void mouseClicked(MouseEvent e)  {
                    
                    if (showing == DIRECTORIES_ONLY) {
                        
                        if (e.getClickCount() == 2 &&
                                flabel.getText().equals("..")) {
                            if (conexion.getParent() == null) {
                                
                            } else {
                                //String tmpString = gotofile.getAbsolutePath().substring(0, gotofile.getAbsolutePath().lastIndexOf(File.separator));
                                //jPathTextField.setText(tmpString);
                                jPathTextField.setText(conexion.getParent().getPath());
                                
                                current = conexion.getParent();
                                conexion.setDirUp();
                                
                                
                                Runnable hilo = new Runnable() {
                                    
                                    public  void run() {
                                        try {
                                            dialogo_espera.imprimirMensaje("Loading...");
                                            setupFiles("*");
                                            
                                            dialogo_espera.setVisible(false);
                                            
                                        } catch (SftpException ex) {
                                            ex.printStackTrace();
                                            
                                            JOptionPane.showMessageDialog(parent, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                                            dialogo_espera.setVisible(false);
                                            
                                            
                                        }
                                    }
                                };
                                
                                
                                
                                Thread init_hilo = new Thread(hilo);
                                init_hilo.start();
                                
                                dialogo_espera.setVisible(true);
                                
                                
                            }
                        } else if (e.getClickCount() == 2){
                            File newFile = new File(current.getAbsolutePath() + ""+File.separator +""+ flabel.getText());
                            
                            /*
                            jPathTextField.setText(gotofile.getAbsolutePath());
                            current = gotofile;
                            setupFiles(currentFilter);
                             */
                            //if (showing == DIRECTORIES_ONLY) {
                            //System.out.println("We're only showing directories!");
                            /*
                            if (newFile.listFiles().length != 0) {
                             
                            boolean moreDir = false;
                            for (int x=0; x<newFile.listFiles().length; x++) {
                            if (newFile.listFiles()[x].isDirectory()) {
                            moreDir = true;
                            //System.out.println("There is another directory here...");
                            }
                            }
                            if (moreDir == true) {
                            jPathTextField.setText(current.getAbsolutePath() + File.separator + flabel.getText());
                            current = new File(current.getAbsolutePath() + File.separator + flabel.getText());
                            setupFiles(currentFilter);
                            } else {
                            selectedFile = newFile;
                            hide();
                            }
                            } else {
                            selectedFile = newFile;
                            hide();
                            }
                             */
                            //} else {
                            //System.out.println("We're showing files and directories!");
                            jPathTextField.setText(current.getAbsolutePath() + File.separator + flabel.getText());
                            
                            
                            
                            try {
                                conexion.setDir(current.getAbsolutePath() + File.separator + flabel.getText());
                                
                            }catch(SftpException ex) {
                                
                                JOptionPane.showMessageDialog(parent, "An error was found while obtaining remote folders from remote server", "Error", JOptionPane.ERROR_MESSAGE);
                                if (conexion.isConnected() == false) {
                                    JOptionPane.showMessageDialog(parent, "We are disconnected from remote server", "Error", JOptionPane.ERROR_MESSAGE);
                                    
                                    setVisible(false);
                                }
                            }
                            
                            current = new File(current.getAbsolutePath() + File.separator + flabel.getText());
                            
                            
                            
                            
                            Runnable hilo = new Runnable() {
                                
                                public  void run() {
                                    try {
                                        dialogo_espera.imprimirMensaje("Loading...");
                                        setupFiles("*");
                                        
                                        dialogo_espera.setVisible(false);
                                        
                                    } catch (SftpException ex) {
                                        ex.printStackTrace();
                                        
                                        JOptionPane.showMessageDialog(parent, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                                        dialogo_espera.setVisible(false);
                                        
                                        
                                    }
                                }
                            };
                            
                            
                            
                            Thread init_hilo = new Thread(hilo);
                            init_hilo.start();
                            
                            dialogo_espera.setVisible(true);
                            
                            //}
                            
                        }
                        
                        else if (e.getClickCount() == 1 && flabel.getText().compareTo("..") != 0) {
                            selectedFile = new File(current.getAbsolutePath()+ ""+File.separator +""+ flabel.getText());
                            jPathTextField.setText(selectedFile.getPath());
                            if (conexion.isaDirectory(selectedFile.getPath()) == true)
                                jButtonAceptar.setEnabled(true);
                            else
                                jButtonAceptar.setEnabled(false);
                        }
                    }
                    
                    else {
                        if (flabel.getText().equals("..")) {
                            if (conexion.getParent() == null) {
                                
                            } else {
                                //String tmpString = gotofile.getAbsolutePath().substring(0, gotofile.getAbsolutePath().lastIndexOf(File.separator));
                                //jPathTextField.setText(tmpString);
                                jPathTextField.setText(conexion.getParent().getPath());
                                
                                current = conexion.getParent();
                                conexion.setDirUp();
                                PantallaEspera waitscreen = new PantallaEspera((JFrame) parent);
                                
                                
                                
                                
                                Runnable hilo = new Runnable() {
                                    
                                    public  void run() {
                                        try {
                                            dialogo_espera.imprimirMensaje("Loading...");
                                            setupFiles("*");
                                            
                                            dialogo_espera.setVisible(false);
                                            
                                        } catch (SftpException ex) {
                                            ex.printStackTrace();
                                            
                                            JOptionPane.showMessageDialog(parent, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                                            dialogo_espera.setVisible(false);
                                            
                                            
                                        }
                                    }
                                };
                                
                                
                                
                                Thread init_hilo = new Thread(hilo);
                                init_hilo.start();
                                
                                dialogo_espera.setVisible(true);
                                
                                
                                
                            }
                        } else {
                            File newFile = new File(current.getAbsolutePath() + ""+File.separator +""+ flabel.getText());
                            
                            /*
                            jPathTextField.setText(gotofile.getAbsolutePath());
                            current = gotofile;
                            setupFiles(currentFilter);
                             */
                            //if (showing == DIRECTORIES_ONLY) {
                            //System.out.println("We're only showing directories!");
                            /*
                            if (newFile.listFiles().length != 0) {
                             
                            boolean moreDir = false;
                            for (int x=0; x<newFile.listFiles().length; x++) {
                            if (newFile.listFiles()[x].isDirectory()) {
                            moreDir = true;
                            //System.out.println("There is another directory here...");
                            }
                            }
                            if (moreDir == true) {
                            jPathTextField.setText(current.getAbsolutePath() + File.separator + flabel.getText());
                            current = new File(current.getAbsolutePath() + File.separator + flabel.getText());
                            setupFiles(currentFilter);
                            } else {
                            selectedFile = newFile;
                            hide();
                            }
                            } else {
                            selectedFile = newFile;
                            hide();
                            }
                             */
                            //} else {
                            //System.out.println("We're showing files and directories!");
                            jPathTextField.setText(current.getAbsolutePath() + File.separator + flabel.getText());
                            
                            
                            
                            try {
                                conexion.setDir(current.getAbsolutePath() + File.separator + flabel.getText());
                                
                            }catch(SftpException ex) {
                                
                                JOptionPane.showMessageDialog(parent, "An error was found while obtaining remote folders from remote server", "Error", JOptionPane.ERROR_MESSAGE);
                                if (conexion.isConnected() == false) {
                                    JOptionPane.showMessageDialog(parent, "We are disconnected from remote server", "Error", JOptionPane.ERROR_MESSAGE);
                                    
                                    setVisible(false);
                                }
                            }
                            
                            current = new File(current.getAbsolutePath() + File.separator + flabel.getText());
                            
                            
                            
                            
                            Runnable hilo = new Runnable() {
                                
                                public  void run() {
                                    try {
                                        dialogo_espera.imprimirMensaje("Loading...");
                                        setupFiles("*");
                                        
                                        dialogo_espera.setVisible(false);
                                        
                                    } catch (SftpException ex) {
                                        ex.printStackTrace();
                                        
                                        JOptionPane.showMessageDialog(parent, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                                        dialogo_espera.setVisible(false);
                                        
                                        
                                    }
                                }
                            };
                            
                            
                            
                            Thread init_hilo = new Thread(hilo);
                            init_hilo.start();
                            
                            dialogo_espera.setVisible(true);
                            
                            
                            
                            
                        }
                        
                        
                    }
                    
                    
                }
            });
            
            label.setOpaque(false);
            this.jPanel1.add(label);
            
            //jScrollPane1.validate();
        }
        if (this.showing == FILES_AND_DIRECTORIES) { // Check to make sure we're even showing files
            for (int y=0; y<files.size(); y++) {
                if (((File)files.elementAt(y)).getName().startsWith(".") == true) //No muestra archivos ocultos
                    continue;
                
                ImageIcon labelImage = new ImageIcon(getClass().getResource("images/file_icon.gif"));
                JLabel label2 = new JLabel(((File)files.elementAt(y)).getName(), labelImage, SwingConstants.LEFT);
                final JLabel flabel2 = label2;
                label2.addMouseListener(new MouseAdapter() {
                    
                    public void mouseEntered(MouseEvent e) {
                        flabel2.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
                        flabel2.validate();
                    }
                    public void mouseExited(MouseEvent e) {
                        flabel2.setCursor(Cursor.getDefaultCursor());
                        if (!MULTIPLE_SELECTION || (MULTIPLE_SELECTION && !ctrlPressed)) {
                            flabel2.setBorder(null);
                            if (selectedFiles.contains(e.getComponent())) {
                                
                            }
                        }
                        flabel2.validate();
                    }
                    
                    public void mouseClicked(MouseEvent e) {
                        if (!MULTIPLE_SELECTION || (MULTIPLE_SELECTION && !ctrlPressed)) {
                            if (e.getClickCount() == 1 || e.getClickCount() == 2) {
                                selectedFile = new File(current.getAbsolutePath() + ""+File.separator +""+ flabel2.getText());
                                //System.out.println("Clicked on " + selectedFile.getAbsolutePath());
                                //setVisible(false);
                                jPathTextField.setText(selectedFile.getPath());
                                if (conexion.isaDirectory(selectedFile.getPath()) == true)
                                    jButtonAceptar.setEnabled(false);
                                else
                                    jButtonAceptar.setEnabled(true);
                                
                                flabel2.validate();
                            }
                            
                        } else if (MULTIPLE_SELECTION && ctrlPressed) {
                            flabel2.setBorder(BorderFactory.createLineBorder(Color.red, 2));
                            File clickedFile = new File(current.getAbsolutePath() + File.separator + flabel2.getText());
                            selectedFiles.addElement(clickedFile);
                            
                            
                        }
                    }
                    
                });
                
                label2.setOpaque(false);
                this.jPanel1.add(label2);
                //this.jPanel1.validate();
                
            }
        }
        this.jPanel1.validate();
        this.jScrollPane1.validate();
        getContentPane().validate();
    }
    
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Código Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonGroup1 = new javax.swing.ButtonGroup();
        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel1 = new javax.swing.JPanel();
        jButtonAceptar = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPathTextField = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Remote browser");
        setAlwaysOnTop(true);
        setResizable(false);
        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 618, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 235, Short.MAX_VALUE)
        );
        jScrollPane1.setViewportView(jPanel1);

        jButtonAceptar.setText("Accept");
        jButtonAceptar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jAceptarMouseClicked(evt);
            }
        });

        jButton2.setText("Cancel");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jCancelarMouseClicked(evt);
            }
        });

        jPathTextField.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                jPathTextFieldPropertyChange(evt);
            }
        });
        jPathTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jPathTextFieldKeyTyped(evt);
            }
        });

        jLabel1.setText("Path:");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(116, 116, 116)
                .add(jButtonAceptar)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 210, Short.MAX_VALUE)
                .add(jButton2)
                .add(145, 145, 145))
            .add(layout.createSequentialGroup()
                .add(29, 29, 29)
                .add(jLabel1)
                .add(24, 24, 24)
                .add(jPathTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                .addContainerGap())
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 621, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 238, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(33, 33, 33)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jPathTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel1))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 15, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButtonAceptar)
                    .add(jButton2))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
                
    private void jPathTextFieldKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jPathTextFieldKeyTyped
        
        if (evt.getKeyChar() == evt.VK_ENTER) {
            
            File aux = new File(this.jPathTextField.getText());
            
            if (conexion.exists(aux.getPath()) == false) {
                this.jButtonAceptar.setEnabled(false);
                return;
            }
            
            this.selectedFile = current = aux;
            
            if (showing == this.DIRECTORIES_ONLY) {
                if (conexion.isaDirectory(current))
                    this.jButtonAceptar.setEnabled(true);
                else
                    this.jButtonAceptar.setEnabled(false);
            } else if (showing == this.FILES_AND_DIRECTORIES) {
                if (conexion.isaDirectory(current))
                    this.jButtonAceptar.setEnabled(false);
                else
                    this.jButtonAceptar.setEnabled(true);
            }
        }
    }//GEN-LAST:event_jPathTextFieldKeyTyped
    
    private void jPathTextFieldPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jPathTextFieldPropertyChange
        
        if (this.conexion != null &&
                this.conexion.isaDirectory(this.jPathTextField.getText()) == false) //Es fichero
            this.jButtonAceptar.setEnabled(true);
        else
            this.jButtonAceptar.setEnabled(false);
    }//GEN-LAST:event_jPathTextFieldPropertyChange
    
    private void jCancelarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCancelarMouseClicked
        
        this.aceptar = false;
        this.setVisible(false);
    }//GEN-LAST:event_jCancelarMouseClicked
    
    private void jAceptarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jAceptarMouseClicked
        
        if (this.jButtonAceptar.isEnabled() == false)
            return;
        
        this.aceptar = true;
        this.setVisible(false);
    }//GEN-LAST:event_jAceptarMouseClicked
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        RemoteFileDialog dialogo = null;
        try {
            dialogo = new RemoteFileDialog(new javax.swing.JFrame(), "globusdev.dyndns.info", "usuario", "pass", new Vector(), false,FILES_AND_DIRECTORIES);
            
            dialogo.setVisible(true);
            if (dialogo.aceptar == true) {
                System.out.println(dialogo.getSelectedFile().toString());
            }
            
        } catch (HeadlessException ex) {
            ex.printStackTrace();
        } catch (SftpException ex) {
            ex.printStackTrace();
        }
        
        
        
        
    }
    
    
    public void sortNames(Object[] names) {
        // Sort array of Files into ascending sequence
        boolean noswap = true;
        
        while(noswap) {
            noswap = false;
            // iterate through array of strings
            for(int i=0; i<names.length-1;i++) {
                // compare names
                if(((File)names[i]).getAbsolutePath().toUpperCase().compareTo(((File)names[i+1]).getAbsolutePath().toUpperCase())>0) {
                    // swap elements.
                    File tempFile = (File)names[i+1];
                    names[i+1] = new File(((File)names[i]).getAbsolutePath());
                    names[i] = new File(tempFile.getAbsolutePath());
                    noswap=true;
                }
            }
            
        }
        
        
    }
    
    
    
    public void sortNames(Vector names) {
        Object[] array = names.toArray();
        sortNames(array);
        names.removeAllElements();
        for (int x=0; x<array.length; x++) {
            names.add(x, array[x]);
        }
    }
    
    // Declaración de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButtonAceptar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTextField jPathTextField;
    private javax.swing.JScrollPane jScrollPane1;
    // Fin de declaración de variables//GEN-END:variables
    
}
