/*
 * SSHConfigurationDialog.java
 *
 * Created on 22 de octubre de 2007, 13:51
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import com.jscape.inet.sftp.SftpException;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;
import java.net.MalformedURLException;
import java.net.URL;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

/**
 *
 * @author  rayban
 */
public class SSHConfigurationDialog extends javax.swing.JDialog {
    
    /** Creates new form SSHConfigurationDialog */
    JFrame parent;
    boolean aceptar = false;
    
    SecureFTP conexion = null;
    SSHConfigurationDialog This;
    public SSHConfigurationDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        this.parent = (JFrame) parent;
        initComponents();
        This = this;
        setLocation(findScreenCenter());
    }
    
    
    private java.awt.Point findScreenCenter() {
        java.awt.Point fin = new java.awt.Point(0, 0);
        if (parent != null) {
            
            Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
            Dimension window = this.getSize();
            
            //setLocation((screen.width - window.width) / 2, (screen.height - window.height) / 2);
            
            fin.x = (screen.width - window.width) / 2;
            fin.y = (screen.height - window.height) / 2;
            
        }
        
        return fin;
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Código Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        hostTextField = new javax.swing.JTextField();
        usuarioTextField = new javax.swing.JTextField();
        jPasswordField1 = new javax.swing.JPasswordField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Connection parameters");
        setAlwaysOnTop(true);
        hostTextField.setToolTipText("Example: globusdev.dyndns.info");

        jLabel1.setText("Host:");

        jLabel2.setText("User:");

        jLabel3.setText("Password:");

        jButton1.setText("Accept");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jAceptarMouseClicked(evt);
            }
        });

        jButton2.setText("Cancel");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jCancelarMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(24, 24, 24)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(jLabel3)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 22, Short.MAX_VALUE)
                        .add(jPasswordField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 259, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel2)
                            .add(jLabel1))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 53, Short.MAX_VALUE)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, usuarioTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 259, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, hostTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 259, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .add(24, 24, 24))
            .add(layout.createSequentialGroup()
                .add(69, 69, 69)
                .add(jButton1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 83, Short.MAX_VALUE)
                .add(jButton2)
                .add(90, 90, 90))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(35, 35, 35)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(hostTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel1))
                .add(17, 17, 17)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(usuarioTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel2))
                .add(17, 17, 17)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(jPasswordField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 13, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton1)
                    .add(jButton2))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void jCancelarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCancelarMouseClicked
        
        aceptar = false;
        this.setVisible(false);
    }//GEN-LAST:event_jCancelarMouseClicked
    
    private void jAceptarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jAceptarMouseClicked
        
        if (this.hostTextField.getText().compareTo("") == 0) {
            JOptionPane.showMessageDialog(this, "URL no válida", "Error", JOptionPane.ERROR_MESSAGE);
            return;
        }
        if (this.usuarioTextField.getText().compareTo("") == 0) {
            JOptionPane.showMessageDialog(this, "Usuario no válido", "Error", JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        if (new String(this.jPasswordField1.getPassword()).compareTo("") == 0) {
            JOptionPane.showMessageDialog(this, "Contraseña inválida", "Error", JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        
        
        
        final EsperaDialog waiting = new EsperaDialog(parent,true);
        
        Runnable hilo = new Runnable() {
            public void run() {
                try {
                    conexion = new SecureFTP((JFrame) parent, hostTextField.getText(),
                            usuarioTextField.getText(), new String(jPasswordField1.getPassword()));
                    
                    waiting.setVisible(false);
                    
                } catch (SftpException ex) {
                    ex.printStackTrace();
                    waiting.setVisible(false);
                    JOptionPane.showMessageDialog(This, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                    conexion = null;
                    
                    hostTextField.setText("");
                    usuarioTextField.setText("");
                    jPasswordField1.setText("");
                    
                    
                }
            }
            
        };
        
        Thread realizar_conexion = new Thread(hilo);
        realizar_conexion.start(); //Se lanza un hilo que realizará la conexión
        
        
        waiting.setVisible(true);
        
        if (conexion != null)
            JOptionPane.showMessageDialog(this, "Conectado", "Éxito", JOptionPane.INFORMATION_MESSAGE);
        else
            return;
        
        this.aceptar = true;
        this.setVisible(false);
        
    }//GEN-LAST:event_jAceptarMouseClicked
    
    
    public SecureFTP getConexion() {
        return this.conexion;
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new SSHConfigurationDialog(new javax.swing.JFrame(), true).setVisible(true);
            }
        });
    }
    
    // Declaración de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JTextField hostTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPasswordField jPasswordField1;
    private javax.swing.JTextField usuarioTextField;
    // Fin de declaración de variables//GEN-END:variables
    
}
