/*
 * SecureFTP.java
 *
 * Created on 19 de octubre de 2007, 23:46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;


import com.jscape.inet.sftp.*;
import com.jscape.inet.sftp.events.*;
import com.jscape.inet.ssh.util.SshParameters;

import ch.ethz.ssh2.Connection;
import ch.ethz.ssh2.Session;
import ch.ethz.ssh2.StreamGobbler;



import java.io.*;
import java.util.ArrayList;
import java.util.Enumeration;
import javax.swing.JFrame;

public class SecureFTP extends SftpAdapter {
    private String ftpHostname;
    private String ftpUsername;
    private String ftpPassword;
    private String homePATH = null;
    private Sftp ftp;
    SshParameters params = null;
    private JFrame parent = null;
    
    /**
     * Creates a new SFtpExample instance.
     * @param ftpHostname the FTP hostname
     * @param ftpUsername the FTP username
     * @param ftpPassword the FTP password
     */
    
    public  String ejecutar(String fichero) throws IOException  {
        
        
        if (ftp.isConnected() == false)
            return null;
        
        Connection conn = new Connection(ftpHostname);
        
        /* Now connect */
        
        conn.connect();
        
                        /* Authenticate.
                         * If you get an IOException saying something like
                         * "Authentication method password not supported by the server at this stage."
                         * then please check the FAQ.
                         */
        
        boolean isAuthenticated = conn.authenticateWithPassword(ftpUsername, this.ftpPassword);
        
        if (isAuthenticated == false)
            throw new IOException("Authentication failed.");
        
        /* Create a session */
        
        Session sess = conn.openSession();
        
        sess.execCommand("echo $GLOBUS_LOCATION");
        
        InputStream stdout = new StreamGobbler(sess.getStdout());
        
        BufferedReader br = new BufferedReader(new InputStreamReader(stdout));
        
        String salida = "";
        String globus_location = "";
        
        globus_location = br.readLine();
        if (globus_location == null || globus_location.compareTo("") == 0) {
            sess.close();
            return "The environment var $GLOBUS_LOCATION has not been initialized yet.\n"+
                    "Please contact with your GridWay administrator.";
        }
        
        /*Si la variable de entorno está prepara el terminal para poder ejecutar comandos de globus*/
        sess.close();
        sess = conn.openSession();
        sess.execCommand("source "+globus_location+"etc/globus-user-env.sh; grid-proxy-info -timeleft");
        
        stdout = new StreamGobbler(sess.getStdout());
        
        br = new BufferedReader(new InputStreamReader(stdout));
        while (true) {
            String line = br.readLine();
            if (line == null)
                break;
            salida += line+"\n";
            
        }
        
        int timeleft = 0;
        try {
            timeleft = Integer.parseInt(salida.replace("\n",""));
        }catch(NumberFormatException e) {
            sess.close();
            return salida;
        }
        
        if (timeleft == 0) {
            sess.close();
            return "The Globus proxy is not valid or not exits for current user.\n"+
                    "Please contact with your GridWay administrator.";
        } else if (timeleft < 0) {
            sess.close();
            return "The Globus proxy has expired for the current user.\n"+
                    "Please connect through ssh and execute grid-proxy-init command on server";
        }
        /* Show exit status, if available (otherwise "null") */
        
        
        /* Close this session */
        
        sess.close();
        
        sess = conn.openSession();
        
        sess.execCommand("echo $GW_LOCATION");
        
        stdout = new StreamGobbler(sess.getStdout());
        
        br = new BufferedReader(new InputStreamReader(stdout));
        
        String gw_location = br.readLine();
        
        if (gw_location == null || gw_location.compareTo("") == 0) {
            sess.close();
            return "The environment var $GW_LOCATION has not been initialized yet";
        }
        sess.close();
        
        sess = conn.openSession();
        sess.execCommand("cd "+this.getActualDir().toString()+"&& chmod +x "+fichero);
        sess.close();
         sess = conn.openSession();
        sess.execCommand("cd "+this.getActualDir().toString()+" && export PATH="+gw_location+"bin:$PATH:/bin:/usr/bin:/sbin ; sh "+fichero);
        stdout = new StreamGobbler(sess.getStdout());
        
        br = new BufferedReader(new InputStreamReader(stdout));
        while (true) {
            String line = br.readLine();
            if (line == null)
                break;
            salida += line+" ";
            
        }
        
        sess.close();
        /* Close the connection */
        
        sess = conn.openSession();
        sess.execCommand("export PATH="+gw_location+"bin:$PATH; gwps -u "+this.ftpUsername);
        stdout = new StreamGobbler(sess.getStdout());
        
        br = new BufferedReader(new InputStreamReader(stdout));
        while (true) {
            String line = br.readLine();
            if (line == null)
                break;
            salida += line+"\n";
            
        }
        return "Job launched successfully!";
    }
    
    public boolean createDir(String carpeta) {
        try {
            ftp.makeDir(carpeta);
        } catch (SftpException ex) {
            ex.printStackTrace();
            
            return false;
        }
        
        return true;
    }
    
    public boolean enviarFichero(File fichero) {
        try {
            ftp.upload(fichero);
            
            return true;
        } catch (SftpException ex) {
            ex.printStackTrace();
            
            
        }
        
        return false;
    }
    
    public SecureFTP(JFrame parent,String ftpHostname, String ftpUsername, String ftpPassword) throws SftpException {
        this.ftpHostname = ftpHostname;
        this.ftpUsername = ftpUsername;
        this.ftpPassword = ftpPassword;
        this.parent = parent;
        
        params = new SshParameters(ftpHostname,ftpUsername,ftpPassword);
        
        // create Sftp instance
        ftp = new Sftp(params);
        
        //capture FTP related events
        ftp.addSftpListener(this);
        
        // establish secure FTP connection
        ftp.connect();
        
        
        homePATH = ftp.getDir();
        
        
    }
    
    public void setHomePath() throws SftpException {
        ftp.setDir(homePATH);
    }
    
    public boolean isaDirectory(String fichero) {
        if (fichero == null || fichero.compareTo("") == 0)
            return false;
        
        try {
            return ftp.isDirectory(fichero);
        } catch (SftpException ex) {
            ex.printStackTrace();
        }
        
        return false;
    }
    
    public boolean exists(String fichero) {
        try {
            return ftp.isValidPath(fichero);
        } catch (SftpException ex) {
            ex.printStackTrace();
        }
        
        return false;
    }
    
    public void setDirUp() {
        try {
            
            this.ftp.setDirUp();
            
        } catch (SftpException ex) {
            ex.printStackTrace();
        }
    }
    
    public void setDir(String dir) throws SftpException {
        this.ftp.setDir(dir);
    }
    
    public File getParent() {
        
        String dir = this.ftp.getDir();
        try {
            
            this.ftp.setDirUp();
        } catch (SftpException ex) {
            ex.printStackTrace();
            
            return new File(dir);
        }
        File parent = new File(this.ftp.getDir());
        
        try {
            this.ftp.setDir(dir);
        } catch (SftpException ex) {
            ex.printStackTrace();
        }
        
        
        return parent;
        
    }
    
    public boolean isaDirectory(File file) {
        try {
            return ftp.isDirectory(file.getPath());
        } catch (SftpException ex) {
            ex.printStackTrace();
        }
        
        return false;
        
    }
    public File[] getListing() throws SftpException {
        
        
        ArrayList listadoficheros = new ArrayList();
        
        // get directory listing
        
        //String results = ftp.getDirListingAsString();
        
        //Enumeration lista = ftp.getDirListing();
        
        
        Enumeration lista = ftp.getDirListing();
        
        
        
        while(lista.hasMoreElements()) {
            SftpFile  fichero = (SftpFile)lista.nextElement();
            File file = new File(fichero.getPath());
            listadoficheros.add(file);
            
            // System.out.println(fichero.getFilename()); //Debuging purposes
            
            
            
        }
        
        
        
        File[] matrizficheros = new File[listadoficheros.size()];
        
        for (int i = 0; i<listadoficheros.size() ;i++)
            matrizficheros[i] =  (File) listadoficheros.get(i);
        
        
        return matrizficheros;
    }
    
    public File getActualDir() {
        return new File(ftp.getDir());
        
    }
    
    
    public boolean isConnected() {
        return this.ftp.isConnected();
    }
    public void disconnect() {
        ftp.disconnect();
    }
    
    /**
     * Captures FtpConnectedEvent event
     */
    public void connected(SftpConnectedEvent evt) {
        System.out.println("Connected to server: " + evt.getHostname());
        
        
    }
    
    /**
     * Captures FtpDisconnectedEvent event
     */
    public void disconnected(SftpDisconnectedEvent evt) {
        System.out.println("Disconnected from server: " + evt.getHostname());
    }
    
    
    public static void main(String[] args) {
        String ftpHostname;
        String ftpUsername;
        String ftpPassword;
        int a = 2;
        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
            System.out.print("Enter FTP hostname (e.g. ftp.myserver.com): ");
            //ftpHostname = reader.readLine();
            ftpHostname = "globusdev.dyndns.info";
            System.out.print("Enter FTP username (e.g. jsmith): ");
            
            //ftpUsername = reader.readLine();
            ftpUsername = "user";
            System.out.print("Enter FTP password (e.g. secret): ");
            //ftpPassword = reader.readLine();
            
            ftpPassword = "pass";
            
            SecureFTP example = new SecureFTP(new JFrame(),ftpHostname, ftpUsername, ftpPassword);
            
            example.ejecutar("WorkFlow1");
            // print directory listing
            example.getListing();
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
}