/*
 * Tarea.java
 *
 * Created on 2 de octubre de 2007, 12:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;

/**
 *
 * @author globus
 */
public class Tarea implements Cloneable {
    
    /** Creates a new instance of Tarea */
    
    
    String nombre;
    
    Fichero ejecutable;
    
    String argumentos;
    
    String variables;
    
    
    
    int tipo;
    
    int np;
    
    int tiempo_maximo_de_suspension;
    
    int umbral_carga_cpu;
    
    Fichero programa_monitor;
    
    boolean planificarSiFallo;
    
    int numeroReintentos;
    
    Fichero stdin;
    
    Fichero stdout;
    
    Fichero stderr;
    
    String requisitosTarea;
    
    String rankingTarea;
    
    Fichero restartFile;
    
    int intervaloCheckpoint;
    
    String checkpointURL;
    
    ArrayList ficherosEntrada;
    
    ArrayList ficherosSalida;
    
    
    int intervaloPlanificacion;
    
    int umbralPlanificacion;
    
    int numero_iteracion;
    
    
    Date tiempoDeadline = null;
    Date horaDeadline;
    
    Fichero wrapper;
    
    Fichero preWrapper;
    
    
    
    String argumentosPreWrapper;
    
    /****************************************/
    
    double x_pos = 0.0 ,y_pos = 0.0;
    
    /////////////////////////////////////////////
    
    
    /*Este método busca en las dos arraylist ficherosEntrada y ficherosEntradaDependientes
     en busca del fichero especificado en la entrada. Fichero debe de ser un nombre de fichero simple*/
    public boolean contieneFicheroEntrada(String nombrefichero) {
        for (int i = 0;i<this.ficherosEntrada.size();i++) {
            Fichero file = (Fichero) this.ficherosEntrada.get(i);
            if (file.iguales(nombrefichero) == true)
                return true;
        }
        
        
        return false;
    }
    
        /*Este método busca en las dos arraylist ficherosEntrada y ficherosEntradaDependientes
     en busca del fichero especificado en la entrada. Fichero debe de ser un nombre de fichero simple*/
    public boolean contieneFicheroEntrada(Fichero fichero) {
        for (int i = 0;i<this.ficherosEntrada.size();i++) {
            Fichero file = (Fichero) this.ficherosEntrada.get(i);
            if (file.iguales(fichero) == true)
                return true;
        }
        
        
        
        
        return false;
    }
    
    public boolean contieneFicheroSalida(Fichero fichero) {
        for (int i = 0;i<this.ficherosSalida.size();i++) {
            Fichero file = (Fichero) this.ficherosSalida.get(i);
            if (file.iguales(fichero) == true)
                return true;
        }
        
        
        
        
        return false;
    }
    
    public boolean actualizaFicheroEntrada(Fichero fichero,Fichero nuevofichero,boolean transformar) {
        for (int i = 0;i<this.ficherosEntrada.size();i++) {
            Fichero file = (Fichero) this.ficherosEntrada.get(i);
            
            if (file.iguales(fichero) == true) {
                this.ficherosEntrada.remove(i);
                if (transformar == true)
                    this.ficherosEntrada.add(nuevofichero.convertirDeSalidaAEntrada()); // Hay que convertirlo de salida a entrada
                else
                    this.ficherosEntrada.add(nuevofichero);
                
                return true;
            }
        }
        
        return false;
    }
    
    
    public boolean actualizaFicheroSalida(Fichero fichero,Fichero nuevofichero) {
        for (int i = 0;i<this.ficherosSalida.size();i++) {
            Fichero file = (Fichero) this.ficherosSalida.get(i);
            
            if (file.iguales(fichero) == true) {
                this.ficherosSalida.remove(i);
                
                this.ficherosSalida.add(nuevofichero);
                
                
                return true;
            }
        }
        
        return false;
    }
    
    public void eliminaFicheroEntrada(Fichero fichero) {
        for (int i = 0;i< this.ficherosEntrada.size();i++) {
            Fichero file = (Fichero) this.ficherosEntrada.get(i);
            
            if (file.iguales(fichero) == true) {
                this.ficherosEntrada.remove(i);
                break;
                
            }
        }
    }
    
    public void eliminaFicheroSalida(Fichero fichero) {
        for (int i = 0;i< this.ficherosSalida.size();i++) {
            Fichero file = (Fichero) this.ficherosSalida.get(i);
            
            if (file.iguales(fichero) == true) {
                this.ficherosSalida.remove(i);
                break;
                
            }
        }
    }
    
    
    public void anadeFicheroEntrada(Fichero fichero) {
        if (this.contieneFicheroEntrada(fichero) == false)
            this.ficherosEntrada.add(fichero);
    }
    
    public void anadeFicheroSalida(Fichero fichero) {
        if (this.contieneFicheroSalida(fichero) == false)
            this.ficherosSalida.add(fichero);
    }
    
    public String generarCodigo() {
           /*Primero hay que analizar las tareas y definir las plantillas de trabajo necesarias para cada tarea.
         Luego hay que analizar las dependencias entre tareas y generar los scripts que lanzarán las tareas
         a gridway.*/
        
        
        
        String jobTemplateContent = "#File generated by GWGUI";
        
        jobTemplateContent +="\n";
        
        /*************El código para el ejecutable se genera**********************/
        
        jobTemplateContent += "EXECUTABLE= "+this.ejecutable.codigo();
        //if (ejecutable.copiaraDestino==false)
        //jobTemplateContent += "EXECUTABLE= "+this.ejecutable.getSourceFilename();
        //else  if(ejecutable != null )
        //{
         //   String exec = ejecutable.getSourceFilename();
         //   String parts[] = exec.split("/");
         //   if (parts.length > 0)
         //   {
         //       exec = parts[parts.length-1];
         //   }
         //   else
         //       exec = parts[0];
            
        //    jobTemplateContent +=  "EXECUTABLE= "+exec;
       // }
        
        
        jobTemplateContent +="\n";
        /**************El código para los argumentos*******************************/
        
        jobTemplateContent += "ARGUMENTS="+this.argumentos;
        jobTemplateContent +="\n";
        /***************El código para STDIN, STDOUT y STDERR***********************/
        if (this.stdin.toString().compareTo("") != 0) {
            jobTemplateContent += "STDIN_FILE="+this.stdin.codigo();
            jobTemplateContent +="\n";
        }
        if (this.stdout.toString().compareTo("") != 0) {
            jobTemplateContent += "STDOUT_FILE="+this.stdout.codigo();
            jobTemplateContent +="\n";
        }
        
        if (this.stderr.toString().compareTo("") != 0) {
            jobTemplateContent += "STDERR_FILE="+this.stderr.codigo();
            jobTemplateContent +="\n";
        }
        /****************VARIABLES DE ENTORNO******************************************/
        jobTemplateContent += "ENVIRONMENT="+this.variables;
        jobTemplateContent +="\n";
        /******************TIPO DE TAREA*************************************************/
        if (this.tipo == TaskEditorDialog.SINGLE)
            jobTemplateContent += "TYPE="+"SINGLE";
        else if (this.tipo == TaskEditorDialog.MULTIPLE)
            jobTemplateContent += "TYPE="+"MULTIPLE";
        else if (this.tipo == TaskEditorDialog.MPI)
            jobTemplateContent += "TYPE="+"MPI";
        
        jobTemplateContent +="\n";
        /****************FICHEROS DE ENTRADA Y SALIDA************************************/
        
        ArrayList inputfiles = this.ficherosEntrada;
        ArrayList outputfiles = this.ficherosSalida;
        jobTemplateContent += "INPUT_FILES = ";
        
        for (int i = 0;i<inputfiles.size();i++) {
            if (i == 0 || i < inputfiles.size()-1)
                jobTemplateContent += ((Fichero)inputfiles.get(i)).codigo() + ", ";
            
            else
                jobTemplateContent +=  ((Fichero)inputfiles.get(i)).codigo();
            
        }
        
        
        
        /*El fichero ejecutable tambien se mete en los ficheros de entrada*/
        jobTemplateContent += " ,"+ ((Fichero)this.ejecutable).codigo();
        
        jobTemplateContent +="\n";
        jobTemplateContent += "OUTPUT_FILES = ";
        for (int i = 0;i<outputfiles.size();i++) {
            if (i == 0 || i< outputfiles.size()-1)
                jobTemplateContent +=  ((Fichero)outputfiles.get(i)).codigo()+" , ";
            
            else
                jobTemplateContent +=  ((Fichero)outputfiles.get(i)).codigo();
            
        }
        
        jobTemplateContent +="\n";
        
        /*********************Restart file****************************************/
        jobTemplateContent += "RESTART_FILES="+this.restartFile.codigo(); //no URL
        
        jobTemplateContent +="\n";
        
        jobTemplateContent += "CHECKPOINT_INTERVAL="+Integer.toString(this.intervaloCheckpoint);
        
        jobTemplateContent +="\n";
        
        jobTemplateContent += "CHECKPOINT_URL="+this.checkpointURL;
        
        jobTemplateContent +="\n";
        
        /***********************EXPRESION DE REQUISITOS DE LA TAREA *************************/
        if (this.requisitosTarea.compareTo("")!= 0) //Partimos de que no tiene errores
            jobTemplateContent += "REQUIREMENTS="+this.requisitosTarea;
        
        jobTemplateContent +="\n";
        
        /***********************EXPRESION DE RANKING DE LA TAREA*****************************/
        
        if (this.rankingTarea.compareTo("") != 0)
            jobTemplateContent += "RANKING="+this.rankingTarea;
        
        jobTemplateContent +="\n";
        /**********************INTERVALO DE REPLANIFICACION*********************************/
        
        jobTemplateContent += "RESCHEDULING_INTERVAL="+Integer.toString(this.intervaloPlanificacion);
        
        jobTemplateContent +="\n";
        
        /*********************UMBRAL DE REPLANNIFICACION**************************************/
        
        jobTemplateContent += "RESCHEDULING_THRESHOLD="+Integer.toString(this.umbralPlanificacion);
        jobTemplateContent +="\n";
        
     //   if (this.tiempoDeadline != null )
            /*********************TIEMPO MÁXIMO PARA EMPEZAR EL TRABAJO*************************************/
       //     jobTemplateContent += "DEADLINE="+this.tiempoDeadline.getDate()+"/"+this.tiempoDeadline.getMonth()+"/" +
         //           (this.tiempoDeadline.getYear()+1900);
        
       // jobTemplateContent +="\n";
        
        /***********************SUSPENSION TIMEOUT*********************************************/
        jobTemplateContent += "SUSPENSION_TIMEOUT="+Integer.toString(this.tiempo_maximo_de_suspension);
        
        jobTemplateContent +="\n";
        
        /***********************UMBRAL DE CARGA DE CPU PARA REALIZAR UNA MIGRACIÓN****************/
        jobTemplateContent += "CPULOAD_THRESHOLD="+Integer.toString(this.umbral_carga_cpu/100); //Porcentaje
        jobTemplateContent +="\n";
        
        
        /***********************Programa monitor***************************************************/
        
        if (this.programa_monitor != null) {
            jobTemplateContent += "MONITOR=" +this.programa_monitor.codigo();
            
            jobTemplateContent +="\n";
        }
        
        /*********************PLANIFICAR SI FALLO***************************************/
        
        if (this.planificarSiFallo == true) {
            jobTemplateContent += "RESCHEDULE_ON_FAILURE=" + " yes";
            
        }
        
        else
            jobTemplateContent += "RESCHEDULE_ON_FAILURE=" + " no";
        
        jobTemplateContent +="\n";
        
        /*******************NUMERO DE REINTENTOS********************/
        
        jobTemplateContent += "NUMBER_OF_RETRIES= "+this.numeroReintentos;
        
        jobTemplateContent +="\n";
        
        /******************WRAPPER***************************************************************/
        
        jobTemplateContent += "WRAPPER="+ this.wrapper.codigo();
        
        jobTemplateContent +="\n";
        
        /********************PREWRAPPER********************************************************/
        
        jobTemplateContent += "PRE_WRAPPER= " + this.preWrapper.codigo();
        
        jobTemplateContent +="\n";
        
        /********************ARGUMENTOS PREWRAPPER*********************************************/
        
        jobTemplateContent += "PRE_WRAPPER_ARGUMENTS= "+ this.argumentosPreWrapper;
        
        jobTemplateContent +="\n";
        
        return jobTemplateContent;
    }
    
    private boolean esBisiesto(int year) {
        return (year % 4 == 0 && year % 100 != 0) || year % 400 == 0;
        
    }
    
    public Tarea() {
        
        this.nombre = "";
        this.tiempoDeadline = null;
        this.horaDeadline = null;
        this.np = 0;
        this.tiempo_maximo_de_suspension = 0;
        this.programa_monitor = new Fichero();
        this.umbral_carga_cpu = 0;
        this.planificarSiFallo = false;
        this.numeroReintentos = 0;
        this.ejecutable = new Fichero();
        this.tiempoDeadline = null;
        
        Calendar fecha_actual = Calendar.getInstance();
        
        int dia = fecha_actual.get(Calendar.DAY_OF_YEAR);
        
        int year = fecha_actual.get(Calendar.YEAR);
        
        if (esBisiesto(year) == true) {
            if (dia == 366)
                dia = 1;
            else
                dia++;
        } else if (dia == 365)
            dia = 1;
        
        else
            dia++;
        
        fecha_actual.set(Calendar.DAY_OF_YEAR,dia);
        
        this.tiempoDeadline = fecha_actual.getTime();
    /*Todas las tareas deben contener este campo para que tareas con el mismo nivel en la jerarquía de tareas
     tengan un taskid concreto, es decir, utilizado para el número de iteración*/
        this.numero_iteracion = 0;
        
        this.argumentos = "";
        
        this.variables = "";
        
        this.tipo = TaskEditorDialog.SINGLE;
        
        this.stdin = new Fichero();
        
        this.stdout = new Fichero();
        
        this.stderr = new Fichero();
        
        this.requisitosTarea = "";
        
        this.rankingTarea = "";
        
        this.restartFile = new Fichero();
        
        this.intervaloCheckpoint = 0;
        
        this.checkpointURL = "";
        
        this.ficherosEntrada = new ArrayList();
        
        this.ficherosSalida = new ArrayList();
        
        this.intervaloPlanificacion = 0;
        
        this.umbralPlanificacion = 0;
        
       
        
        this.wrapper = new Fichero();
        
        this.preWrapper = new Fichero();
        
        this.argumentosPreWrapper = "";
    }
    
    public String toString() {
        return this.nombre;
    }
    
/*Este método devuelve todos los ficheros de la tarea que deben ser subidos a la máquina remota que contiene el
 metaplanificador gridway. Estos ficheros son los ficheros locales especificados en la máquina actual.
Devuelve un arraylist de objetos File*/
    
    public ArrayList getFilesForUpload() throws IOException {
        ArrayList files = new ArrayList();
        
        for (int i = 0;i<this.ficherosEntrada.size();i++) {
            Fichero fichero = (Fichero)this.ficherosEntrada.get(i);
            if (fichero.fichero_local == true)
                files.add(new File(fichero.getSourceFilename().replace(" ","").replace("(","o").replace(")","i")));
            
        }
        
        /*Los ficheros de salida jamás son locales*/
        
        if (this.ejecutable.fichero_local == true)
             files.add(new File(this.ejecutable.getSourceFilename().replace(" ","").replace("(","w").replace(")","x")));
        if (this.stdin.fichero_local == true)
            files.add(new File(this.stdin.getSourceFilename().replace(" ","").replace("(","w").replace(")","x")));
        
        if (this.wrapper.fichero_local == true)
            files.add(new File(this.wrapper.getSourceFilename().replace(" ","").replace("(","w").replace(")","x")));
        
        if (this.preWrapper.fichero_local == true)
            files.add(new File(this.programa_monitor.getSourceFilename().replace(" ","").replace("(","w").replace(")","x")));
        
        
        for (int i = 0;i< files.size();i++) {
            File aux = (File)files.get(i);
            if (aux.exists() == false)
                files.remove(i);
        }
        
        return files;
    }
    
    
    public Object clone() {
        int a = 2;
        try {
            super.clone();
            
            Tarea clon = new Tarea();
            
            clon.argumentos = new String(this.argumentos);
            
            clon.argumentosPreWrapper = new String(this.argumentosPreWrapper);
            
            clon.checkpointURL = new String(this.checkpointURL);
            
            clon.ejecutable = (Fichero)this.ejecutable.clone();
            
            if (horaDeadline == null)
                clon.horaDeadline = null;
            else
                clon.horaDeadline = (Date)this.horaDeadline.clone();
            
            clon.intervaloCheckpoint = this.intervaloCheckpoint;
            
            clon.intervaloPlanificacion = this.intervaloPlanificacion;
            
            clon.nombre = new String(this.nombre);
            
            clon.np = this.np;
            
            clon.numeroReintentos = this.numeroReintentos;
            
            clon.numero_iteracion = this.numero_iteracion;
            
            clon.planificarSiFallo = this.planificarSiFallo;
            
            clon.preWrapper = (Fichero)this.preWrapper.clone();
            
            clon.programa_monitor = (Fichero)this.programa_monitor.clone();
            
            clon.rankingTarea = new String(this.rankingTarea);
            
            clon.requisitosTarea = new String(this.requisitosTarea);
            
            clon.restartFile = (Fichero) this.restartFile.clone();
            
            clon.stderr = (Fichero) this.stderr.clone();
            
            clon.stdin = (Fichero) this.stdin.clone();
            
            clon.stdout = (Fichero) this.stdout.clone();
            
            if (this.tiempoDeadline == null)
                clon.tiempoDeadline = null;
            else
                
                clon.tiempoDeadline = (Date)this.tiempoDeadline.clone();
            
            clon.tiempo_maximo_de_suspension = this.tiempo_maximo_de_suspension;
            
            clon.tipo = this.tipo;
            
            clon.umbralPlanificacion =  this.umbralPlanificacion;
            
            clon.umbral_carga_cpu = this.umbral_carga_cpu;
            
            clon.variables = new String(this.variables);
            
            clon.wrapper = (Fichero)wrapper.clone();
            
            clon.x_pos = this.x_pos;
            
            clon.y_pos = this.y_pos;
            
            for (int i = 0;i<this.ficherosEntrada.size();i++)
                clon.anadeFicheroEntrada((Fichero)this.ficherosEntrada.get(i));
            for(int i = 0;i<this.ficherosSalida.size();i++)
                clon.anadeFicheroSalida((Fichero)this.ficherosSalida.get(i));
                        
            return clon;
            
        }catch (CloneNotSupportedException e) {
            return null;
        }
        
    }
}
