/*
 * TaskEditorDialog.java
 *
 * Created on 2 de octubre de 2007, 9:11
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import java.awt.Frame;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import pSintactico.ErrorSintacticoException;
import pSintactico.ErroresSintacticosDialog;
import pSintactico.SintacticoRanking;
import pSintactico.SintacticoRequisitos;

/**
 *
 * @author  globus
 */



public class TaskEditorDialog extends java.awt.Dialog {
    
    /** Creates new form TaskEditorDialog */
    
    public static int SINGLE = 0;
    
    public static int MULTIPLE = 1;
    
    public static int MPI = 2;
    
    boolean aceptar = false;
    
    Tarea tarea = null;
    
    Dependencia dep;
    
    GUI interfaz;
    
    
    
    Fichero ejecutable;
    
    Fichero restartFile;
    
    Fichero monitor;
    
    Fichero wrapper;
    
    Fichero prewrapper;
    
    Fichero stdin;
    
    Fichero stdout;
    
    Fichero stderr;
    
    
    Frame parent;
    
    SecureFTP conexion;
    
    
    public String getName() {
        return this.nombreTareaTextField.getText();
    }
    

    
    
    public TaskEditorDialog(java.awt.Frame parent, boolean modal,GUI interfaz, Tarea tarea, SecureFTP conexion) {
        super(parent, modal);
        initComponents();
        
        if (tarea != null && tarea instanceof TareaMultiple == false)
            this.jTabbedPane1.remove(this.jarrayTrabajosPanel);
        
        
        
        
        this.conexion = conexion;
        this.parent = parent;
        this.interfaz = interfaz;
        this.tarea = tarea;
        
        /*Inicialización de la lista de parametros para especificar los requisitos y el ranking de la tarea*/
        
        this.listaParametrosList.add("HOSTNAME");
        
        this.listaParametrosList.add("ARCH");
        
        this.listaParametrosList.add("OS_NAME");
        
        this.listaParametrosList.add("ARCH");
        
        this.listaParametrosList.add("OS_VERSION");
        
        this.listaParametrosList.add("CPU_MODEL");
        
        this.listaParametrosList.add("CPU_MHZ");
        
        this.listaParametrosList.add("CPU_FREE");
        
        this.listaParametrosList.add("CPU_SMP");
        
        this.listaParametrosList.add("NODECOUNT");
        
        this.listaParametrosList.add("SIZE_MEM_MB");
        
        this.listaParametrosList.add("FREE_MEM_MB");
        
        this.listaParametrosList.add("SIZE_DISK_MB");
        
        this.listaParametrosList.add("FREE_DISK_MB");
        
        this.listaParametrosList.add("LRMS_NAME");
        
        this.listaParametrosList.add("LRMS_TYPE");
        
        this.listaParametrosList.add("QUEUE_NAME");
        
        this.listaParametrosList.add("QUEUE_NODECOUNT");
        
        this.listaParametrosList.add("QUEUE_FREENODECOUNT");
        
        this.listaParametrosList.add("QUEUE_MAXCOUNT");
        
        this.listaParametrosList.add("QUEUE_MAXRUNNINGJOBS");
        
        this.listaParametrosList.add("QUEUE_MAXJOBSINQUEUE");
        
        this.listaParametrosList.add("QUEUE_DISPATCHTYPE");
        
        this.listaParametrosList.add("QUEUE_PRIORITY");
        
        this.listaParametrosList.add("QUEUE_STATUS");
        
        this.listaParametrosList2.add("HOSTNAME");
        
        this.listaParametrosList2.add("ARCH");
        
        this.listaParametrosList2.add("OS_NAME");
        
        this.listaParametrosList2.add("ARCH");
        
        this.listaParametrosList2.add("OS_VERSION");
        
        this.listaParametrosList2.add("CPU_MODEL");
        
        this.listaParametrosList2.add("CPU_MHZ");
        
        this.listaParametrosList2.add("CPU_FREE");
        
        this.listaParametrosList2.add("CPU_SMP");
        
        this.listaParametrosList2.add("NODECOUNT");
        
        this.listaParametrosList2.add("SIZE_MEM_MB");
        
        this.listaParametrosList2.add("FREE_MEM_MB");
        
        this.listaParametrosList2.add("SIZE_DISK_MB");
        
        this.listaParametrosList2.add("FREE_DISK_MB");
        
        this.listaParametrosList2.add("LRMS_NAME");
        
        this.listaParametrosList2.add("LRMS_TYPE");
        
        this.listaParametrosList2.add("QUEUE_NAME");
        
        this.listaParametrosList2.add("QUEUE_NODECOUNT");
        
        this.listaParametrosList2.add("QUEUE_FREENODECOUNT");
        
        this.listaParametrosList2.add("QUEUE_MAXCOUNT");
        
        this.listaParametrosList2.add("QUEUE_MAXRUNNINGJOBS");
        
        this.listaParametrosList2.add("QUEUE_MAXJOBSINQUEUE");
        
        this.listaParametrosList2.add("QUEUE_DISPATCHTYPE");
        
        this.listaParametrosList2.add("QUEUE_PRIORITY");
        
        this.listaParametrosList2.add("QUEUE_STATUS");
        
        /***********************************************************************************************************/
        
        this.setTaskDialogParameters(tarea); //Inicializa todos los campos del  cuadro de diálogo.
        
        
        
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Código Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jSplitPane1 = new javax.swing.JSplitPane();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        nombreTareaTextField = new java.awt.TextField();
        label1 = new java.awt.Label();
        label2 = new java.awt.Label();
        label3 = new java.awt.Label();
        label4 = new java.awt.Label();
        label5 = new java.awt.Label();
        jButton17 = new javax.swing.JButton();
        ejecutableTextField = new java.awt.TextField();
        argumentostextField = new java.awt.TextField();
        jButton18 = new javax.swing.JButton();
        variablesEntornoTextField = new java.awt.TextField();
        jButton19 = new javax.swing.JButton();
        jTipoComboBox = new javax.swing.JComboBox();
        label30 = new java.awt.Label();
        NPTextField = new java.awt.TextField();
        jPanel10 = new javax.swing.JPanel();
        label27 = new java.awt.Label();
        label28 = new java.awt.Label();
        label29 = new java.awt.Label();
        tiempoMaxSuspensionTextField = new javax.swing.JTextField();
        umbralCargaCPUTextField = new javax.swing.JTextField();
        monitorTextField = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jPanel11 = new javax.swing.JPanel();
        jLabel17 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        volveraPlanificarComboBox = new javax.swing.JComboBox();
        reintentosTextField = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        label8 = new java.awt.Label();
        label9 = new java.awt.Label();
        label10 = new java.awt.Label();
        stdinTextField = new java.awt.TextField();
        stdoutTextField = new java.awt.TextField();
        stderrTextField = new java.awt.TextField();
        jButton22 = new javax.swing.JButton();
        jButton23 = new javax.swing.JButton();
        jButton24 = new javax.swing.JButton();
        jPanel8 = new javax.swing.JPanel();
        jLabel14 = new javax.swing.JLabel();
        listaParametrosList = new java.awt.List();
        jButton8 = new javax.swing.JButton();
        jButton10 = new javax.swing.JButton();
        jLabel18 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jButton41 = new javax.swing.JButton();
        jButton42 = new javax.swing.JButton();
        jButton43 = new javax.swing.JButton();
        jButton44 = new javax.swing.JButton();
        jButton45 = new javax.swing.JButton();
        jButton46 = new javax.swing.JButton();
        jButton47 = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        requisitosTextArea = new javax.swing.JTextArea();
        jButton5 = new javax.swing.JButton();
        jPanel13 = new javax.swing.JPanel();
        jLabel23 = new javax.swing.JLabel();
        listaParametrosList2 = new java.awt.List();
        jButton25 = new javax.swing.JButton();
        jButton26 = new javax.swing.JButton();
        jButton27 = new javax.swing.JButton();
        jButton28 = new javax.swing.JButton();
        jLabel24 = new javax.swing.JLabel();
        jButton39 = new javax.swing.JButton();
        jButton40 = new javax.swing.JButton();
        jLabel26 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        rankingTextArea1 = new javax.swing.JTextArea();
        jButton30 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        label11 = new java.awt.Label();
        label12 = new java.awt.Label();
        label13 = new java.awt.Label();
        restart_filesTextField = new javax.swing.JTextField();
        intervaloCheckpointTextField = new javax.swing.JTextField();
        checkpointURLTextField = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        label6 = new java.awt.Label();
        label7 = new java.awt.Label();
        InFileslist = new java.awt.List();
        OutFilesList = new java.awt.List();
        jButton20 = new javax.swing.JButton();
        jButton21 = new javax.swing.JButton();
        jPanel9 = new javax.swing.JPanel();
        label24 = new java.awt.Label();
        label25 = new java.awt.Label();
        label26 = new java.awt.Label();
        umbralPlanificacionTextField = new javax.swing.JTextField();
        intervaloplanificacionTextField = new javax.swing.JTextField();
        jDateChooserDeadline = new com.toedter.calendar.JDateChooser();
        jPanel12 = new javax.swing.JPanel();
        jLabel20 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        wrapperTextField = new javax.swing.JTextField();
        preWrapperTextField = new javax.swing.JTextField();
        argumentosPreWrapperTextField = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jarrayTrabajosPanel = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        numeroTrabajosTextField = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        jButton34 = new javax.swing.JButton();
        jButton37 = new javax.swing.JButton();

        setResizable(false);
        setTitle("Task editor");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jSplitPane1.setDividerLocation(520);
        jSplitPane1.setDividerSize(2);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jTabbedPane1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jTabbedPane1.setMaximumSize(new java.awt.Dimension(13, 11));
        nombreTareaTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                nombreTareaTextFieldKeyTyped(evt);
            }
        });

        label1.setText("Name:");

        label2.setText("Executable:");

        label3.setText("Arguments:");

        label4.setText("Environment:");

        label5.setText("Type:");

        jButton17.setText("Browse...");
        jButton17.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton17jExaminarMouseClicked(evt);
            }
        });

        ejecutableTextField.setEditable(false);

        jButton18.setText("Edit");
        jButton18.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton18jEditarArgumentosMouseClicked(evt);
            }
        });

        variablesEntornoTextField.setEditable(false);

        jButton19.setText("Edit");
        jButton19.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton19jEditarVariablesEntornoMouseClicked(evt);
            }
        });

        jTipoComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Single", "Multiple", "MPI" }));
        jTipoComboBox.setEnabled(false);
        jTipoComboBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jTipoComboBoxItemStateChanged(evt);
            }
        });
        jTipoComboBox.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                jTipoComboBoxPropertyChange(evt);
            }
        });

        label30.setText("Number of processes (MPI jobs):");

        NPTextField.setEnabled(false);
        NPTextField.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                NPTextFieldPropertyChange(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(20, 20, 20)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(label4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(label5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(label30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(54, 54, 54)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(nombreTareaTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, argumentostextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                    .add(jTipoComboBox, 0, 185, Short.MAX_VALUE)
                    .add(ejecutableTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                    .add(variablesEntornoTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                    .add(NPTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 185, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jButton19, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jButton18, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jButton17, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .add(105, 105, 105))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(47, 47, 47)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(nombreTareaTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 28, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton17, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(ejecutableTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel2Layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(jButton18, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(argumentostextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                        .add(16, 16, 16)
                        .add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jPanel2Layout.createSequentialGroup()
                        .add(21, 21, 21)
                        .add(label4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(label5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel2Layout.createSequentialGroup()
                        .add(12, 12, 12)
                        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jButton19)
                            .add(variablesEntornoTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 28, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jTipoComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(13, 13, 13)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(label30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(NPTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 29, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(209, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("Environment", jPanel2);

        label27.setText("Suspension timeout:");

        label28.setText("CPULOAD THRESHOLD (%):");

        label29.setText("MONITOR:");

        tiempoMaxSuspensionTextField.setText("0");
        tiempoMaxSuspensionTextField.setToolTipText("");

        umbralCargaCPUTextField.setText("0");
        umbralCargaCPUTextField.setToolTipText("If the CPU assigned to your job is less than this given\npercentage, the job will be migrated.");

        monitorTextField.setEditable(false);
        monitorTextField.setToolTipText("Additional monitoring program.");

        jButton1.setText("...");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton1jExaminarMonitorMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel10Layout = new org.jdesktop.layout.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel10Layout.createSequentialGroup()
                .add(26, 26, 26)
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(label27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(label28, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(label29, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(23, 23, 23)
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(umbralCargaCPUTextField)
                    .add(tiempoMaxSuspensionTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 231, Short.MAX_VALUE)
                    .add(jPanel10Layout.createSequentialGroup()
                        .add(monitorTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 195, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton1)))
                .addContainerGap(113, Short.MAX_VALUE))
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel10Layout.createSequentialGroup()
                .add(66, 66, 66)
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(label27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(tiempoMaxSuspensionTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(28, 28, 28)
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jPanel10Layout.createSequentialGroup()
                        .add(label28, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(27, 27, 27)
                        .add(label29, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel10Layout.createSequentialGroup()
                        .add(umbralCargaCPUTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(monitorTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jButton1))))
                .addContainerGap(292, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("Performance", jPanel10);

        jLabel17.setText("Reschedule on failure:");

        jLabel19.setText("Retries:");

        volveraPlanificarComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "S\u00ed", "No" }));

        reintentosTextField.setText("0");
        reintentosTextField.setToolTipText("Maximum number of retries");

        org.jdesktop.layout.GroupLayout jPanel11Layout = new org.jdesktop.layout.GroupLayout(jPanel11);
        jPanel11.setLayout(jPanel11Layout);
        jPanel11Layout.setHorizontalGroup(
            jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel11Layout.createSequentialGroup()
                .add(27, 27, 27)
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel17)
                    .add(jLabel19))
                .add(48, 48, 48)
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(volveraPlanificarComboBox, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(reintentosTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE))
                .addContainerGap(223, Short.MAX_VALUE))
        );
        jPanel11Layout.setVerticalGroup(
            jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel11Layout.createSequentialGroup()
                .add(43, 43, 43)
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jLabel17)
                    .add(volveraPlanificarComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(27, 27, 27)
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel19)
                    .add(reintentosTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(357, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("Fault tolerance", jPanel11);

        label8.setText("STDIN:");

        label9.setText("STDOUT:");

        label10.setText("STDERR:");

        stdinTextField.setEditable(false);

        stdoutTextField.setEditable(false);

        stderrTextField.setEditable(false);

        jButton22.setText("...");
        jButton22.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton22jEditarStdinMouseClicked(evt);
            }
        });

        jButton23.setText("...");
        jButton23.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton23jEditarStdoutMouseClicked(evt);
            }
        });

        jButton24.setText("...");
        jButton24.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton24jEditarStdErrMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel4Layout = new org.jdesktop.layout.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel4Layout.createSequentialGroup()
                .add(67, 67, 67)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel4Layout.createSequentialGroup()
                        .add(label8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 53, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                    .add(label9, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 96, Short.MAX_VALUE)
                    .add(label10, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 96, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 50, Short.MAX_VALUE)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(stdoutTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, stderrTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, stdinTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 256, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jButton22)
                    .add(jButton24)
                    .add(jButton23))
                .add(42, 42, 42))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .add(26, 26, 26)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(jButton22)
                    .add(label8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(stdinTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(label9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 31, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel4Layout.createSequentialGroup()
                        .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(stdoutTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jButton23))
                        .add(6, 6, 6)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jButton24)
                    .add(label10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(stderrTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(61, 61, 61))
        );
        jTabbedPane1.addTab("Standard I/O", jPanel4);

        jPanel8.setMaximumSize(new java.awt.Dimension(150, 150));
        jLabel14.setText("Parameters to choose from:");

        listaParametrosList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                listaParametrosListMouseClicked(evt);
            }
        });

        jButton8.setText("(");
        jButton8.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton8jParentesisIzdaMouseClicked(evt);
            }
        });

        jButton10.setText(")");
        jButton10.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton10jParentesisDchaMouseClicked(evt);
            }
        });

        jLabel18.setText("Requirement expression:");

        jLabel1.setText("Logic operators:");

        jButton41.setText("<");
        jButton41.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton41jMenorQueMouseClicked(evt);
            }
        });

        jButton42.setText(">");
        jButton42.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton42jMayorQueMouseClicked(evt);
            }
        });

        jButton43.setText("=");
        jButton43.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton43jIgualQueMouseClicked(evt);
            }
        });

        jButton44.setText("AND");
        jButton44.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton44jANDMouseClicked(evt);
            }
        });

        jButton45.setText("OR");
        jButton45.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton45jORMouseClicked(evt);
            }
        });

        jButton46.setText("NOT");
        jButton46.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton46jNOTMouseClicked(evt);
            }
        });

        jButton47.setText("Check expression");
        jButton47.setToolTipText("");
        jButton47.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton47jChequearExpresionMouseClicked(evt);
            }
        });

        requisitosTextArea.setColumns(20);
        requisitosTextArea.setRows(5);
        jScrollPane2.setViewportView(requisitosTextArea);

        jButton5.setText("?");
        jButton5.setToolTipText("Help");
        jButton5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton5MouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel8Layout = new org.jdesktop.layout.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel8Layout.createSequentialGroup()
                        .add(105, 105, 105)
                        .add(listaParametrosList, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 302, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel8Layout.createSequentialGroup()
                        .add(11, 11, 11)
                        .add(jLabel14))
                    .add(jLabel18)
                    .add(jPanel8Layout.createSequentialGroup()
                        .add(jLabel1)
                        .add(21, 21, 21)
                        .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(jPanel8Layout.createSequentialGroup()
                                .add(jButton8)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .add(jButton10))
                            .add(jPanel8Layout.createSequentialGroup()
                                .add(jButton41)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jButton42)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton43)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton44)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton45)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton46))
                    .add(jPanel8Layout.createSequentialGroup()
                        .add(96, 96, 96)
                        .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 294, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jButton5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 52, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jButton47))))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel8Layout.createSequentialGroup()
                .add(20, 20, 20)
                .add(jLabel14)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(listaParametrosList, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 137, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton8)
                    .add(jButton10))
                .add(22, 22, 22)
                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(jButton41)
                    .add(jButton42)
                    .add(jButton43)
                    .add(jButton44)
                    .add(jButton45)
                    .add(jButton46))
                .add(45, 45, 45)
                .add(jLabel18)
                .add(8, 8, 8)
                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 118, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel8Layout.createSequentialGroup()
                        .add(jButton47)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton5)))
                .addContainerGap())
        );
        jTabbedPane1.addTab("Requirements", jPanel8);

        jPanel13.setMaximumSize(new java.awt.Dimension(150, 150));
        jLabel23.setText("Parameters to choose from:");

        listaParametrosList2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                listaParametrosList2MouseClicked(evt);
            }
        });

        jButton25.setText("+");
        jButton25.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton25jSumarMouseClicked(evt);
            }
        });

        jButton26.setText("-");
        jButton26.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton26jRestarMouseClicked(evt);
            }
        });

        jButton27.setText("*");
        jButton27.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton27jMultiplicarMouseClicked(evt);
            }
        });

        jButton28.setText("/");
        jButton28.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton28jDividirMouseClicked(evt);
            }
        });

        jLabel24.setText("Arithmetic operators:");

        jButton39.setText("(");
        jButton39.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton39jParentesisIzdaMouseClicked(evt);
            }
        });

        jButton40.setText(")");
        jButton40.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton40jParentesisDchaMouseClicked(evt);
            }
        });

        jLabel26.setText("Ranking expression:");

        rankingTextArea1.setColumns(20);
        rankingTextArea1.setRows(5);
        jScrollPane1.setViewportView(rankingTextArea1);

        jButton30.setText("Check expression");
        jButton30.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton30jChequearRankingMouseClicked(evt);
            }
        });

        jButton6.setText("?");
        jButton6.setToolTipText("Help");
        jButton6.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton6MouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel13Layout = new org.jdesktop.layout.GroupLayout(jPanel13);
        jPanel13.setLayout(jPanel13Layout);
        jPanel13Layout.setHorizontalGroup(
            jPanel13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel13Layout.createSequentialGroup()
                .add(jPanel13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel13Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jPanel13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel13Layout.createSequentialGroup()
                                .add(jLabel23)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel13Layout.createSequentialGroup()
                                .add(jLabel24)
                                .add(224, 224, 224))))
                    .add(jPanel13Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jLabel26))
                    .add(jPanel13Layout.createSequentialGroup()
                        .add(115, 115, 115)
                        .add(jPanel13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(jPanel13Layout.createSequentialGroup()
                                .add(jButton25)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jButton26)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jButton27)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jButton28)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jButton39)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jButton40))
                            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 273, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jButton6)
                            .add(jButton30)))
                    .add(jPanel13Layout.createSequentialGroup()
                        .add(100, 100, 100)
                        .add(listaParametrosList2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 302, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(26, Short.MAX_VALUE))
        );
        jPanel13Layout.setVerticalGroup(
            jPanel13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel13Layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel23)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(listaParametrosList2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 137, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(2, 2, 2)
                .add(jLabel24)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton25)
                    .add(jButton26)
                    .add(jButton27)
                    .add(jButton28)
                    .add(jButton39)
                    .add(jButton40))
                .add(49, 49, 49)
                .add(jLabel26)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel13Layout.createSequentialGroup()
                        .add(jButton30)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton6))
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 113, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        jTabbedPane1.addTab("Ranking", jPanel13);

        label11.setText("RESTART FILE:");

        label12.setText("Checkpoint interval:");

        label13.setText("Checkpoint file URL:");

        restart_filesTextField.setToolTipText("");
        restart_filesTextField.setEnabled(false);
        restart_filesTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                restart_filesTextFieldKeyPressed(evt);
            }
        });

        intervaloCheckpointTextField.setToolTipText("");
        intervaloCheckpointTextField.setEnabled(false);

        checkpointURLTextField.setToolTipText("GridFTP URL to store/access checkpoint \ufb01les (Default is job\nexperiment directory in localhost). Example:\nCHECKPOINT_URL =\ngsiftp://hydrus.ucm.es/var/checkpoints/\n\nEs la URL gridftp donde se encontrar\u00e1n los ficheros de restauraci\u00f3n.\n\nEl formato es:\n\nCHECKPOINT_URL = gridftp://globusdev.prueba.info\n\nPor defecto es localhost");
        checkpointURLTextField.setEnabled(false);

        org.jdesktop.layout.GroupLayout jPanel5Layout = new org.jdesktop.layout.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .add(30, 30, 30)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(label13, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                        .add(label12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(label11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 100, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(checkpointURLTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 170, Short.MAX_VALUE)
                    .add(intervaloCheckpointTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 170, Short.MAX_VALUE)
                    .add(restart_filesTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 170, Short.MAX_VALUE))
                .add(235, 235, 235))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .addContainerGap(27, Short.MAX_VALUE)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(restart_filesTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(label11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(label12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(intervaloCheckpointTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(label13, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(checkpointURLTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(366, 366, 366))
        );
        jTabbedPane1.addTab("Checkpointing", jPanel5);

        label6.setText("Input files:");

        label7.setText("Output files:");

        jButton20.setText("Add files:");
        jButton20.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton20jAnadirFicherosEntradaMouseClicked(evt);
            }
        });

        jButton21.setText("Add files:");
        jButton21.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton21jAnadirFicherosSalidaMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel3Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel3Layout.createSequentialGroup()
                                .add(label6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jButton20))
                            .add(jPanel3Layout.createSequentialGroup()
                                .add(label7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 74, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(1, 1, 1)
                                .add(jButton21))))
                    .add(jPanel3Layout.createSequentialGroup()
                        .add(56, 56, 56)
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(OutFilesList, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 396, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(InFileslist, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 396, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(112, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .add(26, 26, 26)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(label6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton20))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(InFileslist, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 121, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(19, 19, 19)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(label7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton21))
                .add(16, 16, 16)
                .add(OutFilesList, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 121, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(107, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("I/O", jPanel3);

        label24.setText("Scheduling Interval (s):");

        label25.setText("Scheduling Threshold (s):");

        label26.setText("Deadline date:");

        umbralPlanificacionTextField.setText("0");
        umbralPlanificacionTextField.setToolTipText("Migration threshold.");
        umbralPlanificacionTextField.setEnabled(false);

        intervaloplanificacionTextField.setText("0");
        intervaloplanificacionTextField.setToolTipText("Interval of searching of new better resources by GridWay.");
        intervaloplanificacionTextField.setEnabled(false);

        jDateChooserDeadline.setEnabled(false);
        jDateChooserDeadline.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                jDateChooserDeadlinePropertyChange(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel9Layout = new org.jdesktop.layout.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel9Layout.createSequentialGroup()
                .add(42, 42, 42)
                .add(jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(label24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(label25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(label26, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(28, 28, 28)
                .add(jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, umbralPlanificacionTextField)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, intervaloplanificacionTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jDateChooserDeadline, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(135, Short.MAX_VALUE))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel9Layout.createSequentialGroup()
                .add(60, 60, 60)
                .add(jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel9Layout.createSequentialGroup()
                        .add(intervaloplanificacionTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(25, 25, 25)
                        .add(umbralPlanificacionTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(23, 23, 23)
                        .add(jDateChooserDeadline, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel9Layout.createSequentialGroup()
                        .add(label24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(25, 25, 25)
                        .add(label25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(23, 23, 23)
                        .add(label26, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(305, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("Scheduling", jPanel9);

        jLabel20.setText("WRAPPER:");

        jLabel21.setText("PREWRAPPER:");

        jLabel22.setText("PREWRAPPER ARGUMENTS:");

        wrapperTextField.setEditable(false);
        wrapperTextField.setToolTipText("Script para el wrapper");

        preWrapperTextField.setEditable(false);
        preWrapperTextField.setToolTipText("Optional program that is executed before the execution of\nthe job, to perform an additional remote setup (e.g. access a\nweb service). This job is ALWAYS submitted to the FORK\njob-manager. stdout and stderr streams of this program can\nbe found in directory\n\nPrograma opcional que se ejecuta antes de la ejecuci\u00f3n del trabajo, para desarrollar tareas adicionales de setup remoto, por ejemplo, acceder a un servicio web.\n\nEste trabajo es siempre ejecutado por el gestor de trabajos FORK. stdout y stderr pueden ser encontrados en el directorio: $GW_LOCATION/var");

        argumentosPreWrapperTextField.setEditable(false);

        jButton2.setText("...");
        jButton2.setEnabled(false);
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jWrapperMouseClicked(evt);
            }
        });

        jButton3.setText("...");
        jButton3.setEnabled(false);
        jButton3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPreWrapperMouseClicked(evt);
            }
        });

        jButton4.setText("Edit");
        jButton4.setEnabled(false);
        jButton4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton4jEditarArgumentosPreWrapperMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel12Layout = new org.jdesktop.layout.GroupLayout(jPanel12);
        jPanel12.setLayout(jPanel12Layout);
        jPanel12Layout.setHorizontalGroup(
            jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel12Layout.createSequentialGroup()
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel12Layout.createSequentialGroup()
                        .add(103, 103, 103)
                        .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(jLabel21)
                            .add(jLabel20)))
                    .add(jPanel12Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jLabel22)))
                .add(28, 28, 28)
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(argumentosPreWrapperTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 162, Short.MAX_VALUE)
                    .add(preWrapperTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 162, Short.MAX_VALUE)
                    .add(wrapperTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 162, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                        .add(jButton2)
                        .add(jButton3))
                    .add(jButton4))
                .add(217, 217, 217))
        );
        jPanel12Layout.setVerticalGroup(
            jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel12Layout.createSequentialGroup()
                .add(74, 74, 74)
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jButton2)
                    .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jLabel20)
                        .add(wrapperTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(26, 26, 26)
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel21)
                    .add(jButton3)
                    .add(preWrapperTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(27, 27, 27)
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel22)
                    .add(jButton4)
                    .add(argumentosPreWrapperTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(268, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("Advanced options", jPanel12);

        jLabel2.setText("Number of jobs:");

        numeroTrabajosTextField.setText("0");
        numeroTrabajosTextField.setToolTipText("Number of jobs of an job array.");

        org.jdesktop.layout.GroupLayout jarrayTrabajosPanelLayout = new org.jdesktop.layout.GroupLayout(jarrayTrabajosPanel);
        jarrayTrabajosPanel.setLayout(jarrayTrabajosPanelLayout);
        jarrayTrabajosPanelLayout.setHorizontalGroup(
            jarrayTrabajosPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jarrayTrabajosPanelLayout.createSequentialGroup()
                .add(37, 37, 37)
                .add(jLabel2)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(numeroTrabajosTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 288, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(127, Short.MAX_VALUE))
        );
        jarrayTrabajosPanelLayout.setVerticalGroup(
            jarrayTrabajosPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jarrayTrabajosPanelLayout.createSequentialGroup()
                .add(54, 54, 54)
                .add(jarrayTrabajosPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(numeroTrabajosTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(397, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("Job Array", jarrayTrabajosPanel);

        jSplitPane1.setLeftComponent(jTabbedPane1);

        jButton34.setText("Accept");
        jButton34.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jAceptarMouseClicked(evt);
            }
        });

        jButton37.setText("Cancel");
        jButton37.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jCancelarMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(98, 98, 98)
                .add(jButton34)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 218, Short.MAX_VALUE)
                .add(jButton37)
                .add(107, 107, 107))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton34, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jButton37, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jSplitPane1.setRightComponent(jPanel1);

        add(jSplitPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton6MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton6MouseClicked
    RankingDialog dialogo = new RankingDialog(this.interfaz,false);
    dialogo.setVisible(true);
    }//GEN-LAST:event_jButton6MouseClicked

    private void jButton5MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton5MouseClicked

        ExpressionDialog dialogo = new ExpressionDialog(this.interfaz,false);
        dialogo.setVisible(true);
        
    }//GEN-LAST:event_jButton5MouseClicked
    
    private void nombreTareaTextFieldKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_nombreTareaTextFieldKeyTyped
        
        if (this.nombreTareaTextField.getText().contains(" ") == true)
            this.nombreTareaTextField.setText(this.nombreTareaTextField.getText().replace(" ",""));
    }//GEN-LAST:event_nombreTareaTextFieldKeyTyped
    
    private void jDeadlineTimeChooserMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jDeadlineTimeChooserMouseClicked
       
    }//GEN-LAST:event_jDeadlineTimeChooserMouseClicked
    
    private void jDeadlineTimeChooserKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jDeadlineTimeChooserKeyTyped
        
        Calendar fecha_actual = Calendar.getInstance();
        
        
        if (this.jDateChooserDeadline.getDate() == null)
            return;
        
        Calendar fecha_seleccionada = this.jDateChooserDeadline.getCalendar();
        
        
        //EN fecha_seleccionada está la fecha y ahora seleccionadas.
        
        
        if (fecha_actual.getTime().compareTo(fecha_seleccionada.getTime()) == 1)
            
        {
           JOptionPane.showMessageDialog(this, "The deadline time must be in the future not in the past!", "Error", JOptionPane.ERROR_MESSAGE);
           
            
            int hora = fecha_actual.get(Calendar.HOUR_OF_DAY);
            
            hora = (hora + 1); //+ 1 hora desde la actual
            
            if (hora == 24) {
                hora = 0;
                fecha_actual.set(Calendar.HOUR_OF_DAY,hora);
                int year = fecha_actual.get(Calendar.YEAR);
                
                int dia = fecha_actual.get(Calendar.DAY_OF_YEAR);
                if (esBisiesto(year) == true) {
                    if (dia == 366)
                        dia = 1;
                } else if (dia == 365)
                    dia = 1;
                
                else
                    dia++;
                fecha_actual.set(Calendar.DAY_OF_YEAR,dia);
                this.jDateChooserDeadline.setCalendar(fecha_actual);
            }
            
            fecha_actual.set(Calendar.HOUR_OF_DAY,hora);
        }
    }//GEN-LAST:event_jDeadlineTimeChooserKeyTyped
    
    private void jDeadlineTimeChooserPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jDeadlineTimeChooserPropertyChange
        
        Calendar fecha_actual = Calendar.getInstance();
        
        
        if (this.jDateChooserDeadline.getDate() == null)
            return;
        
        Calendar fecha_seleccionada = this.jDateChooserDeadline.getCalendar();
        
        
        
        //EN fecha_seleccionada está la fecha y ahora seleccionadas.
        
        
        if (fecha_actual.getTime().compareTo(fecha_seleccionada.getTime()) == 1)
            
        {
            
            JOptionPane.showMessageDialog(this, "The deadline time must be in the future not in the past!", "Error", JOptionPane.ERROR_MESSAGE);

            
                int year = fecha_actual.get(Calendar.YEAR);
                
                int dia = fecha_actual.get(Calendar.DAY_OF_YEAR);
                if (esBisiesto(year) == true) {
                    if (dia == 366)
                        dia = 1;
                    else
                        dia++;
                } else if (dia == 365)
                    dia = 1;
                
                else
                    dia++;
                fecha_actual.set(Calendar.DAY_OF_YEAR,dia);
                this.jDateChooserDeadline.setCalendar(fecha_actual);
            
        }
        
    }//GEN-LAST:event_jDeadlineTimeChooserPropertyChange
    
    private void restart_filesTextFieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_restart_filesTextFieldKeyPressed
        
        String restartfiles = this.restart_filesTextField.getText();
        
        this.restart_filesTextField.setText(restartfiles.replace("/","").replace(" ",""));
        try {
            
            this.restartFile = Fichero.constructorFicheroRestart(this.restart_filesTextField.getText(),false);
        } catch (URISyntaxException ex) {
            
        }
        
        
    }//GEN-LAST:event_restart_filesTextFieldKeyPressed
    
    private void jTipoComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jTipoComboBoxItemStateChanged
        if (this.jTipoComboBox.getSelectedIndex() != -1) {
            if (this.jTipoComboBox.getSelectedItem().toString().compareTo("Multiple") == 0 ||
                    this.jTipoComboBox.getSelectedItem().toString().compareTo("MPI") == 0)
                
                this.NPTextField.setEnabled(true);
            
            else
                this.NPTextField.setEnabled(false);
            
        } else
            this.NPTextField.setEnabled(false);
    }//GEN-LAST:event_jTipoComboBoxItemStateChanged
    
    private void jPreWrapperMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPreWrapperMouseClicked
        if (this.jButton3.isEnabled() == false)
            return;
        
        AddInputFile dialogo_examinar = null;
        this.conexion = ((GUI)parent).conexion;
        if (this.prewrapper != null)
            dialogo_examinar = new AddInputFile(parent,true,this.preWrapperTextField.getText(),null,true,conexion,prewrapper.fichero_local);
        
        else
            dialogo_examinar = new AddInputFile(parent,true,this.preWrapperTextField.getText(),null,true,conexion,true);
        
        dialogo_examinar.setVisible(true);
        
        if (dialogo_examinar.aceptar == true) {
            this.preWrapperTextField.setText(dialogo_examinar.getFichero().toString());
            this.prewrapper = dialogo_examinar.getFichero();
        }
    }//GEN-LAST:event_jPreWrapperMouseClicked
    
    private void jWrapperMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jWrapperMouseClicked
        if (this.jButton2.isEnabled() == false)
            return;
        
        AddInputFile dialogo_examinar = null;
        this.conexion = ((GUI)parent).conexion;
        if (this.wrapper != null)
            dialogo_examinar = new AddInputFile(parent,true,this.wrapperTextField.getText(),null,true,conexion,wrapper.fichero_local);
        
        else
            dialogo_examinar = new AddInputFile(parent,true,this.wrapperTextField.getText(),null,true,conexion,true);
        
        dialogo_examinar.setVisible(true);
        
        if (dialogo_examinar.aceptar == true) {
            this.wrapperTextField.setText(dialogo_examinar.getFichero().toString());
            this.wrapper = dialogo_examinar.getFichero();
        }
        
    }//GEN-LAST:event_jWrapperMouseClicked
    
    private void jCancelarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCancelarMouseClicked
        
        this.aceptar = false;
        this.setVisible(false);
    }//GEN-LAST:event_jCancelarMouseClicked
    
    private void jAceptarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jAceptarMouseClicked
        
        if (this.nombreTareaTextField.getText().compareTo("") == 0) {
            JOptionPane.showMessageDialog(interfaz, "The task needs a name! ",
                    "Error", JOptionPane.ERROR_MESSAGE);
            
            return;
        }
        this.aceptar = true;
        this.interfaz.workflow_actual.setModified();
        this.setVisible(false);
    }//GEN-LAST:event_jAceptarMouseClicked
    
    
    
    boolean esBisiesto(int year) {
        return (year % 4 == 0 && year % 100 != 0) || year % 400 == 0;
        
    }
    
    private void jButton4jEditarArgumentosPreWrapperMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton4jEditarArgumentosPreWrapperMouseClicked
        if (this.jButton4.isEnabled() == false)
            return;
        EditorArgumentos dialogo = new paqInterfaz.EditorArgumentos(parent,true,this.argumentosPreWrapperTextField.getText());
        
        dialogo.setVisible(true);
        if (dialogo.aceptar == true) {
            this.argumentosPreWrapperTextField.setText(dialogo.getArguments());
        }
    }//GEN-LAST:event_jButton4jEditarArgumentosPreWrapperMouseClicked
    
    public void setTaskParametersFromDialog(Tarea tarea) {
        
        if (tarea  instanceof TareaMultiple) {
            try {
                ((TareaMultiple)tarea).numeroTareas = Integer.parseInt(this.numeroTrabajosTextField.getText());
            }catch(NumberFormatException e) {
                ((TareaMultiple)tarea).numeroTareas = 1;
            }
            
        }
        tarea.nombre = this.nombreTareaTextField.getText();
        
        tarea.argumentos = this.argumentostextField.getText();
        
        tarea.variables = this.variablesEntornoTextField.getText();
        
        tarea.tipo = this.jTipoComboBox.getSelectedIndex();
        
        if (tarea.tipo != this.SINGLE) {
            try {
                tarea.np = Integer.parseInt(this.NPTextField.getText());
            }catch(NumberFormatException e) {
                tarea.np = 0;
            }
        } else
            tarea.np = 0;
        
        
        tarea.ejecutable = this.ejecutable;
        
        try {
            tarea.tiempo_maximo_de_suspension = Integer.parseInt(this.tiempoMaxSuspensionTextField.getText());
        }catch(NumberFormatException e) {
            tarea.tiempo_maximo_de_suspension = 0;
        }
        
        try {
            tarea.umbral_carga_cpu = Integer.parseInt(this.umbralCargaCPUTextField.getText());
        }catch(NumberFormatException e) {
            tarea.umbral_carga_cpu = 0;
        }
        
        tarea.programa_monitor = this.monitor;
        
        if (this.volveraPlanificarComboBox.getSelectedIndex() == 0)
            tarea.planificarSiFallo = true;
        
        else if (this.volveraPlanificarComboBox.getSelectedIndex() == 1)
            tarea.planificarSiFallo = false;
        
        tarea.stdin = this.stdin;
        tarea.stdout = this.stdout;
        
        tarea.stderr = this.stderr;
        
        tarea.requisitosTarea = this.requisitosTextArea.getText();
        
        tarea.rankingTarea = this.rankingTextArea1.getText();
        
        tarea.restartFile = this.restartFile;
        
        try {
            tarea.intervaloCheckpoint = Integer.parseInt(this.intervaloCheckpointTextField.getText());
        }catch(NumberFormatException e) {
            tarea.intervaloCheckpoint = 0;
        }
        
        tarea.checkpointURL = this.checkpointURLTextField.getText();
        
        
        
        
        
        
        try {
            tarea.intervaloPlanificacion = Integer.parseInt(this.intervaloplanificacionTextField.getText());
            tarea.umbralPlanificacion = Integer.parseInt(this.umbralPlanificacionTextField.getText());
        }catch(NumberFormatException e) {
            tarea.intervaloPlanificacion = 0;
            tarea.umbralPlanificacion = 0;
        }
        
        tarea.tiempoDeadline = this.jDateChooserDeadline.getDate();
        
        tarea.wrapper = this.wrapper;
        
        tarea.preWrapper = this.prewrapper;
        
        tarea.argumentosPreWrapper = this.argumentosPreWrapperTextField.getText();
        
        
        
        this.intervaloplanificacionTextField.setText(""+tarea.intervaloPlanificacion);
        
        this.umbralPlanificacionTextField.setText(""+tarea.umbralPlanificacion);
        
        
        
        ////////////////////////////////////////////////////////////////////////////
        tarea.tiempoDeadline = this.jDateChooserDeadline.getDate();
        
        
        ////////////////////////////////////////////////////////////////////////////
        
        this.wrapper = tarea.wrapper;
        
        this.prewrapper = tarea.preWrapper;
        
        this.argumentosPreWrapperTextField.setText(tarea.argumentosPreWrapper);
        
    }
    
    
    
    public void setTaskDialogParameters(Tarea tarea) {
        
        if (tarea != null && tarea instanceof TareaMultiple)
            this.numeroTrabajosTextField.setText(""+((TareaMultiple)tarea).numeroTareas);
        
        this.nombreTareaTextField.setText(tarea.nombre);
        
        this.argumentostextField.setText(tarea.argumentos);
        
        this.variablesEntornoTextField.setText(tarea.variables);
        
        this.jTipoComboBox.setSelectedIndex(tarea.tipo);
        
        if (tarea.tipo == this.MULTIPLE  || tarea.tipo == this.MPI) {
            this.NPTextField.setEnabled(true);
            
            this.NPTextField.setText(""+tarea.np);
        }
        
        
        
        
        
        this.ejecutableTextField.setText(tarea.ejecutable.toString());
        
        this.ejecutable = tarea.ejecutable;
        
        this.tiempoMaxSuspensionTextField.setText(""+tarea.tiempo_maximo_de_suspension);
        
        this.umbralCargaCPUTextField.setText(""+tarea.umbral_carga_cpu);
        
        if (tarea.programa_monitor != null)
            this.monitorTextField.setText(tarea.programa_monitor.toString());
        
        this.monitor = tarea.programa_monitor;
        
        if (tarea.planificarSiFallo ==  true)
            this.volveraPlanificarComboBox.setSelectedIndex(0);
        
        else
            this.volveraPlanificarComboBox.setSelectedIndex(1);
        
        
        this.stdinTextField.setText(tarea.stdin.toString());
        this.stdin = tarea.stdin;
        
        this.stdoutTextField.setText(tarea.stdout.toString());
        
        this.stdout = tarea.stdout;
        
        this.stderrTextField.setText(tarea.stderr.toString());
        
        this.stderr = tarea.stderr;
        
        this.requisitosTextArea.setText(tarea.requisitosTarea);
        
        this.rankingTextArea1.setText(tarea.rankingTarea);
        
        this.restart_filesTextField.setText(tarea.restartFile.toString());
        
        this.restartFile = tarea.restartFile;
        
        this.intervaloCheckpointTextField.setText(""+tarea.intervaloCheckpoint);
        
        this.checkpointURLTextField.setText(tarea.checkpointURL);
        
        ////////////////////////////////////////////////////////////////////////////////////////////////
        
        
        for (int i = 0;i<tarea.ficherosEntrada.size();i++) {
            this.InFileslist.add(tarea.ficherosEntrada.get(i).toString());
        }
        
        
        for (int i = 0;i<tarea.ficherosSalida.size();i++) {
            this.OutFilesList.add(tarea.ficherosSalida.get(i).toString());
            
        }
        
        this.intervaloplanificacionTextField.setText(""+tarea.intervaloPlanificacion);
        
        this.umbralPlanificacionTextField.setText(""+tarea.umbralPlanificacion);
        
        if (tarea.tiempoDeadline == null) {
            
        /*Ahora se inicializa la fecha del jDateChooser que será la fecha de deadline de la tarea. Por defecto 1 día.
         */
            
            this.tarea = tarea;
            Calendar fecha_actual = Calendar.getInstance();
            
            int dia = fecha_actual.get(Calendar.DAY_OF_YEAR);
            
            int year = fecha_actual.get(Calendar.YEAR);
            
            if (esBisiesto(year) == true) {
                if (dia == 366)
                    dia = 1;
                else dia++;
            } else if (dia == 365)
                dia = 1;
            else
                dia++;
            
            

            
            fecha_actual.set(Calendar.DAY_OF_YEAR,dia);
            
            
            this.jDateChooserDeadline.setCalendar(fecha_actual); //Se ajusta la fecha de deadline a un día de distancia.
            
        }
        
        else
        this.jDateChooserDeadline.setDate(tarea.tiempoDeadline);
        
        
        
        /***************Ahora se inicializa el jtimechooser********/
        
        
        this.wrapperTextField.setText(tarea.wrapper.toString());
        this.wrapper = tarea.wrapper;
        
        this.prewrapper = tarea.preWrapper;
        this.preWrapperTextField.setText(tarea.preWrapper.toString());
        
        this.argumentosPreWrapperTextField.setText(tarea.argumentosPreWrapper);
        
        
        
    }
    
    private void jDateChooserDeadlinePropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jDateChooserDeadlinePropertyChange
        Calendar fecha_actual = Calendar.getInstance();
        
        if (this.jDateChooserDeadline.getDate() == null)
            return;
        
        
        Calendar fecha_seleccionada = this.jDateChooserDeadline.getCalendar();
        
        
        //fecha_seleccionada.set(Calendar.HOUR_OF_DAY,hora_seleccionada.get(Calendar.HOUR_OF_DAY));
        //fecha_seleccionada.set(Calendar.MINUTE,hora_seleccionada.get(Calendar.MINUTE));
        
        if (fecha_actual.getTime().compareTo(fecha_seleccionada.getTime()) == 1)
            
        {
            
        //JOptionPane.showMessageDialog(this, "The deadline time must be in the future not in the past!", "Error", JOptionPane.ERROR_MESSAGE);
                  
            int dia = fecha_actual.get(Calendar.DAY_OF_YEAR);
            
            int year = fecha_actual.get(Calendar.YEAR);
            
            if (esBisiesto(year) == true) {
                if (dia == 366)
                    dia = 1;
                else dia++;
            } else if (dia == 365)
                dia = 1;
            
            else
                dia++;
            
            fecha_actual.set(Calendar.DAY_OF_YEAR,dia);
            this.jDateChooserDeadline.setCalendar(fecha_actual);
            
            
        }
        
        
    }//GEN-LAST:event_jDateChooserDeadlinePropertyChange
    
    private void jButton21jAnadirFicherosSalidaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton21jAnadirFicherosSalidaMouseClicked
        this.conexion = ((GUI)parent).conexion;
        AddOutputFilesDialog dialogo = new AddOutputFilesDialog(parent,true, this.tarea.ficherosSalida,this,conexion);
        
        dialogo.setVisible(true);
        
        if (dialogo.aceptar == true) {
            this.OutFilesList.removeAll();
            ArrayList files = dialogo.getFiles();
            
            this.tarea.ficherosSalida.clear();
            
            for (int i = 0;i<files.size();i++) {
                this.OutFilesList.add(files.get(i).toString());
                this.tarea.ficherosSalida.add(files.get(i));
            }
        }
    }//GEN-LAST:event_jButton21jAnadirFicherosSalidaMouseClicked
    
    private void jButton20jAnadirFicherosEntradaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton20jAnadirFicherosEntradaMouseClicked
        this.conexion = ((GUI)parent).conexion;
        AddInPutFilesDialog dialogo = new AddInPutFilesDialog(parent,true,this.tarea.ficherosEntrada,this,this.conexion);
        
        dialogo.setVisible(true);
        
        if (dialogo.aceptar == true) {
            this.InFileslist.removeAll();
            ArrayList ficheros = dialogo.getFicheros(); //Devuelve un arraylist de objetos fichero
            
            this.tarea.ficherosEntrada.clear();
            for (int i = 0;i<ficheros.size();i++) {
                
                Fichero aux = (Fichero) ficheros.get(i);
                
                this.InFileslist.add(aux.toString());
                this.tarea.ficherosEntrada.add(aux);
            }
            
            
        }
    }//GEN-LAST:event_jButton20jAnadirFicherosEntradaMouseClicked
    
    private void jButton30jChequearRankingMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton30jChequearRankingMouseClicked
        SintacticoRanking sintax = new SintacticoRanking(this.rankingTextArea1.getText());
        
        try  {
            sintax.Analizar();
            if (sintax.getLexErrores().size() == 0)
                JOptionPane.showMessageDialog(this, "No errors were found", "", JOptionPane.INFORMATION_MESSAGE);
            else {
                ErroresSintacticosDialog dialogo= new ErroresSintacticosDialog(parent,true,sintax.getLexErrores());
                dialogo.setVisible(true);
            }
            
        }catch(Exception e) {
            
            
            JOptionPane.showMessageDialog(this, e.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            ErroresSintacticosDialog dialogo= new ErroresSintacticosDialog(parent,true,sintax.getLexErrores());
            if (sintax.getLexErrores().size() > 0)
                dialogo.setVisible(true);
            
        }
    }//GEN-LAST:event_jButton30jChequearRankingMouseClicked
                
    private void jButton40jParentesisDchaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton40jParentesisDchaMouseClicked
        this.rankingTextArea1.setText(this.rankingTextArea1.getText()+")");
    }//GEN-LAST:event_jButton40jParentesisDchaMouseClicked
    
    private void jButton39jParentesisIzdaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton39jParentesisIzdaMouseClicked
        this.rankingTextArea1.setText(this.rankingTextArea1.getText()+"(");
    }//GEN-LAST:event_jButton39jParentesisIzdaMouseClicked
                                
    private void jButton28jDividirMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton28jDividirMouseClicked
        this.rankingTextArea1.setText(this.rankingTextArea1.getText()+"/");
    }//GEN-LAST:event_jButton28jDividirMouseClicked
    
    private void jButton27jMultiplicarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton27jMultiplicarMouseClicked
        this.rankingTextArea1.setText(this.rankingTextArea1.getText()+"*");
    }//GEN-LAST:event_jButton27jMultiplicarMouseClicked
    
    private void jButton26jRestarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton26jRestarMouseClicked
        this.rankingTextArea1.setText(this.rankingTextArea1.getText()+"-");
    }//GEN-LAST:event_jButton26jRestarMouseClicked
    
    private void jButton25jSumarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton25jSumarMouseClicked
        this.rankingTextArea1.setText(this.rankingTextArea1.getText()+"+");
    }//GEN-LAST:event_jButton25jSumarMouseClicked
    
    private void listaParametrosList2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_listaParametrosList2MouseClicked
        if (this.listaParametrosList2.getSelectedIndex() != -1) {
            this.rankingTextArea1.setText(this.rankingTextArea1.getText()+this.listaParametrosList2.getSelectedItem());
        }
    }//GEN-LAST:event_listaParametrosList2MouseClicked
    
    private void jButton47jChequearExpresionMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton47jChequearExpresionMouseClicked
        SintacticoRequisitos sintax = new SintacticoRequisitos(this.requisitosTextArea.getText());
        
        try  {
            sintax.Analizar();
            if (sintax.getLexErrores().size() == 0)
                JOptionPane.showMessageDialog(this, "No errors were found", "", JOptionPane.INFORMATION_MESSAGE);
            else {
                ErroresSintacticosDialog dialogo= new ErroresSintacticosDialog(parent,true,sintax.getLexErrores());
                dialogo.setVisible(true);
            }
            
        }catch(Exception e) {
            
            
            JOptionPane.showMessageDialog(this, e.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            ErroresSintacticosDialog dialogo= new ErroresSintacticosDialog(parent,true,sintax.getLexErrores());
            if (sintax.getLexErrores().size() > 0)
                dialogo.setVisible(true);
            
        }
        
        
    }//GEN-LAST:event_jButton47jChequearExpresionMouseClicked
    
    private void jButton46jNOTMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton46jNOTMouseClicked
        this.requisitosTextArea.setText(this.requisitosTextArea.getText()+"!");
    }//GEN-LAST:event_jButton46jNOTMouseClicked
    
    private void jButton45jORMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton45jORMouseClicked
        this.requisitosTextArea.setText(this.requisitosTextArea.getText()+"|");
    }//GEN-LAST:event_jButton45jORMouseClicked
    
    private void jButton44jANDMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton44jANDMouseClicked
        this.requisitosTextArea.setText(this.requisitosTextArea.getText()+"&");
    }//GEN-LAST:event_jButton44jANDMouseClicked
    
    private void jButton43jIgualQueMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton43jIgualQueMouseClicked
        this.requisitosTextArea.setText(this.requisitosTextArea.getText()+"=");
    }//GEN-LAST:event_jButton43jIgualQueMouseClicked
    
    private void jButton42jMayorQueMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton42jMayorQueMouseClicked
        this.requisitosTextArea.setText(this.requisitosTextArea.getText()+">");
    }//GEN-LAST:event_jButton42jMayorQueMouseClicked
    
    private void jButton41jMenorQueMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton41jMenorQueMouseClicked
        this.requisitosTextArea.setText(this.requisitosTextArea.getText()+"<");
    }//GEN-LAST:event_jButton41jMenorQueMouseClicked
    
    private void jButton10jParentesisDchaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton10jParentesisDchaMouseClicked
        this.requisitosTextArea.setText(this.requisitosTextArea.getText()+")");
    }//GEN-LAST:event_jButton10jParentesisDchaMouseClicked
    
    private void jButton8jParentesisIzdaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton8jParentesisIzdaMouseClicked
        this.requisitosTextArea.setText(this.requisitosTextArea.getText()+"(");
    }//GEN-LAST:event_jButton8jParentesisIzdaMouseClicked
                                            
    private void listaParametrosListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_listaParametrosListMouseClicked
        if (this.listaParametrosList.getSelectedIndex() != -1)
            this.requisitosTextArea.setText(this.requisitosTextArea.getText()+this.listaParametrosList.getSelectedItem());
    }//GEN-LAST:event_listaParametrosListMouseClicked
    
    private void jButton24jEditarStdErrMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton24jEditarStdErrMouseClicked
        this.conexion = ((GUI)parent).conexion;
        AddOutPutFile dialogooutput = new AddOutPutFile(parent,true,null,this.stderrTextField.getText(),true,conexion,true);
        
        dialogooutput.setVisible(true);
        
        if (dialogooutput.aceptar == true) {
            this.stderrTextField.setText(dialogooutput.getFichero().toString());
            this.stderr = dialogooutput.getFichero();
        }
    }//GEN-LAST:event_jButton24jEditarStdErrMouseClicked
    
    private void jButton23jEditarStdoutMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton23jEditarStdoutMouseClicked
        this.conexion = ((GUI)parent).conexion;
        AddOutPutFile dialogooutput = new AddOutPutFile(parent,true,null,this.stdoutTextField.getText(),true,conexion,true);
        
        dialogooutput.setVisible(true);
        
        if (dialogooutput.aceptar == true) {
            this.stdoutTextField.setText(dialogooutput.getFichero().toString());
            this.stdout = dialogooutput.getFichero();
        }
    }//GEN-LAST:event_jButton23jEditarStdoutMouseClicked
    
    private void jButton22jEditarStdinMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton22jEditarStdinMouseClicked
        this.conexion = ((GUI)parent).conexion;
        AddInputFile dialogoinput = new AddInputFile(parent,true,this.stdinTextField.getText(),null,true,conexion,true);
        
        dialogoinput.setVisible(true);
        
        if (dialogoinput.aceptar == true) {
            this.stdinTextField.setText(dialogoinput.getFichero().toString());
            this.stdin = dialogoinput.getFichero();
        }
    }//GEN-LAST:event_jButton22jEditarStdinMouseClicked
    
    private void jButton1jExaminarMonitorMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1jExaminarMonitorMouseClicked
        this.conexion = ((GUI)parent).conexion;
        AddInputFile dialogo_examinar = null;
        if (this.monitor != null)
            dialogo_examinar = new AddInputFile(parent,true,this.preWrapperTextField.getText(),null,true,conexion,this.monitor.fichero_local);
        
        else
            dialogo_examinar = new AddInputFile(parent,true,this.preWrapperTextField.getText(),null,true,conexion,true);
        
        dialogo_examinar.setVisible(true);
        
        if (dialogo_examinar.aceptar == true) {
            this.monitorTextField.setText(dialogo_examinar.getFichero().toString());
            this.monitor = dialogo_examinar.getFichero();
        }
        
    }//GEN-LAST:event_jButton1jExaminarMonitorMouseClicked
    
    private void NPTextFieldPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_NPTextFieldPropertyChange
        int NP = -1;
        try {
            NP = Integer.parseInt(this.NPTextField.getText());
        }catch(NumberFormatException e) {
            System.out.println(e);
        }
    }//GEN-LAST:event_NPTextFieldPropertyChange
    
    private void jTipoComboBoxPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jTipoComboBoxPropertyChange
        if (this.jTipoComboBox.getSelectedIndex() != -1) {
            if (this.jTipoComboBox.getSelectedItem().toString().compareTo("Multiple") == 0 ||
                    this.jTipoComboBox.getSelectedItem().toString().compareTo("MPI") == 0)
                
                this.NPTextField.setEnabled(true);
            
            else
                this.NPTextField.setEnabled(false);
            
        } else
            this.NPTextField.setEnabled(false);
    }//GEN-LAST:event_jTipoComboBoxPropertyChange
    
    private void jButton19jEditarVariablesEntornoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton19jEditarVariablesEntornoMouseClicked
        
        EnvironmentEditor dialogo = new EnvironmentEditor(parent,true,this.variablesEntornoTextField.getText());
        
        dialogo.setVisible(true);
        
        if (dialogo.aceptar == true) {
            this.variablesEntornoTextField.setText(dialogo.getVariables());
        }
    }//GEN-LAST:event_jButton19jEditarVariablesEntornoMouseClicked
    
    private void jButton18jEditarArgumentosMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton18jEditarArgumentosMouseClicked
        EditorArgumentos dialogo = new paqInterfaz.EditorArgumentos(parent,true,this.argumentostextField.getText());
        
        dialogo.setVisible(true);
        if (dialogo.aceptar == true) {
            this.argumentostextField.setText(dialogo.getArguments());
        }
    }//GEN-LAST:event_jButton18jEditarArgumentosMouseClicked
    
    private void jButton17jExaminarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton17jExaminarMouseClicked
/*Este gestor de eventos se lanza cuando se selecciona la opción de examinar para buscar un ejecutable válido
 *para nuestra tarea*/
        AddInputFile dialogo_examinar = null;
        this.conexion = ((GUI)parent).conexion;
        if (this.ejecutable != null)
            dialogo_examinar = new AddInputFile(parent,true,this.ejecutableTextField.getText(),
                    null,true,conexion,this.ejecutable.fichero_local);
        
        else
            dialogo_examinar = new AddInputFile(parent,true,this.ejecutableTextField.getText(),
                    null,true,conexion, true);
        
        dialogo_examinar.setVisible(true);
        
        if (dialogo_examinar.aceptar == true) {
            this.ejecutableTextField.setText(dialogo_examinar.getFichero().toString());
            this.ejecutable = dialogo_examinar.getFichero();
        }
        
                /*
        JFileChooser dialogo_examinar = new JFileChooser();
                 
        int returnVal = dialogo_examinar.showOpenDialog(this);
                 
        dialogo_examinar.setDialogTitle("Examinar la ubicación del ejecutable");
                 
        dialogo_examinar.setFileSelectionMode(JFileChooser.FILES_ONLY); //Sólo archivos.
                 
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            this.ejecutableTextField.setText(dialogo_examinar.getSelectedFile().getName());
                 
        }
                 **/
    }//GEN-LAST:event_jButton17jExaminarMouseClicked
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    
    
    
    // Declaración de varibales -no modificar//GEN-BEGIN:variables
    private java.awt.List InFileslist;
    private java.awt.TextField NPTextField;
    private java.awt.List OutFilesList;
    private javax.swing.JTextField argumentosPreWrapperTextField;
    private java.awt.TextField argumentostextField;
    private javax.swing.JTextField checkpointURLTextField;
    private java.awt.TextField ejecutableTextField;
    private javax.swing.JTextField intervaloCheckpointTextField;
    private javax.swing.JTextField intervaloplanificacionTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton10;
    private javax.swing.JButton jButton17;
    private javax.swing.JButton jButton18;
    private javax.swing.JButton jButton19;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton20;
    private javax.swing.JButton jButton21;
    private javax.swing.JButton jButton22;
    private javax.swing.JButton jButton23;
    private javax.swing.JButton jButton24;
    private javax.swing.JButton jButton25;
    private javax.swing.JButton jButton26;
    private javax.swing.JButton jButton27;
    private javax.swing.JButton jButton28;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton30;
    private javax.swing.JButton jButton34;
    private javax.swing.JButton jButton37;
    private javax.swing.JButton jButton39;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton40;
    private javax.swing.JButton jButton41;
    private javax.swing.JButton jButton42;
    private javax.swing.JButton jButton43;
    private javax.swing.JButton jButton44;
    private javax.swing.JButton jButton45;
    private javax.swing.JButton jButton46;
    private javax.swing.JButton jButton47;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton8;
    private com.toedter.calendar.JDateChooser jDateChooserDeadline;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JComboBox jTipoComboBox;
    private javax.swing.JPanel jarrayTrabajosPanel;
    private java.awt.Label label1;
    private java.awt.Label label10;
    private java.awt.Label label11;
    private java.awt.Label label12;
    private java.awt.Label label13;
    private java.awt.Label label2;
    private java.awt.Label label24;
    private java.awt.Label label25;
    private java.awt.Label label26;
    private java.awt.Label label27;
    private java.awt.Label label28;
    private java.awt.Label label29;
    private java.awt.Label label3;
    private java.awt.Label label30;
    private java.awt.Label label4;
    private java.awt.Label label5;
    private java.awt.Label label6;
    private java.awt.Label label7;
    private java.awt.Label label8;
    private java.awt.Label label9;
    private java.awt.List listaParametrosList;
    private java.awt.List listaParametrosList2;
    private javax.swing.JTextField monitorTextField;
    private java.awt.TextField nombreTareaTextField;
    private javax.swing.JTextField numeroTrabajosTextField;
    private javax.swing.JTextField preWrapperTextField;
    private javax.swing.JTextArea rankingTextArea1;
    private javax.swing.JTextField reintentosTextField;
    private javax.swing.JTextArea requisitosTextArea;
    private javax.swing.JTextField restart_filesTextField;
    private java.awt.TextField stderrTextField;
    private java.awt.TextField stdinTextField;
    private java.awt.TextField stdoutTextField;
    private javax.swing.JTextField tiempoMaxSuspensionTextField;
    private javax.swing.JTextField umbralCargaCPUTextField;
    private javax.swing.JTextField umbralPlanificacionTextField;
    private java.awt.TextField variablesEntornoTextField;
    private javax.swing.JComboBox volveraPlanificarComboBox;
    private javax.swing.JTextField wrapperTextField;
    // Fin de declaración de variables//GEN-END:variables
    
}
