/*
 * TreeMouseListener.java
 *
 * Created on 20 de septiembre de 2007, 7:31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;

import java.awt.AWTEvent;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.tree.DefaultMutableTreeNode;
import org.jgraph.graph.DefaultEdge;
import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.GraphConstants;
/**
 *
 * @author globus
 */
public class TreeMouseListener implements MouseListener{
    
    /** Creates a new instance of TreeMouseListener */
    
    
    
    
    GUI interfaz;
    
    JPopupMenu popupTarea;
    JPopupMenu popupDependencia;
    JPopupMenu popupWorkFlow;
    JMenuItem menuItem;
    
    public TreeMouseListener(GUI pointer) {
        this.interfaz = pointer;
        
        
        popupTarea = new JPopupMenu();
        menuItem = new JMenuItem("Edit");
        
        menuItem.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
               
                interfaz.habilitarBorrarTask(true);
                interfaz.habilitarBorrarDep(false);
                interfaz.workflow_actual.deSeleccionarTodos();
                
                Tarea tarea = interfaz.workflow_actual.getTarea(interfaz.workflow_actual.seleccionado.toString());
                String nameaux = tarea.nombre;
                
                TaskEditorDialog dialogoedicion = new TaskEditorDialog((Frame) interfaz, true,interfaz,tarea,interfaz.conexion);
                
                dialogoedicion.setVisible(true);
                
                while(true) {
                    if (dialogoedicion.aceptar == true) {
                        
                        if (interfaz.workflow_actual.setName(dialogoedicion.getName(),nameaux,
                                interfaz.workflow_actual.seleccionado) == true) {
                            dialogoedicion.setTaskParametersFromDialog(tarea);
                            break;
                        } else {
                            dialogoedicion.aceptar = false;
                            dialogoedicion.setVisible(true);
                            
                        }
                        
                    }
                    
                    else {
                        interfaz.workflow_actual.seleccionado = null;
                        interfaz.habilitarBorrarTask(false);
                        interfaz.workflow_actual.deSeleccionarTodos();
                        break;
                    }
                    
                    
                }
                
                
                
                
            }
            
        }
        
        
        );
        
        popupTarea.add(menuItem);
        
        
        menuItem = new JMenuItem("Remove");
        
        menuItem.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                
                interfaz.workflow_actual.deleteTask(interfaz.workflow_actual.seleccionado,true);
                
            }
            
        }
        
        
        );
        
        popupTarea.add(menuItem);
        
        /////////////////////////////////////////////////////////////////////////////////////////
        
        popupDependencia = new JPopupMenu();
        menuItem = new JMenuItem("Remove");
        
        menuItem.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                interfaz.workflow_actual.deleteDep(interfaz.workflow_actual.dependencia,false);
                
            }
            
        }
        
        
        );
        
        popupDependencia.add(menuItem);
        
        
        menuItem = new JMenuItem("Edit");
        menuItem.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                
                
                Dependencia aux = interfaz.workflow_actual.getDependencyObject(interfaz.workflow_actual.getDependencia().toString());
                
                Tarea tarea1 = aux.tarea1;
                Tarea tarea2 = aux.tarea2;
                
                
                ArrayList ficheros_dependientes = new ArrayList();
                
                for (int i = 0;i<tarea1.ficherosSalida.size();i++) {
                    Fichero fichero = (Fichero)tarea1.ficherosSalida.get(i);
                    if (tarea2.contieneFicheroEntrada(fichero) == true)
                        ficheros_dependientes.add(fichero);
                }
                
                EditorDependenciaDialog dialog = new EditorDependenciaDialog(interfaz,true,tarea1.ficherosSalida,ficheros_dependientes);
                
                
                ficheros_dependientes = new ArrayList();
                dialog.setVisible(true);
                
                if (dialog.aceptar == true) {
                    
                    ficheros_dependientes = dialog.getSelectedFiles();
                    
                    
                    
                    
                    ArrayList ficheros_antiguos = aux.obtieneFicheros();
                    
                    for (int i = 0;i< ficheros_antiguos.size();i++) {
                        tarea2.eliminaFicheroEntrada((Fichero)ficheros_antiguos.get(i)); //Elimina los ficheros dependientes de la tarea 2
                    }
                    
                    aux.eliminaTodos(); //Elimina los ficheros de la dependencia
                    
                    for (int i = 0;i<ficheros_dependientes.size();i++) {
                        
              /*Añade los nuevos ficheros a la tarea dependiente y a la dependencia.
               Para añadir los ficheros a la tarea dependientes previamente ha de transformar los ficheros de salida a entrada*/
                        aux.anadeFichero((Fichero)ficheros_dependientes.get(i));
                        tarea2.anadeFicheroEntrada(((Fichero)ficheros_dependientes.get(i)).convertirDeSalidaAEntrada());
                    }
                }
            }
        }
        
        );
        
        popupDependencia.add(menuItem);
        
        
        //////////////////////////////////////////////////////////////////////////////////////////
        
        popupWorkFlow = new JPopupMenu();
        
        menuItem = new JMenuItem("Close");
        
        menuItem.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                interfaz.cerrarWorkFlow(); //Cierra el workflow actual
                
            }
            
        }
        
        );
        
        popupWorkFlow.add(menuItem);
        
        
    }
    
    
    
    
    
    public WorkFlow obtenerWorkFlow(DefaultMutableTreeNode tree)
    
    
    {
        
        DefaultMutableTreeNode aux = null;
        
        if (tree == null) return null;
        
        if (tree.getParent() != null && tree.getParent().toString().compareTo("WorkFlows") == 0) //Se ha seleccionado un workflow
            aux = tree;
        
        //Se ha seleccionado dependencias o tareas
        else if (tree.getParent() != null && (tree.getParent().toString().compareTo("Tasks") == 0 || tree.getParent().toString().compareTo("Dependencias") == 0))
            aux = (DefaultMutableTreeNode) tree.getParent().getParent();
        
        else if (tree.getParent() != null && tree.getParent().getParent().toString().compareTo("WorkFlows") == 0 )
            aux = (DefaultMutableTreeNode) tree.getParent(); //Se ha seleccionad un workflow
        
        if (aux == null)
            return null;
        
        for (int i = 0;i<this.interfaz.workflows.size();i++) {
            WorkFlow aux2 = (WorkFlow)this.interfaz.workflows.get(i);
            if (aux.toString().compareTo(aux2.toString()) == 0)
                return aux2;
            
        }
        
        return null;
        
        
    }
    
    /*El controlador de eventos asociado al árbol lateral está implementado aquí, cada vez que se pincha en el panel del árbol
     se ejecuta el siguiente código que determina el nodo sobre el que se ha pinchado y se toman las acciones necesarias
     en el interfaz gráfico.*/
    public void mouseClicked(MouseEvent e) {
        
        
        
        if (e.getClickCount() == 1) {
            DefaultMutableTreeNode aux = this.interfaz.treePanel.getSelection();
            
            WorkFlow workflow = this.obtenerWorkFlow(aux);
            
            if (workflow != null) {
                
                this.interfaz.workflow_actual = workflow;
                //this.interfaz.borrarTodos();
                this.interfaz.anadirComponentes(workflow.getGraph()); //Añade el objeto jgraph al panel para visualizar
                this.interfaz.habilitarCerrarWorkFlow(true);
                if (this.interfaz.creando_dependencia == true)
                    this.interfaz.workflow_actual.deSeleccionarTodos();
                
                
                if (this.interfaz.workflow_actual.ObtenerTipo(aux) == this.interfaz.workflow_actual.WORKFLOW) {
                    this.interfaz.habilitarBorrarDep(false);
                    this.interfaz.habilitarBorrarTask(false);
                    this.interfaz.habilitarCrearDep(true);
                    this.interfaz.habilitarCrearTarea(true);
                    
                    this.interfaz.workflow_actual.seleccionado = null;
                    this.interfaz.workflow_actual.dependencia = null;
                    this.interfaz.workflow_actual.nodo1 = this.interfaz.workflow_actual.nodo2 = null;
                    this.interfaz.workflow_actual.nodo1seleccionado = false;
                    this.interfaz.creando_dependencia = false;
                    this.interfaz.imprimirMensajeBarra("",false,null);
                    
                    this.interfaz.tree_workflow_actual = this.interfaz.treePanel.obtenerTreeNode(this.interfaz.workflow_actual);
                    
                    if (e.getButton() == e.BUTTON3) {
                        this.popupWorkFlow.show(e.getComponent(),e.getX(),e.getY());
                    }
                    
                } else if (this.interfaz.workflow_actual.ObtenerTipo(aux) == this.interfaz.workflow_actual.TAREA) {
                    this.interfaz.habilitarBorrarDep(false);
                    this.interfaz.habilitarBorrarTask(true);
                    this.interfaz.habilitarCrearDep(true);
                    this.interfaz.habilitarCrearTarea(true);
                    
                    this.interfaz.workflow_actual.seleccionado = this.interfaz.workflow_actual.getGraphCellFromTreeNode(aux);
                    this.interfaz.workflow_actual.nodo1 = this.interfaz.workflow_actual.nodo2 = null;
                    this.interfaz.workflow_actual.dependencia = null;
                    this.interfaz.workflow_actual.nodo1seleccionado = false;
                    this.interfaz.creando_dependencia = false;
                    
                    this.interfaz.imprimirMensajeLog("Selected "+this.interfaz.workflow_actual.seleccionado.toString());
                    this.interfaz.imprimirMensajeBarra("",false,null);
                    this.interfaz.tree_workflow_actual = this.interfaz.treePanel.obtenerTreeNode(this.interfaz.workflow_actual);
                    
                    if (e.getButton() == e.BUTTON3) {
                        this.popupTarea.show(e.getComponent(),e.getX(),e.getY());
                    }
                    
                    
                }
                
                else if (this.interfaz.workflow_actual.ObtenerTipo(aux) == this.interfaz.workflow_actual.DEPENDENCIA) {
                    this.interfaz.habilitarBorrarDep(true);
                    this.interfaz.habilitarBorrarTask(false);
                    this.interfaz.habilitarCrearTarea(true);
                    this.interfaz.habilitarCrearDep(true);
                    
                    this.interfaz.workflow_actual.seleccionado = null;
                    this.interfaz.workflow_actual.dependencia = (DefaultEdge) this.interfaz.workflow_actual.getGraphCellFromTreeNode(aux);
                    this.interfaz.workflow_actual.nodo1 = this.interfaz.workflow_actual.nodo2 = null;
                    this.interfaz.workflow_actual.nodo1seleccionado = false;
                    this.interfaz.creando_dependencia = false;
                    this.interfaz.workflow_actual.seleccionado = null;
                    this.interfaz.tree_workflow_actual = this.interfaz.treePanel.obtenerTreeNode(this.interfaz.workflow_actual);
                    
                    if (e.getButton() == e.BUTTON3) {
                        this.popupDependencia.show(e.getComponent(),e.getX(),e.getY());
                    }
                    
                }
                
                else if (this.interfaz.workflow_actual.ObtenerTipo(aux) == this.interfaz.workflow_actual.OTHER) {
                    this.interfaz.habilitarBorrarDep(false);
                    this.interfaz.habilitarBorrarTask(false);
                    this.interfaz.habilitarCrearTarea(true);
                    this.interfaz.habilitarCrearDep(true);
                    this.interfaz.workflow_actual.seleccionado = null;
                    
                    this.interfaz.workflow_actual.dependencia = null;
                    this.interfaz.workflow_actual.nodo1 = this.interfaz.workflow_actual.nodo2 = null;
                    this.interfaz.workflow_actual.nodo1seleccionado = false;
                    this.interfaz.creando_dependencia = false;
                    this.interfaz.workflow_actual.seleccionado = null;
                    this.interfaz.tree_workflow_actual = this.interfaz.treePanel.obtenerTreeNode(this.interfaz.workflow_actual);
                    
                }
                
                else
                    System.out.println("What happened?");
                
                
            }
            
        }
        
        
        
        
        else if (e.getClickCount() == 2) {
            
        }
    }
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public GUI getInterfaz() {
        return interfaz;
    }
    
    
    
}
