/*
 * WorkFlow.java
 *
 * Created on 19 de septiembre de 2007, 8:37
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
/* -------------------------------------------------------------------------- */
/* Copyright 2007-2008, Iván Fernández Hernández <rayban1984@gmail.com>       */
/*                                                                            */
/* Licensed under the Apache License, Version 2.0 (the "License"); you may    */
/* not use this file except in compliance with the License. You may obtain    */
/* a copy of the License at                                                   */
/*                                                                            */
/* http://www.apache.org/licenses/LICENSE-2.0                                 */
/*                                                                            */
/* Unless required by applicable law or agreed to in writing, software        */
/* distributed under the License is distributed on an "AS IS" BASIS,          */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   */
/* See the License for the specific language governing permissions and        */
/* limitations under the License.                                             */
/* -------------------------------------------------------------------------- */
package paqInterfaz;


import com.jscape.inet.sftp.SftpException;
import java.awt.Color;
import java.awt.Component;
import java.awt.GridBagLayout;

import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Date;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.tree.*;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import org.jdom.JDOMException;


import org.jgraph.JGraph;
import org.jgraph.event.GraphModelEvent;
import org.jgraph.event.GraphModelListener;
import org.jgraph.graph.DefaultEdge;
import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.DefaultGraphModel;
import org.jgraph.graph.DefaultPort;
import org.jgraph.graph.GraphCellEditor;
import org.jgraph.graph.GraphConstants;
import org.jgraph.graph.GraphModel;
import paqInterfaz.MouseDemo;
import paqInterfaz.WorkFlowXMLDoc;

/**
 *
 * @author globus
 */
public class WorkFlow implements GraphModelListener {
    public static int TAREA = 0;
    public static int DEPENDENCIA = 1;
    public static int WORKFLOW = 2;
    public static int OTHER = 3;
    
    public final Color color_seleccionado = Color.orange;
    
    public final Color color_tarea = new Color(110,90,216);
    
    public final Color color_bulk_job = new Color(86,202,17);
    
    int nodecounter;
    int noderealcounter;
    int bulkcounter = 0;
    int depcounter;
    
    public Tarea copia = null;
    
    ArrayList listaTareas;
    ArrayList listaDeps;
    
    boolean modificado;
    
    public String ruta = null;
    
    DefaultGraphCell seleccionado;
    
    boolean nodo1seleccionado;
    DefaultMutableTreeNode workflow_actual;
    
    
    DefaultGraphCell nodo1, nodo2;
    
    DefaultEdge dependencia;
    
    
    GraphModel model;
    /*
     public TGPanel tgpan = new TGPanel();
  TGLensSet tglen = new TGLensSet();
     
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
     *
     */
    
    
//protected TGUIManager tgUIManager = new TGUIManager();
    
    JGraph graph;
    
    /*Variables del trabajo*/
    
    GUI interfaz;
    
    String name;
    
    
    
    
    ////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    /*Este método genera en el directorio pasado como parámetro
     los scripts de las tareas del workflow.
     Devuelve los objetos File que se han creado*/
    
    public ArrayList generarPlantillas(String pathFicheros) throws IOException {
        ArrayList listaFile = new ArrayList();
        for (int i = 0;i<this.listaTareas.size();i++) {
            Tarea tarea = (Tarea)this.listaTareas.get(i);
            
            String plantillaTarea = tarea.generarCodigo();
            
            try {
                File file = new File(pathFicheros+ File.separator +tarea.nombre.replace("(","w").replace(")","x").replace(" ","")+".jt");
                FileWriter out = new FileWriter(file);
                out.write(plantillaTarea);
                out.close();
            } catch (IOException e) {
                System.out.println(e);
                JOptionPane.showMessageDialog(interfaz, "Unexpected error found: "+e.getMessage(),
                        "Error", JOptionPane.ERROR_MESSAGE);
                
                return null;
            }
            listaFile.add(new File(pathFicheros+ File.separator +tarea.nombre.replace("(","w").replace(")","x").replace(" ","")+".jt"));
        }
        
        
        /*Ahora toca el turno a los ficheros de cada tarea*/
        
        for (int i = 0;i< this.listaTareas.size();i++) {
            Tarea tarea = (Tarea) this.listaTareas.get(i);
            
            ArrayList aux = tarea.getFilesForUpload();
            
            for (int j = 0; j<aux.size();j++) {
                listaFile.add(aux.get(j));
            }
            
            
        }
        
        
        return listaFile;
    }
    
    
    
    /*Este método genera los script que lanzarán los trabajos en gridway.
     En este scripts están definidas las dependencias entre tareas.
     */
    
    public boolean dependeDeAlgunaTarea(Tarea tarea) {
        ArrayList lista = this.dependenciasdeTarea(tarea);
        return lista.size() > 0;
    }
    
    
    public ArrayList raices() {
        ArrayList raices = new ArrayList();
        for (int i = 0;i< this.listaTareas.size();i++) {
            Tarea tarea1 = (Tarea)this.listaTareas.get(i);
            
            if (this.dependeDeAlgunaTarea(tarea1) == false) {
                raices.add(tarea1);
            }
        }
        
        return raices;
    }
    
    public ArrayList getRoots() {
        ArrayList raices = this.raices();
        
        ArrayList defaultGraphRoots = new ArrayList();
        
        for (int i = 0;i<raices.size();i++) {
            Tarea aux = (Tarea)raices.get(i);
            defaultGraphRoots.add(this.getDefaultGraphCellFromTaskName(aux.toString()));
        }
        
        return defaultGraphRoots;
    }
    
    
    public ArrayList getTareasDependientes(Tarea tarea) {
        ArrayList lista = this.dependenciasaTarea(tarea);
        
        ArrayList tareas = new ArrayList();
        
        for (int i = 0;i<lista.size();i++) {
            
            Dependencia dep = (Dependencia)lista.get(i);
            Tarea aux = dep.tarea2;
            tareas.add(aux);
        }
        
        return tareas;
    }
    
    public ArrayList getTareasPadre(Tarea tarea) {
        ArrayList lista = this.dependenciasdeTarea(tarea);
        
        ArrayList tareas = new ArrayList();
        
        for (int i = 0;i<lista.size();i++) {
            Dependencia dep = (Dependencia)lista.get(i);
            Tarea aux = dep.tarea1;
            tareas.add(aux);
        }
        
        return tareas;
    }
    
    /*Devuelve la lista con todos los ficheros generados relacionados con gridway,
     scripts y plantillas de trabajo.*/
    public  ArrayList generarScripts(String pathFicheros,String nombreFichero) throws IOException {
        
        String generatedCode = "#!/bin/sh\n\n";
        
        ArrayList tareas_anadidas = new ArrayList();
        ArrayList tareas_para_anadir = new ArrayList();
        
        ArrayList plantillas = this.generarPlantillas(pathFicheros); //Se generan las plantillas de trabajo de las tareas.
        
        ArrayList raices = this.raices(); //Devuelve las tareas raíz, es decir, las que no dependen de ninguna
        
        for (int i = 0;i<raices.size();i++) {
            Tarea tarea = (Tarea)raices.get(i);
            
            ArrayList tareasdependientes = this.getTareasDependientes(tarea);
            
            if (tarea instanceof TareaMultiple == false)
                generatedCode += tarea.nombre.replace(" ","").replace("(","w").replace(")","x")+"_12345"+"=`gwsubmit -v -t  "+tarea.nombre.replace("(","w").replace(")","x")+".jt | cut -f2 -d ':'`";
            else
                generatedCode += tarea.nombre.replace(" ","").replace("(","w").replace(")","x")+"_12345"+"=`gwsubmit -v -t "+tarea.nombre.replace("(","w").replace(")","x")+".jt -n "+
                        ((TareaMultiple)tarea).numeroTareas+"| awk '$1 !~ /ARRAY/ {print}' | awk '$1 !~ /TASK/ {print}' | awk '{print $2}' |sed '/^$/d' | tr '\n' ' ' `";
            
            
            tareas_anadidas.add(tarea);
            generatedCode += "\n";
            
        }
        
        ArrayList tareas = this.listaTareas;
        for (int i = 0;i<tareas.size();i++) {
            Tarea tarea = (Tarea)tareas.get(i);
            
            boolean esta = false;
            
            for (int h = 0;h<tareas_anadidas.size();h++) {
                Tarea task = (Tarea)tareas_anadidas.get(h);
                if (task.nombre.compareTo(tarea.nombre) == 0) {
                    esta = true;
                    break;
                }
            }
            
            if (esta == true)
                continue;
            
            
            
            ArrayList listatareaspadre = this.getTareasPadre(tarea);
            
            
            boolean todoslosPadres = false;
            
            for (int k = 0;k<listatareaspadre.size();k++) {
                Tarea aux2 = (Tarea)listatareaspadre.get(k);
                
                
                todoslosPadres = false;
                for (int l = 0;l<tareas_anadidas.size();l++) {
                    Tarea aux3 = (Tarea)tareas_anadidas.get(l);
                    if (aux3.nombre.compareTo(aux2.nombre) == 0) {
                        todoslosPadres = true;
                        break;
                    }
                }
                
                if (todoslosPadres == false) //Falta un padre por añadir, todavía no se puede generar el código para esta tarea
                {
                    tareas_para_anadir.add(tarea);
                    break;
                }
                
            }
            
            if (todoslosPadres == true) {
                
                
                if (tarea instanceof TareaMultiple == false)
                    generatedCode += tarea.nombre.replace(" ","").replace("(","w").replace(")","x")+"_12345" + "=`gwsubmit -v -t "+tarea.nombre.replace(" ","").replace("(","w").replace(")","x")+".jt -d ";
                
                else
                    generatedCode += tarea.nombre.replace(" ","").replace("(","w").replace(")","x")+"_12345" + "=`gwsubmit -v -t "+tarea.nombre.replace(" ","").replace("(","w").replace(")","x")+".jt -n "+
                            ((TareaMultiple)tarea).numeroTareas +
                            " -d ";
                
                generatedCode += "\"";
                for (int k = 0;k<listatareaspadre.size();k++) {
                    Tarea aux2 = (Tarea) listatareaspadre.get(k);
                    generatedCode += "$"+aux2.nombre.replace(" ","").replace("(","w").replace(")","x")+"_12345"+" ";
                    
                }
                
                generatedCode += "\""; //Comilla del cierre.
                
                if (tarea instanceof TareaMultiple == false)
                    generatedCode += "| cut -f2 -d ':' `";
                else
                    generatedCode += "| awk '$1 !~ /ARRAY/ {print}' | awk '$1 !~ /TASK/ {print}' | awk '{print $2}' |sed '/^$/d' | tr '\n' ' ' `";
                
                tareas_anadidas.add(tarea);
                
            }
            
            generatedCode += "\n";
            
                /*En este punto se comprueba en la lista de tareas_para_anadir que contiene la tareas que no han sido
                 añadidas porque dependen de una tarea que aún no ha sido añadida, si la tarea de la que depende ha sido añadida.
                 En este caso la tarea se añade y se elimina de la lista de tareas para añadir y se añade a la tarea
                 de listas añadidas.*/
            
            
            
        }
        
        for (int j = 0;j<tareas_para_anadir.size();j++) {
            
            Tarea aux = (Tarea)tareas_para_anadir.get(j);
            
            ArrayList listatareaspadre = this.getTareasPadre(aux);
            
            boolean todoslosPadres = false;
            
            for (int k = 0;k<listatareaspadre.size();k++) {
                Tarea aux2 = (Tarea)listatareaspadre.get(k);
                
                
                todoslosPadres = false;
                for (int l = 0;l<tareas_anadidas.size();l++) {
                    Tarea aux3 = (Tarea)tareas_anadidas.get(l);
                    if (aux3.nombre.compareTo(aux2.nombre) == 0) {
                        todoslosPadres = true;
                        break;
                    }
                }
                
                if (todoslosPadres == false) //Falta un padre por añadir, todavía no se puede generar el código para esta tarea
                {
                    break;
                }
                
            }
            
            if (todoslosPadres == true) {
                
                if (aux instanceof TareaMultiple == false)
                    generatedCode += aux.nombre.replace(" ","").replace("(","w").replace(")","x")+"_12345" + "=`gwsubmit -v -t "+aux.nombre.replace("(","w").replace(")","x").replace(" ","")+".jt -d ";
                
                else
                    generatedCode += aux.nombre.replace(" ","").replace("(","w").replace(")","x")+"_12345" + "=`gwsubmit -v -t "+aux.nombre.replace("(","w").replace(")","x").replace(" ","")+".jt -n "+
                            ((TareaMultiple)aux).numeroTareas +
                            " -d ";
                
                generatedCode += "\"";
                for (int k = 0;k<listatareaspadre.size();k++) {
                    Tarea aux2 = (Tarea) listatareaspadre.get(k);
                    generatedCode += "$"+aux2.nombre.replace(" ","").replace("(","w").replace(")","x")+"_12345"+" ";
                    
                }
                generatedCode += "\" ";
                if (aux instanceof TareaMultiple == false)
                    generatedCode += "| cut -f2 -d ':' `";
                else
                    generatedCode += "| awk '$1 !~ /ARRAY/ {print}' | awk '$1 !~ /TASK/ {print}' | awk '{print $2}' |sed '/^$/d' | tr '\n' ' ' `";
                
                generatedCode += "\n";
                
                tareas_anadidas.add(aux); //Se añade a la lista de tareas añadidas.
                
                tareas_para_anadir.remove(aux); //Se elimina de la lista de tareas para añadir.
            }
            
        }
        
        
        
            /*Se vuelve a comprobar de nuevo si las tareas de las que dependian las tareas que no se han
            podido añadir antes ya que no todas sus dependencias estaban añadidas, ahora tienen sus tareas
             añadidas.*/
        for (int j = 0;j<tareas_para_anadir.size();j++) {
            
            Tarea aux = (Tarea)tareas_para_anadir.get(j);
            
            ArrayList listatareaspadre = this.getTareasPadre(aux);
            
            boolean todoslosPadres = false;
            
            for (int k = 0;k<listatareaspadre.size();k++) {
                Tarea aux2 = (Tarea)listatareaspadre.get(k);
                
                
                todoslosPadres = false;
                
                for (int l = 0;l<tareas_anadidas.size();l++) {
                    Tarea aux3 = (Tarea)tareas_anadidas.get(l);
                    if (aux3.nombre.compareTo(aux2.nombre) == 0) {
                        todoslosPadres = true;
                        break;
                    }
                }
                
                if (todoslosPadres == false) //Falta un padre por añadir, todavía no se puede generar el código para esta tarea
                {
                    break;
                }
                
            }
            
            if (todoslosPadres == true) {
                
                if (aux instanceof TareaMultiple == false)
                    generatedCode += aux.nombre.replace(" ","").replace("(","w").replace(")","x")+"_12345" + "=`gwsubmit -v -t "+aux.nombre.replace(" ","").replace("(","w").replace(")","x")+".jt -d ";
                
                else
                    generatedCode += aux.nombre.replace(" ","").replace("(","w").replace(")","x")+"_12345" + "=`gwsubmit -v -t "+aux.nombre.replace(" ","").replace("(","w").replace(")","x")+".jt -n "+
                            ((TareaMultiple)aux).numeroTareas +
                            " -d  ";
                
                generatedCode += "\"";
                for (int k = 0;k<listatareaspadre.size();k++) {
                    Tarea aux2 = (Tarea) listatareaspadre.get(k);
                    generatedCode += "$"+aux2.nombre.replace(" ","").replace("(","w").replace(")","x")+" ";
                    
                }
                generatedCode += "\" ";
                
                if (aux instanceof TareaMultiple == false)
                    generatedCode += "| cut -f2 -d ':' `";
                else
                    generatedCode += "| awk '$1 !~ /ARRAY/ {print}' | awk '$1 !~ /TASK/ {print}' | awk '{print $2}' |sed '/^$/d' | tr '\n' ' ' `";
                
                generatedCode += "\n";
                
                tareas_anadidas.add(aux); //Se añade a la lista de tareas añadidas.
                
                //////////tareas_para_anadir.remove(aux); //Se elimina de la lista de tareas para añadir.
            }
            
        }
        
        
        for (int i = 0;i<tareas_anadidas.size();i++) {
            Tarea aux = (Tarea)tareas_anadidas.get(i);
            generatedCode += "echo $"+aux.toString().replace(" ","").replace("(","w").replace(")","x")+"_12345\n";
        }
        
        /*El script finaliza. El metaplanificador se encargará de realizar todas las acciones necesarias.
         Si se desean acciones adicionales al terminar las tareas como avisar al usuario de que su workflow
         ha terminado su ejecución, puede añadirse al script el comando gwwait, para que el script espere
         a la terminación de las tareas, y a continuación realizar las acciones que se crean convenientes.*/
        
        /**************Se almacena en disco el script generado********************************/
        String filename = null;
        try {
            if (nombreFichero.matches("[A-Za-z0-9]+.sh"))
                filename =pathFicheros+ File.separator +nombreFichero.replace(" ","");
            else
                filename =pathFicheros+ File.separator +nombreFichero.replace(" ","")+".sh";
            
            File file = new File(filename);
            FileWriter out = new FileWriter(file);
            out.write(generatedCode);
            out.close();
            
        } catch (IOException e) {
            System.out.println(e);
            JOptionPane.showMessageDialog(interfaz, "Unexpedted error found: "+e.getMessage(),
                    "Error", JOptionPane.ERROR_MESSAGE);
        }
        
        /*Al final de todo se añade el fichero de script generado en este método para que también sea enviado*/
        if (filename != null)
            plantillas.add(new File(filename));
        
        return plantillas;
    }
    
    
    public void ejecutar() throws SftpException {
       
        interfaz.imprimirMensajeLog("Launching into execution "+this.name+".sh");
        
        final EsperaDialog dialogo_espera = new EsperaDialog(interfaz,true);
        
        if (interfaz.conexion != null && interfaz.conexion.isConnected() == true) {
            
            Thread hilo = new Thread() {
                 String errorlog = null;
                public void run() {
                    dialogo_espera.imprimirMensaje("Sending execution commando to remote server");
                    try {
                        
                        /*TERMINAR*/
                        errorlog = interfaz.conexion.ejecutar(name.replace(" ","")+".sh");
                        if (errorlog == null) {
                            dialogo_espera.setVisible(false);
                            
                            JOptionPane.showMessageDialog(interfaz, "Unexpedted error found!",
                                    "Error", JOptionPane.ERROR_MESSAGE);
                        }
                    } catch (IOException e) {
                        e.printStackTrace(System.err);
                        return;
                    }
                    
                    dialogo_espera.setVisible(false);
                    
                    JOptionPane.showMessageDialog(interfaz, errorlog,
                            "Information", JOptionPane.INFORMATION_MESSAGE);
                    
                    
                }
            };
            
            hilo.start();
            
            dialogo_espera.setVisible(true);
            
        }
        
        
    }
    
    public boolean enviarTrabajo() {
        if (interfaz.conexion == null || interfaz.conexion.isConnected() == false) {
            
            JOptionPane dialog = new JOptionPane();
            String string1 = "Yes";
            String string2 = "No";
            Object[] options = {string1, string2};
            int n = JOptionPane.showOptionDialog(null,
                    "You are disconnected from remote server\n"+
                    "Would you like to connect?",
                    "Caution",
                    JOptionPane.YES_NO_OPTION,
                    JOptionPane.QUESTION_MESSAGE,
                    null,     //don't use a custom Icon
                    options,  //the titles of buttons
                    string2); //the title of the default button
            
            if (n == 1)
                return false;
            
            
            
            SSHConfigurationDialog dialogo_ssh = new SSHConfigurationDialog(this.interfaz,true);
            dialogo_ssh.setVisible(true);
            
            if (dialogo_ssh.aceptar == false)
                return false;
            
            interfaz.conexion = dialogo_ssh.getConexion();
            
        }
        
        RemoteFileDialog dialogo_examinar = null;
        try {
            
            dialogo_examinar = new RemoteFileDialog(interfaz, interfaz.conexion,new Vector(),
                    false,RemoteFileDialog.DIRECTORIES_ONLY);
            
            dialogo_examinar.setVisible(true);
            
        } catch (SftpException ex) {
            ex.printStackTrace();
            
            JOptionPane.showMessageDialog(interfaz, "Unexpected error found: "+ex.toString(),
                    "Error", JOptionPane.ERROR_MESSAGE);
            
            return false;
            
        }
        
        final EsperaDialog dialogo_espera = new EsperaDialog(interfaz,true);
        
        
        if (dialogo_examinar.aceptar == false)
            return false;
        
        final File carpeta_remota = dialogo_examinar.getSelectedFile();
        
        class Thread2 extends Thread  {
            
            public boolean bien = false;
            
            public Thread2() {
            }
            
            public void run() {
                
                
                /*Se creará una carpeta temporal en el directorio actual y luego se borrará, a la hora de generar los scripts*/
                String path =System.getProperty("user.dir")+File.separator+((int)(Math.random()*1000000.0));
                String fileName = name;
                
                ArrayList ficheros_para_enviar = null;
                try {
                    dialogo_espera.imprimirMensaje("Generating scripts... in folder "+ path);
                    
                    if (new File(path).exists() == false)
                        new File(path).mkdirs();
                    
                    ficheros_para_enviar = generarScripts(path,fileName);
                } catch (IOException ex) {
                    ex.printStackTrace();
                    dialogo_espera.setVisible(false);
                    JOptionPane.showMessageDialog(interfaz, ex.toString(),
                            "Error", JOptionPane.ERROR_MESSAGE);
                    
                    File temporal= new File(path);
                    
                    if (temporal.exists()) //Si el directorio temporal existe lo borra junto a todo su contenido
                    {
                        File[] ficherostemp = temporal.listFiles();
                        for (int j = 0;j<ficherostemp.length;j++) //Se vacía el contenido del directorio
                            ficherostemp[j].delete();
                        
                        temporal.delete(); //Una vez vacío el directorio lo borra
                    }
                    
                    
                    
                    return;
                }
                
                
                
                
                
                try {
                    dialogo_espera.imprimirMensaje("Creating folder on server");
                    
                    interfaz.conexion.setDir(carpeta_remota.getPath()); //Establece el directorio remoto seleccionado
                } catch (SftpException ex) {
                    ex.printStackTrace();
                    
                    dialogo_espera.setVisible(false);
                    JOptionPane.showMessageDialog(interfaz, "Unexpected error found: "+ex.toString(),
                            "Error", JOptionPane.ERROR_MESSAGE);
                    
                    
                    return ;
                    
                } //Establece el directorio remoto seleccionado
                
                
                dialogo_espera.imprimirMensaje("Uploading files...");
                /*A continuación comienza a enviar ficheros*/
                if (ficheros_para_enviar != null) {
                    for (int j = 0;j<ficheros_para_enviar.size();j++) {
                        File upfile = (File)ficheros_para_enviar.get(j);
                        int r = 0;
                        
                        dialogo_espera.imprimirMensaje("Uploading file: "+upfile.getName().replace(" ",""));
                        while(interfaz.conexion.enviarFichero(upfile) == false && r < 3)
                            r++;
                        
                        if (r == 3) {
                            dialogo_espera.setVisible(false);
                            JOptionPane.showMessageDialog(interfaz, "Unexpected error while uploading file: " +
                                    ""+upfile.getPath(),
                                    "Error", JOptionPane.ERROR_MESSAGE);
                            
                            
                            File temporal= new File(path);
                            
                            if (temporal.exists()) //Si el directorio temporal existe lo borra junto a todo su contenido
                            {
                                File[] ficherostemp = temporal.listFiles();
                                for (int k = 0;k<ficherostemp.length;k++) //Se vacía el contenido del directorio
                                    ficherostemp[k].delete();
                                
                                temporal.delete(); //Una vez vacío el directorio lo borra
                            }
                            
                            return ;
                        }
                    }
                     
                    dialogo_espera.imprimirMensaje("Removing temporary files...");
                    JOptionPane.showMessageDialog(interfaz, "The uploading finnished successfully",
                            "Success", JOptionPane.INFORMATION_MESSAGE);
                    
                    
                   
                    
                    File temporal= new File(path);
                    if (temporal.exists()) //Si el directorio temporal existe lo borra junto a todo su contenido
                    {
                        File[] ficherostemp = temporal.listFiles();
                        for (int k = 0;k<ficherostemp.length;k++) //Se vacía el contenido del directorio
                            ficherostemp[k].delete();
                        
                        temporal.delete(); //Una vez vacío el directorio lo borra
                        
                        dialogo_espera.setVisible(false);
                    }
                    
                    bien = true; //Al final hace que la variable bien del hilo sea verdadera para indicar al método
                    //que no ha habido problemas en el envío de los ficheros.
                    return;
                    
                    
                } else {
                    
                    JOptionPane.showMessageDialog(interfaz, "Unexpected error found!",
                            "Error", JOptionPane.ERROR_MESSAGE);
                    dialogo_espera.setVisible(false);
                    return;
                }
            }
        };
        
        Thread2 hilo = new Thread2();
        //hilo.start();//Se lanza el hilo que mandará los ficheros al servidor.
        
        hilo.start();
        dialogo_espera.setVisible(true);
        
        return hilo.bien;
    }
    
    
    public ArrayList getFicherosDependientes(Tarea tarea) {
        
        ArrayList dependencias = this.dependenciasaTarea(tarea);
        
        ArrayList ficheros = new ArrayList();
        
        for (int i = 0;i<dependencias.size();i++) {
            Dependencia aux = (Dependencia)dependencias.get(i);
            ArrayList listaficherosdep =  aux.obtieneFicheros();
            
            for (int j = 0;j<listaficherosdep.size();j++) {
                ficheros.add(listaficherosdep.get(j));
            }
            
        }
        
        
        return ficheros;
    }
    
    
    public void actualizarFicheroDependiente(Tarea tarea, Fichero fichero, Fichero nuevofichero) {
        ArrayList dependencias = this.dependenciasaTarea(tarea); //Obtiene las dependencias de la tarea
        
        /*Ahora hay que buscar entre las dependencias por el fichero*/
        
        ArrayList tareasdependientes = this.getTareasDependientes(tarea,fichero);
        
        for (int i = 0;i<tareasdependientes.size();i++) {
            Tarea aux = (Tarea) tareasdependientes.get(i);
            aux.actualizaFicheroEntrada(fichero, nuevofichero,true);
        }
        
        for (int i = 0;i<dependencias.size();i++) {
            Dependencia dep = (Dependencia) dependencias.get(i);
            
            dep.actualizaFicheroDependiente(fichero,nuevofichero);
            
        }
        
        
    }
    
    /*Este método elimina el fichero dependiente: fichero, a una tarea en las tareas que dependen de la
     tarea pasada como parámetro.*/
    public void eliminarFicheroDependiente(Tarea tarea, Fichero fichero) {
        ArrayList dependencias = this.dependenciasaTarea(tarea);
        
        ArrayList tareasdependientes = this.getTareasDependientes(tarea,fichero);
        
        for (int i = 0;i<tareasdependientes.size();i++) {
            Tarea aux = (Tarea) tareasdependientes.get(i);
            aux.eliminaFicheroEntrada(fichero);
        }
        
        for (int i = 0;i<dependencias.size();i++) {
            Dependencia dep = (Dependencia) dependencias.get(i);
            dep.eliminaFicheroDependencia(fichero);
        }
        
        
    }
    
    /*Este método elimina los ficheros dependientes de otra tarea, es decir,
     cuando una tarea que depende de otra edita sus ficheros de entrada y elimina
     uno que era dependiente de otra tarea, este debe eliminarse de las dependencias correspondientes*/
    public void eliminarFicherodeDependencia(Tarea tarea, Fichero fichero) {
        ArrayList dependencias = this.dependenciasdeTarea(tarea);
        
        /////////////////////////////////////////////////////////
        
        for (int i = 0;i<dependencias.size();i++) {
            Dependencia dep = (Dependencia)dependencias.get(i);
            dep.eliminaFicheroDependencia(fichero);
            
            if (dep.hayFicherosDependientes() == false) {
                
                JOptionPane dialog = new JOptionPane();
                String string1 = "Yes";
                String string2 = "No";
                Object[] options = {string1, string2};
                int n = JOptionPane.showOptionDialog(null,
                        tarea.nombre+" has no files with dependencies left "+dep.tarea1.nombre+" Would you like to remove the dep "+dep.nombre+"?",
                        "Caution",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,     //don't use a custom Icon
                        options,  //the titles of buttons
                        string2); //the title of the default button
                
                if (n == 1)
                    return;
                
                
                this.eliminaDependencia(dep.nombre,true);
                
                DefaultEdge aux = this.getDependencia(dep.nombre);
                
                if (aux != null)
                    this.deleteDep(aux,true); //No pregunta para borrar
                
                
            }
        }
        
    }
    
    public DefaultEdge getDependencia(String dep) {
        List lista = this.getCells();
        
        for (int i = 0;i<lista.size();i++) {
            DefaultGraphCell aux = (DefaultGraphCell)lista.get(i);
            if (model.isEdge(aux) == true)
                if (aux.toString().compareTo(dep) == 0)
                    return (DefaultEdge)aux;
        }
        
        return null;
        
        
    }
    
    public ArrayList getTareasDependientes(Tarea tarea, Fichero fichero) {
        ArrayList lista = this.dependenciasaTarea(tarea);
        
        ArrayList tareas = new ArrayList();
        
        for (int i = 0;i<lista.size();i++) {
            
            Dependencia dep = (Dependencia)lista.get(i);
            Tarea aux = dep.tarea2;
            if (aux.contieneFicheroEntrada(fichero) == true && aux.toString().compareTo(tarea.toString()) != 0)
                tareas.add(aux);
        }
        
        return tareas;
        
    }
    
    public boolean existeDependenciaAlFichero(Tarea tarea, Fichero fichero) {
        
        ArrayList ficheros = this.getFicherosDependientes(tarea);
        
        for (int i = 0;i<ficheros.size();i++) {
            Fichero ficherodep = (Fichero) ficheros.get(i);
            if (ficherodep.iguales(fichero) == true)
                return true;
        }
        
        return false;
    }
    
    
    public boolean existeDependenciaDelFichero(Tarea tarea, Fichero fichero) {
        ArrayList dependencias = this.dependenciasdeTarea(tarea);
        
        for (int i = 0;i<dependencias.size();i++) {
            Dependencia dep = (Dependencia)dependencias.get(i);
            if (dep.contieneFichero(fichero) == true)
                return true;
        }
        
        return false;
    }
    
    
    
    public String toString() {
        return this.name;
    }
    
    
    public void setModified() {
        this.modificado = true;
    }
    
    public void deSeleccionarTodos() {
        List lista = this.getCells();
        
        for (int i = 0;i<lista.size();i++) {
            DefaultGraphCell aux = (DefaultGraphCell) lista.get(i);
            if (!(aux instanceof DefaultEdge ) && !(aux instanceof DefaultPort)) {
                this.deSeleccionar(aux,null); //De uno en uno
            }
        }
    }
    
    
    public void deSeleccionar(DefaultGraphCell nodo1, DefaultGraphCell nodo2) {
        Map atributos = new Hashtable();
        Map atributos2 = new Hashtable();
        Map nested = new Hashtable();
        
        if (nodo1 == null)
            return;
        
        Tarea tarea = this.getTarea(nodo1.toString());
        
        if (tarea instanceof TareaMultiple)
            GraphConstants.setGradientColor(atributos,this.color_bulk_job);
        
        else
            GraphConstants.setGradientColor(atributos,this.color_tarea);
        
        
        if (nodo2 != null) {
            tarea = this.getTarea(nodo2.toString());
            if (tarea instanceof TareaMultiple)
                GraphConstants.setGradientColor(atributos2,this.color_bulk_job);
            
            else
                GraphConstants.setGradientColor(atributos2,this.color_tarea);
            
        }
        
        
        
        if (nodo1 != null)
            nested.put(nodo1,atributos);
        
        if (nodo2 != null)
            nested.put(nodo2,atributos2);
        
        this.graph.getGraphLayoutCache().edit(nested,null,null,null);
        
        this.graph.repaint();
        
    }
    
    public void seleccionar(DefaultGraphCell nodo) {
        Map atributos = new Hashtable();
        
        Map nested = new Hashtable();
        
        GraphConstants.setGradientColor(atributos , Color.orange);
        
        nested.put(nodo,atributos);
        
        this.graph.getGraphLayoutCache().edit(nested,null,null,null);
        
    }
    
    public DefaultGraphCell getDefaultGraphCellFromTaskName(String tarea) {
        List lista =  this.getCells();
        
        
        for (int i = 0;i<lista.size();i++) {
            DefaultGraphCell aux = (DefaultGraphCell)lista.get(i);
            
            if (model.isEdge(aux) == false && model.isPort(aux) == false)
                if (aux.toString().compareTo(tarea) == 0)
                    return aux;
        }
        
        return null;
    }
    
    public boolean setName(String nombre, String nombreantiguo, DefaultGraphCell nodo) {
        List lista_deps = this.getEdges(nodo);
        ArrayList nodos_conectados_destino = new ArrayList(); //Almacenará los nodos que son destino de nodo
        ArrayList nodos_conectados_fuente = new ArrayList(); //Almacenará los nodos que son origen de nodo
        
        ArrayList nombres_deps_destino = new ArrayList();
        ArrayList nombres_deps_fuente = new ArrayList();
        
        
        if (this.contieneTarea(nombre) == true && nombreantiguo.compareTo(nombre) != 0) {
            JOptionPane dialog = new JOptionPane();
            
            JOptionPane.showMessageDialog(null, "This task name already exists!", "Error", JOptionPane.ERROR_MESSAGE);
            return false;
        }
        
        for (int i = 0;i< lista_deps.size() ;i++) {
            
            DefaultEdge aux = (DefaultEdge)lista_deps.get(i);
            
            DefaultGraphCell nodo1 = (DefaultGraphCell) model.getParent(aux.getSource());
            
            DefaultGraphCell nodo2 = (DefaultGraphCell) model.getParent(aux.getTarget());
            
            if (nodo1.toString().compareTo(nodo.toString()) == 0) //nodo es el nodo origen
            {
                nodos_conectados_destino.add(nodo2);
                nombres_deps_destino.add(aux.toString());
            }
            
            
            else //Si no es el origen entonces será el destino
            {
                nodos_conectados_fuente.add(nodo1);
                nombres_deps_fuente.add(aux.toString());
            }
        }
        
        
        
        Rectangle2D rect = GraphConstants.getBounds(nodo.getAttributes());
        
        
        
        
        for (int i = 0;i<lista_deps.size();i++) {/*Se eliminan las dependencias de este nodo*/
            
            this.graph.getGraphLayoutCache().remove(new Object[]{lista_deps.get(i)}); //Se eliminan del grafo, no del árbol
            
        }
        
        this.graph.getGraphLayoutCache().remove(new Object[]{nodo});
        
        this.interfaz.treePanel.removeNode(this.name,nodo.toString(),true);
        this.interfaz.treePanel.repaint();
        
        Tarea tarea = this.getTarea(nombreantiguo);
        DefaultGraphCell nuevo = null;
        
        if (tarea instanceof TareaMultiple)
            nuevo = this.createVertex(nombre,rect.getX(),rect.getY(),rect.getWidth(),rect.getHeight(),this.color_bulk_job,true);
        
        else
            nuevo = this.createVertex(nombre,rect.getX(),rect.getY(),rect.getWidth(),rect.getHeight(),this.color_tarea,true);
        
        
        this.graph.getGraphLayoutCache().insert(nuevo); //Inserta el nuevo nodo en la red
        
        
        this.interfaz.treePanel.addObject((DefaultMutableTreeNode) this.interfaz.tree_workflow_actual.getChildAt(0), nuevo.toString(),true); //Se crea en el arbol una tarea con el mismo nombre, previamente se ha eliminado la tarea con el nombre anterior.
        
        this.interfaz.actualizarWorkFlow();
        
        
        //Ahora toca crear las dependencias que se han eliminado antes
        
        
        for (int i = 0;i< nodos_conectados_fuente.size();i++) {
            DefaultGraphCell aux = (DefaultGraphCell) nodos_conectados_fuente.get(i);
            String nombre_dep = (String) nombres_deps_fuente.get(i);
            
            DefaultEdge edge = (DefaultEdge) this.createEdge(nombre_dep,aux,nuevo);
            
            this.graph.getGraphLayoutCache().insert(edge); //Inserta la dependencia
            
            
        }
        
        for (int i = 0;i< nodos_conectados_destino.size();i++) {
            DefaultGraphCell aux = (DefaultGraphCell) nodos_conectados_destino.get(i);
            String nombre_dep = (String) nombres_deps_destino.get(i);
            
            DefaultEdge edge = (DefaultEdge) this.createEdge(nombre_dep,nuevo,aux);
            
            this.graph.getGraphLayoutCache().insert(edge); //Inserta la dependencia
            
            
        }
        
        this.graph.repaint();
        this.interfaz.treePanel.repaint();
        
        return true;
    }
    
    public DefaultGraphCell getGraphCellFromTreeNode(DefaultMutableTreeNode node) {
        List lista_cells = this.getCells();
        
        for (int i = 0;i<lista_cells.size();i++) {
            DefaultGraphCell auxiliar = (DefaultGraphCell) lista_cells.get(i);
            if (auxiliar instanceof DefaultEdge )
                if (lista_cells.get(i).toString().compareTo(node.toString()) == 0)
                    return (DefaultGraphCell)lista_cells.get(i);
            
            if (auxiliar instanceof DefaultGraphCell && !(auxiliar instanceof DefaultPort)) {
                if (lista_cells.get(i).toString().compareTo(node.toString()) == 0)
                    return (DefaultGraphCell)lista_cells.get(i);
                
                
            }
        }
        
        return null;
    }
    
    public List getCells() {
        Object roots[] = (Object[])graph.getRoots();
        List cells = new ArrayList();
        
        Object[] descendientes = graph.getDescendants(roots);
        
        for (int i = 0;i<descendientes.length;i++) {
            cells.add(descendientes[i]);
        }
        
        
        return cells;
    }
    
    public WorkFlow(GUI interfaz,String nombre) {
        
        
        
        this.interfaz = interfaz;
        nodecounter = 0;
        noderealcounter = 0;
        seleccionado = null;
        
        dependencia = null;
        nodo1 = nodo2 = null;
        nodo1seleccionado = false;
        this.workflow_actual = null;
        this.name = nombre;
        this.depcounter = 0;
        this.modificado = false;
        
        // Construct Model and Graph
        model = new DefaultGraphModel();
        graph = new JGraph(model);
        
        // Control-drag should clone selection
        graph.setCloneable(true);
        
                /*
                // Enable edit without final RETURN keystroke
                graph.setInvokesStopCellEditing(true);
                 
                // When over a cell, jump to its default port (we only have one, anyway)
                graph.setJumpToDefaultPort(true);
                 
                // Insert all three cells in one call, so we need an array to store them
                DefaultGraphCell[] cells = new DefaultGraphCell[3];
                 
                 
                // Create Hello Vertex
                cells[0] = createVertex("Hello", 20, 20, 75, 75, new Color(110,90,216), true);
                 
                // Create World Vertex
                cells[1] = createVertex("World", 140, 140, 40, 20, Color.ORANGE, true);
                 
                // Create Edge
                DefaultEdge edge = new DefaultEdge();
                // Fetch the ports from the new vertices, and connect them with the edge
                edge.setSource(cells[0].getChildAt(0));
                edge.setTarget(cells[1].getChildAt(0));
                cells[2] = edge;
                 
                // Set Arrow Style for edge
                int arrow = GraphConstants.ARROW_CLASSIC;
                GraphConstants.setLineEnd(edge.getAttributes(), arrow);
                GraphConstants.setEndFill(edge.getAttributes(), true);
                 
                GraphConstants.setRouting(edge.getAttributes(),GraphConstants.ROUTING_DEFAULT);
                GraphConstants.setBendable(edge.getAttributes(),false);
                 
                 
                // Insert the cells via the cache, so they get selected
                graph.getGraphLayoutCache().insert(cells);
                 
                 **/
        
        
        graph.setConnectable(false);
        graph.setDisconnectable(false);
        graph.setDisconnectOnMove(false);
        
        graph.setEditable(false);
        
        
        graph.setAntiAliased(true);
        
        graph.setGridEnabled(true);
        
        
        graph.addMouseListener(new MouseDemo(this));
        
        graph.getModel().addGraphModelListener(this);
        
        this.listaDeps = new ArrayList();
        
        this.listaTareas = new ArrayList();
    }
    
    
    
    public boolean contieneTarea(String nombreTarea) {
        for (int i = 0;i<listaTareas.size();i++) {
            Tarea aux = (Tarea) listaTareas.get(i);
            
            if (aux.nombre.compareTo(nombreTarea) == 0)
                return true;
        }
        
        return false;
    }
    
    
    
    public boolean contieneTarea(Tarea tarea) {
        int contador = 0;
        for (int i = 0;i<listaTareas.size();i++) {
            Tarea aux = (Tarea) listaTareas.get(i);
            
            if (aux.nombre.compareTo(tarea.nombre) == 0)
                return true;
        }
        
        return false;
    }
    public void anadeTarea(Tarea tarea) {
        if (this.contieneTarea(tarea) == false)
            listaTareas.add(tarea);
    }
    
    public int getDepcounter() {
        return depcounter;
    }
    
    public Tarea getTarea(String nombreTarea) {
        for (int i = 0;i< listaTareas.size();i++) {
            Tarea aux = (Tarea) listaTareas.get(i);
            if (aux.nombre.compareTo(nombreTarea) == 0)
                return aux;
        }
        
        return null;
    }
    
    public Dependencia getDependencyObject(String dependencia) {
        for (int i = 0;i<this.listaDeps.size();i++) {
            Dependencia aux = (Dependencia) this.listaDeps.get(i);
            if (aux.nombre.compareTo(dependencia) == 0)
                return aux;
        }
        
        return null;
    }
    
    
    public  List getEdges(DefaultGraphCell node1) {
        List listEdges = new ArrayList();
        
        
        int numChildren = model.getChildCount(node1);
        
        for (int i = 0; i < numChildren; i++) {
            Object port = model.getChild(node1, i);
            if (model.isPort(port)) {
                Iterator iter = model.edges(port);
                while (iter.hasNext()) {
                    listEdges.add(iter.next());
                }
            }
        }
        
        return listEdges;
        
        
        
    }
    
    
    public boolean existeConexion(DefaultGraphCell nodo1, DefaultGraphCell nodo2) {
        List listEdges = this.getEdges(nodo1);
        DefaultGraphCell aux = null;
        DefaultGraphCell aux2 = null;
        
        for (int i = 0;i<listEdges.size();i++) {
            DefaultEdge edge = (DefaultEdge)listEdges.get(i);
            aux = (DefaultGraphCell) model.getParent(model.getTarget(edge));
            aux2 = (DefaultGraphCell) model.getParent(model.getSource(edge));
            
            if (aux == nodo1 && aux != aux2)
                continue;
            
            if (nodo2 == aux) {
                return true;
            }
            
            if (existeConexion(aux,nodo2) == true)
                return true;
            
            
        }
        
        
        
        
        return false;
    }
    
    
    public  DefaultGraphCell createEdge(String name,DefaultGraphCell node1, DefaultGraphCell node2) {
        
        
        DefaultEdge edge = new DefaultEdge(name);
        // Fetch the ports from the new vertices, and connect them with the edge
        edge.setSource(node1.getChildAt(0));
        edge.setTarget(node2.getChildAt(0));
        int arrow = GraphConstants.ARROW_CLASSIC;
        GraphConstants.setLineEnd(edge.getAttributes(), arrow);
        GraphConstants.setEndFill(edge.getAttributes(), true);
        
        GraphConstants.setRouting(edge.getAttributes(),GraphConstants.ROUTING_DEFAULT);
        GraphConstants.setBendable(edge.getAttributes(),false);
        return edge;
        
    }
    
    
    
    
    private static DefaultGraphCell createVertex(String name, double x,
            double y, double w, double h, Color bg, boolean raised) {
        
        // Create vertex with the given name
        DefaultGraphCell cell = new DefaultGraphCell(name);
        
        
        // Set bounds
        GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double(
                x, y, w, h));
        
        GraphConstants.setResize(cell.getAttributes(),false);
        GraphConstants.setSizeable(cell.getAttributes(),false);
        // Set fill color
        if (bg != null) {
            GraphConstants.setGradientColor(cell.getAttributes(), bg);
            GraphConstants.setOpaque(cell.getAttributes(), true);
            
        }
        
        // Set raised border
        if (raised)
            GraphConstants.setBorder(cell.getAttributes(), BorderFactory
                    .createRaisedBevelBorder());
        else
            // Set black border
            GraphConstants.setBorderColor(cell.getAttributes(), Color.black);
        
        // Add a Floating Port
        cell.addPort();
        
        
        
        return cell;
    }
    
    
    public int ObtenerTipo(DefaultMutableTreeNode tree) {
        
        if (tree.getParent().toString().compareTo("WorkFlows") == 0)
            return this.WORKFLOW;
        else if (tree.getParent().toString().compareTo("Tasks") == 0)
            return this.TAREA;
        else if (tree.getParent().toString().compareTo("Dependencies") == 0)
            return this.DEPENDENCIA;
        
        else if (tree.toString().compareTo("Tasks") == 0|| tree.toString().compareTo("Dependencies") == 0)
            return this.OTHER;
        
        else return -1;
    }
    
    
    public WorkFlow obtenerWorkFlow(DefaultMutableTreeNode tree)
    
    
    {
        
        DefaultMutableTreeNode aux = null;
        
        if (tree == null) return null;
        
        if (tree.getParent() != null && tree.getParent().toString().compareTo("WorkFlows") == 0) //Se ha seleccionado un workflow
            aux = tree;
        
        //Se ha seleccionado dependencias o tareas
        else if (tree.getParent() != null && (tree.getParent().toString().compareTo("Tasks") == 0 || tree.getParent().toString().compareTo("Dependencias") == 0))
            aux = (DefaultMutableTreeNode) tree.getParent().getParent();
        
        else if (tree.getParent() != null && tree.getParent().getParent().toString().compareTo("WorkFlows") == 0 )
            aux = (DefaultMutableTreeNode) tree.getParent(); //Se ha seleccionad un workflow
        
        if (aux == null)
            return null;
        
        for (int i = 0;i<this.interfaz.workflows.size();i++) {
            WorkFlow aux2 = (WorkFlow)this.interfaz.workflows.get(i);
            if (aux.toString().compareTo(aux2.toString()) == 0)
                return aux2;
            
        }
        
        return null;
        
        
    }
    
    
    public void cerrarWorkFlow(boolean withSaved) {
        
        
        DefaultMutableTreeNode aux =  this.interfaz.tree_workflow_actual;
        
        DefaultMutableTreeNode aux2 = null;
        
        
        
        if (aux != null) {
            if (this.ObtenerTipo(aux) == this.WORKFLOW)
                aux2 = aux;
            else if (this.ObtenerTipo(aux) == this.TAREA)
                aux2 = (DefaultMutableTreeNode) aux.getParent();
            
            else if (this.ObtenerTipo(aux) == this.DEPENDENCIA)
                aux2 = (DefaultMutableTreeNode) aux.getParent();
            
            if (aux2.toString().compareTo(this.name) == 0) {
                
                /*Ahora toca eliminar el grafo del arraylist de workloads*/
                
                this.interfaz.treeworkflows.remove(aux2); //Elimina el arbol del árbol de workflows.
                
                this.interfaz.treePanel.removeNode(aux2); // Borra el workflow del arbol
                
                
                this.interfaz.deleteWorkFlowFromWorkFlowList(this.interfaz.workflow_actual); // Se elimina el workflow del arraylist de workflows
                
                this.interfaz.imprimirMensajeLog("Removing WorkFlow: " + aux2.toString());
                
                this.interfaz.workflow_actual = null;
                
                if (this.interfaz.treeworkflows.size() > 0) {
                    this.interfaz.tree_workflow_actual = (DefaultMutableTreeNode) this.interfaz.treeworkflows.get(0);
                    ///////////////////
                    
                    WorkFlow workflow = this.obtenerWorkFlow(this.interfaz.tree_workflow_actual);
                    
                    this.interfaz.workflow_actual = workflow;
                    this.interfaz.borrarTodos(this.graph);
                    this.interfaz.anadirComponentes(workflow.getGraph()); //Añade el objeto jgraph al panel para visualizar
                    
                    
                }
                
                else {
                    this.interfaz.tree_workflow_actual = null;
                    
                    this.workflow_actual = null;
                    
                    this.interfaz.borrarTodos(this.graph);
                    
                    
                    
                    
                    this.interfaz.habilitarBorrarDep(false);
                    this.interfaz.habilitarBorrarTask(false);
                    this.interfaz.habilitarCrearDep(false);
                    this.interfaz.habilitarCrearNuevoWorkFlow(true);
                    this.interfaz.habilitarCrearTarea(false);
                    this.interfaz.habilitarCerrarWorkFlow(false);
                }
            }
            
            
        }
        
        if (withSaved == true)
            this.guardarComoWorkFlow();
        
    }
    
    
    public void deleteTask(DefaultGraphCell cell,boolean preguntar) {
        
        if (preguntar == true) {
            
            JOptionPane dialog = new JOptionPane();
            String string1 = "Yes";
            String string2 = "No";
            Object[] options = {string1, string2};
            int n = JOptionPane.showOptionDialog(null,
                    "Would you like to remove "+cell+"?",
                    "Caution",
                    JOptionPane.YES_NO_OPTION,
                    JOptionPane.QUESTION_MESSAGE,
                    null,     //don't use a custom Icon
                    options,  //the titles of buttons
                    string2); //the title of the default button
            
            if (n == 1)
                return;
        }
        
        this.setModified();
        
        List listaedges = this.getEdges(cell);
        
        for (int i = 0;i<listaedges.size();i++) {
            this.deleteDep((DefaultEdge) listaedges.get(i),true);
        }
        
        
        
        this.interfaz.imprimirMensajeLog("Removed "+cell.toString());
    /*
        for (int i = 0;i<this.interfaz.tree_workflow_actual.getChildAt(0).getChildCount();i++) {
            TreeNode aux = this.interfaz.tree_workflow_actual.getChildAt(0).getChildAt(i);
     
            if (aux.toString().compareTo(cell.toString()) == 0) {
                ((DefaultMutableTreeNode)this.interfaz.tree_workflow_actual.getChildAt(0)).remove(i);
                break;
            }
     
        }*/
        
        this.eliminaTarea(cell.toString()); //Elimina la tarea del arraylist de tareas del workflow
        
        
        this.noderealcounter--;
        
        this.graph.getGraphLayoutCache().remove(new Object[]{cell});
        
        this.interfaz.treePanel.removeNode(this.name,cell.toString(),true);
        this.interfaz.treePanel.repaint();
        
    }
    
    public int getDEPENDENCIA() {
        return DEPENDENCIA;
    }
    
    public boolean existeDependenciaenOtrasTareas(Tarea tarea) {
        ArrayList lista = tarea.ficherosSalida;
        
        for (int i = 0;i< lista.size();i++) {
            Fichero fichero = (Fichero) lista.get(i);
            
            if (this.existeDependenciaAlFichero(tarea,fichero) == true)
                return true;
        }
        
        return false;
    }
    
    
    private void eliminaTarea(String nombreTarea) {
        
        
        for (int i = 0;i<this.listaTareas.size();i++) {
            Tarea aux = (Tarea)this.listaTareas.get(i);
            if (aux.nombre.compareTo(nombreTarea) == 0) {
                
                
                if (this.existeDependenciaenOtrasTareas(aux) == true)
                    
                {
                    
                    JOptionPane dialog = new JOptionPane();
                    String string1 = "Yes";
                    String string2 = "No";
                    Object[] options = {string1, string2};
                    
                    int n = JOptionPane.showOptionDialog(null,
                            "This task has dependencies in another tasks.\n"+
                            "Would you like to remove the files from the other tasks?",
                            "Caution",
                            JOptionPane.YES_NO_OPTION,
                            JOptionPane.QUESTION_MESSAGE,
                            null,     //don't use a custom Icon
                            options,  //the titles of buttons
                            string2); //the title of the default button
                    
                    
                    
                    if (n == 1)
                        return;
                    
                }
                this.listaTareas.remove(i);
                ArrayList ficherosdep = this.getFicherosDependientes(aux);
                
                for (int j = 0;i<ficherosdep.size();j++) {
                    Fichero aux2 = (Fichero)ficherosdep.get(j);
                    this.eliminarFicheroDependiente(aux,aux2);
                }
                
                
                
            }
        }
    }
    
    
    private void eliminaDependencia(String nombreDep, boolean mostrarAdvertencia) {
        
        
        for (int i = 0;i<this.listaDeps.size();i++) {
            Dependencia aux = (Dependencia)this.listaDeps.get(i);
            if (aux.nombre.compareTo(nombreDep) == 0) {
                this.listaDeps.remove(i);
                
                if (aux.hayFicherosDependientes() == true && mostrarAdvertencia == true) {
                    
                    JOptionPane dialog = new JOptionPane();
                    String string1 = "Yes";
                    String string2 = "No";
                    Object[] options = {string1, string2};
                    
                    int n = JOptionPane.showOptionDialog(null,
                            "Would you like to remove files from "+aux.tarea2+" that depend on "+aux.tarea1+"?",
                            "Caution",
                            JOptionPane.YES_NO_OPTION,
                            JOptionPane.QUESTION_MESSAGE,
                            null,     //don't use a custom Icon
                            options,  //the titles of buttons
                            string2); //the title of the default button
                    
                    if (n == 1)
                        return;
                    
                    
                    ArrayList listaficheros = aux.obtieneFicheros();
                    
                /*Se eliminan los ficheros que dependen de la
                tarea origen de la dependencia*/
                    for (int j = 0;j<listaficheros.size();j++)
                        aux.tarea2.eliminaFicheroEntrada((Fichero)listaficheros.get(j));
                    
                    break;
                }
                
            }
        }
        
        
        
    }
    
    public void deleteDep(DefaultEdge edge,boolean fromTask) {
        
        
        
        JOptionPane dialog = new JOptionPane();
        String string1 = "Yes";
        String string2 = "No";
        Object[] options = {string1, string2};
        
        if (fromTask == false) {
            int n = JOptionPane.showOptionDialog(null,
                    "Would you like to remove the dependency?",
                    "Caution",
                    JOptionPane.YES_NO_OPTION,
                    JOptionPane.QUESTION_MESSAGE,
                    null,     //don't use a custom Icon
                    options,  //the titles of buttons
                    string2); //the title of the default button
            
            
            
            
            if (n == 1)
                return;
            
            this.setModified();
            
        }
        
        
        /*
         
        for (int i = 0;i<this.interfaz.tree_workflow_actual.getChildAt(1).getChildCount();i++) {
            TreeNode aux = this.interfaz.tree_workflow_actual.getChildAt(1).getChildAt(i);
            if ( aux.toString().compareTo( edge.toString() ) == 0) {
                ((DefaultMutableTreeNode)this.interfaz.tree_workflow_actual.getChildAt(1)).remove(i);
                break;
            }
         
         
        }
         
         **/
        
        this.setModified();
        
        this.eliminaDependencia(edge.toString(),fromTask); //Elimina la dependencia del arraylist de dependencias.
        
        this.graph.getGraphLayoutCache().remove(new Object[]{edge});
        
        
        this.interfaz.treePanel.removeNode(this.name,edge.toString(),false);
        
        this.interfaz.treePanel.repaint();
        
        this.interfaz.imprimirMensajeLog("Remove dependency:"+edge.toString());
        
        
        
        
    }
    
    public void graphChanged(GraphModelEvent graphModelEvent) {
        System.out.println("Event");
    }
    
    public JGraph getGraph() {
        return this.graph;
    }
    
    public Rectangle2D getTaskPosition(String tarea) {
        DefaultGraphCell nodo = this.getDefaultGraphCellFromTaskName(tarea);
        
        if (nodo != null) {
            Rectangle2D rect = GraphConstants.getBounds(nodo.getAttributes());
            return rect;
        }
        
        return null;
    }
    
    public void crearTareaDefaultGraphCell(Tarea tarea, double x, double y) {
        
        if (tarea == null || tarea.nombre.compareTo("") == 0)
            return;
        
        
        
        DefaultGraphCell nodo = null;
        
        if (tarea instanceof TareaMultiple)
            nodo =  this.createVertex(tarea.nombre,x,y,75,75,this.color_bulk_job,
                    true);
        
        else
            nodo =  this.createVertex(tarea.nombre,x,y,75,75,this.color_tarea,
                    true);
        
        this.graph.getGraphLayoutCache().insert(nodo);
        
        
    }
    
    
    
    
    public void crearTarea(Tarea tarea,double x,double y) {
        if (tarea == null || tarea.nombre.compareTo("") == 0)
            return;
        
        this.nodecounter++;
        this.noderealcounter++;
        DefaultGraphCell nodo = null;
        
        if (tarea instanceof TareaMultiple) {
            nodo = this.createVertex(tarea.nombre,x,y,75,75,new Color(86,202,17),
                    true);
        }
        
        else
            nodo = this.createVertex(tarea.nombre,x,y,75,75,new Color(110,90,216),
                    true);
        
        this.graph.getGraphLayoutCache().insert(nodo);
        
        
        this.anadeTarea(tarea); //Anade la tarea al arraylist de tareas del workflow
        
        
        
        this.noderealcounter++;
    }
    
    public String crearBulkJob() {
        this.bulkcounter++;
        this.noderealcounter++;
        
        
        
        DefaultGraphCell nodo = this.createVertex("Array"+this.bulkcounter,
                20+(this.noderealcounter*80)%(7*80),
                20+(this.noderealcounter/7)*80,
                75,
                75,
                this.color_bulk_job,
                true);
        
        
        this.graph.getGraphLayoutCache().insert(nodo);
        
        
        Tarea nueva_tarea = new TareaMultiple();
        
        nueva_tarea.nombre = nodo.toString();
        
        this.anadeTarea(nueva_tarea); //Anade la tarea al arraylist de tareas del workflow
        
        
        
        this.noderealcounter++;
        
        
        this.setModified();
        return nodo.toString();
    }
    
    public String crearTarea() {
        
        this.nodecounter++;
        this.noderealcounter++;
        
        
        
        DefaultGraphCell nodo = this.createVertex("Task "+this.nodecounter,
                20+(this.noderealcounter*80)%(7*80),
                20+(this.noderealcounter/7)*80,
                75,
                75,
                this.color_tarea,
                true);
        
        
        this.graph.getGraphLayoutCache().insert(nodo);
        
        
        Tarea nueva_tarea = new Tarea();
        
        nueva_tarea.nombre = nodo.toString();
        
        this.anadeTarea(nueva_tarea); //Anade la tarea al arraylist de tareas del workflow
        
        
        
        this.noderealcounter++;
        
        
        this.setModified();
        return nodo.toString();
    }
    
    
    
    
    public String crearDependencia(String tarea1, String tarea2,ArrayList files) {
        if (this.contieneTarea(tarea1) == true && this.contieneTarea(tarea2) == true) {
            if (this.nodo1 != null && this.nodo2 != null) {
                Dependencia dep = null;
                try {
                    dep = new Dependencia("Dep" + (++this.depcounter), this.getTarea(tarea1), this.getTarea(tarea2));
                } catch (URISyntaxException ex) {
                    ex.printStackTrace();
                }
                DefaultEdge edge = (DefaultEdge) this.createEdge("Dep"+this.depcounter,this.nodo1,this.nodo2);
                
                
                for (int i = 0;i<files.size();i++) {
                    dep.anadeFichero((Fichero) files.get(i));
                    Tarea task2 = this.getTarea(tarea2);
                    
                    task2.anadeFicheroEntrada(((Fichero)files.get(i)).convertirDeSalidaAEntrada()); //Convierte el fichero de salida a entrada
                    
                }
                
                
                this.anadeDependencia(dep);
                
                
                
                this.graph.getGraphLayoutCache().insert(edge);
                this.setModified();
                return edge.toString();
            }
            
            
        }
        
        return null;
        
        
    }
    
    public DefaultEdge getDependencia() {
        return dependencia;
    }
    
    public GUI getInterfaz() {
        return interfaz;
    }
    
    
    
    /*Este método devuelve las dependencias asociadas a la tarea, es decir, las dependencias
     cuyo origen está en ficheros de esta tarea*/
    public ArrayList dependenciasaTarea(Tarea tarea) {
        ArrayList dependencias = new ArrayList();
        
        for (int i = 0;i< this.listaDeps.size();i++) {
            Dependencia aux = (Dependencia) this.listaDeps.get(i);
            if (aux.tarea1.toString().compareTo(tarea.toString()) == 0)
                dependencias.add(aux);
        }
        
        return dependencias;
    }
    
        /*Este método devuelve justo lo contrario, devuelve las dependencias en cuyo destino está
         la tarea pasada como parámetro.
         */
    public ArrayList dependenciasdeTarea(Tarea tarea) {
        ArrayList dependencias = new ArrayList();
        
        for (int i = 0;i< this.listaDeps.size();i++) {
            Dependencia aux = (Dependencia) this.listaDeps.get(i);
            if (aux.tarea2.toString().compareTo(tarea.toString()) == 0)
                dependencias.add(aux);
        }
        
        return dependencias;
    }
    
    private int numeroHijosNivelInferior(DefaultGraphCell raiz) {
        
        ArrayList hijos = this.getHijos(raiz);
        
        if (hijos.size() == 0)
            return 1;
        
        int maximo = 0;
        
        for (int i = 0;i<hijos.size();i++) {
            ArrayList aux = this.getHijos(((DefaultGraphCell)hijos.get(i)));
            
            maximo += aux.size();
        }
        
        
        
        return maximo;
        
    }
    public  int numeroHijosMayorNivel(DefaultGraphCell raiz) {
        ArrayList hijos = this.getHijos(raiz);
        
        int maximo = 0;
        
        for (int i = 0;i<hijos.size();i++) {
            maximo += this.numeroHijosMayorNivel((DefaultGraphCell)hijos.get(i));
        }
        
        if (maximo < hijos.size())
            maximo = hijos.size();
        
        return maximo;
        
    }
    
    public ArrayList getHijos(DefaultGraphCell nodo) {
        ArrayList lista = new ArrayList();
        
        
        List aristas = this.getEdges(nodo);
        
        for (int i = 0;i<aristas.size();i++) {
            
            if (model.isEdge(aristas.get(i))) {
                
                DefaultGraphCell hijo = (DefaultGraphCell)model.getParent(model.getTarget(aristas.get(i)));
                
                if (hijo.toString().compareTo(nodo.toString()) != 0)
                    lista.add(model.getParent(model.getTarget(aristas.get(i))));
            }
        }
        
        return lista;
    }
    
    void cambiarPosicion(DefaultGraphCell nodo, int x, int y) {
        
        Map atributos = new Hashtable();
        
        Map nested = new Hashtable();
        
        Rectangle2D rect = GraphConstants.getBounds(nodo.getAttributes());
        
        rect.setRect(x,y,75,75);
        
        GraphConstants.setBounds(atributos,rect);
        
        nested.put(nodo,atributos);
        
        this.graph.getGraphLayoutCache().edit(nested,null,null,null);
    }
    
    public void reordenarGrafo() {
        
        int x_pos = 20;
        int y_pos = 20;
        
        int level = 0;
        int limitex = 20;
        
        ArrayList raices = this.getRoots();
        
        int maximo = 0;
        
        
        for (int i = 0;i<raices.size();i++) {
            
            DefaultGraphCell aux = (DefaultGraphCell) raices.get(i);
            
            maximo = this.numeroHijosMayorNivel(aux)*(75+80);
            
            if (maximo == 0)
                maximo = 75+80;
            
            if (i == 0)
                x_pos += maximo/2 - 75/2;
            else
                x_pos += maximo ;
            
            
            this.cambiarPosicion(aux,x_pos, y_pos);
            
            int hermanos = this.getHijos(aux).size();
            
            
            
            
            reordenarGrafo(aux , 1 , 0 , limitex , x_pos);
            
            limitex += maximo;
        }
        
    }
    
    private void reordenarGrafo(DefaultGraphCell nodo,int level,int numerodehijo,int limitex,int rootx) {
        
        ArrayList hijos = this.getHijos(nodo);
        
        
        int x_pos = limitex + numerodehijo*(75+80) ;
        int y_pos = level*(75+80);
        
        
        for (int i = 0;i<hijos.size();i++) {
            DefaultGraphCell aux = (DefaultGraphCell)hijos.get(i);
            
            this.cambiarPosicion(aux, x_pos, y_pos);
            
            int hermanos = this.getHijos(aux).size();
            
            int x = rootx - hermanos*(80+75)/2;
            
            reordenarGrafo(aux,level+1,i,limitex,rootx);
            x_pos += 75+80;
        }
        
        
        
        
        
    }
    
    public static WorkFlow Cargar(GUI interfaz,String file) {
        WorkFlow abierto = null;
        
        
        
        WorkFlowXMLDoc abrir = new WorkFlowXMLDoc(interfaz,file);
        try {
            
            abrir.Cargar();
            
            abierto = abrir.leerWorkFlow();
            
        } catch (IOException ex) {
            ex.printStackTrace();
            
            
            JOptionPane.showMessageDialog(interfaz, "Unexpected error found: "+ex.getMessage(),
                    "Error", JOptionPane.ERROR_MESSAGE);
            
            
        } catch (JDOMException ex) {
            ex.printStackTrace();
            JOptionPane.showMessageDialog(interfaz, "Unexpected error found: "+ex.getMessage(),
                    "Error", JOptionPane.ERROR_MESSAGE);
        }
        
        //abierto.reordenarGrafo();
        return abierto;
        
    }
    
    public void anadeDependencia(Dependencia dependencia) {
        this.listaDeps.add(dependencia);
    }
    
    public boolean guardarWorkFlow() {
        if (ruta != null) {
            WorkFlowXMLDoc nuevo = new WorkFlowXMLDoc(this.interfaz,this.ruta);
            
            nuevo.anadeWorkFlow(this);
            try {
                nuevo.Guardar();
                this.modificado = false;
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        
        else
            return this.guardarComoWorkFlow();
        
        return false;
    }
    
    
    public boolean guardarComoWorkFlow() {
        
        JFileChooser dialogo_examinar = new JFileChooser();
        
        dialogo_examinar.setDialogTitle("Select location");
        dialogo_examinar.setMultiSelectionEnabled(false); //Posibilidad de seleccionar varios ficheros a la vez
        dialogo_examinar.setDialogType(JFileChooser.SAVE_DIALOG);
        dialogo_examinar.setFileSelectionMode(JFileChooser.FILES_ONLY);
        dialogo_examinar.setCurrentDirectory(new File(System.getProperty("user.dir")));
        int returnVal = dialogo_examinar.showOpenDialog(interfaz);

        
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            
            
            WorkFlowXMLDoc nuevo = new WorkFlowXMLDoc(this.interfaz,dialogo_examinar.getSelectedFile().toString());
            
            nuevo.anadeWorkFlow(this);
            try {
                nuevo.Guardar();
                ruta = dialogo_examinar.getSelectedFile().toString();
                
                this.modificado = false;
                return true;
                
            } catch (IOException ex) {
                ex.printStackTrace();
                
                return false;
            }
        }
        
        return false;
    }
    
    
    
    public Tarea getCopy(Tarea tarea) {
        int i = 1;
        
        if (tarea == null)
            return null;
        
        Tarea copia = null;
        
        while (this.contieneTarea(tarea.nombre+"("+i+")") == true) {
            i++;
        }
        
        
        
        copia = (Tarea) tarea.clone();
        
        copia.nombre = tarea+"("+i+")";
        
        
        return copia;
    }
    
    
    
}
